	.text
	.file	"kem.c"
	.section	.rodata.cst8,"aM",@progbits,8
	.p2align	3               # -- Begin function crypto_kem_keypair
.LCPI0_0:
	.quad	415615                  # 0x6577f
	.section	.rodata.cst4,"aM",@progbits,4
	.p2align	2
.LCPI0_1:
	.long	4294962129              # 0xffffebd1
.LCPI0_2:
	.long	5167                    # 0x142f
.LCPI0_5:
	.long	4294967294              # 0xfffffffe
.LCPI0_6:
	.long	4294967292              # 0xfffffffc
.LCPI0_7:
	.long	1                       # 0x1
	.section	.rodata.cst32,"aM",@progbits,32
	.p2align	5
.LCPI0_3:
	.byte	0                       # 0x0
	.byte	1                       # 0x1
	.byte	4                       # 0x4
	.byte	5                       # 0x5
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	14                      # 0xe
	.byte	15                      # 0xf
	.byte	16                      # 0x10
	.byte	17                      # 0x11
	.byte	20                      # 0x14
	.byte	21                      # 0x15
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	30                      # 0x1e
	.byte	31                      # 0x1f
	.section	.rodata.cst16,"aM",@progbits,16
	.p2align	4
.LCPI0_4:
	.short	62953                   # 0xf5e9
	.short	62953                   # 0xf5e9
	.short	62953                   # 0xf5e9
	.short	62953                   # 0xf5e9
	.short	62953                   # 0xf5e9
	.short	62953                   # 0xf5e9
	.short	62953                   # 0xf5e9
	.short	62953                   # 0xf5e9
.LCPI0_8:
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
.LCPI0_9:
	.byte	0                       # 0x0
	.byte	2                       # 0x2
	.byte	4                       # 0x4
	.byte	6                       # 0x6
	.byte	8                       # 0x8
	.byte	10                      # 0xa
	.byte	12                      # 0xc
	.byte	14                      # 0xe
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.text
	.globl	crypto_kem_keypair
	.p2align	4, 0x90
	.type	crypto_kem_keypair,@function
crypto_kem_keypair:                     # @crypto_kem_keypair
	.cfi_startproc
# %bb.0:
	pushq	%r15
	.cfi_def_cfa_offset 16
	pushq	%r14
	.cfi_def_cfa_offset 24
	pushq	%r13
	.cfi_def_cfa_offset 32
	pushq	%r12
	.cfi_def_cfa_offset 40
	pushq	%rbx
	.cfi_def_cfa_offset 48
	subq	$11200, %rsp            # imm = 0x2BC0
	.cfi_def_cfa_offset 11248
	.cfi_offset %rbx, -48
	.cfi_offset %r12, -40
	.cfi_offset %r13, -32
	.cfi_offset %r14, -24
	.cfi_offset %r15, -16
	movq	%rsi, %r14
	movq	%rdi, %r13
	movl	$32, %esi
	callq	randombytes@PLT
	leaq	aes_nonce(%rip), %rdx
	leaq	864(%rsp), %r15
	movl	$3428, %esi             # imm = 0xD64
	movq	%r15, %rdi
	movq	%r13, %rcx
	callq	crypto_stream_aes256ctr_openssl@PLT
	movq	%r15, %rdi
	movq	%r15, %rsi
	callq	crypto_decode_857xint32_little@PLT
	xorl	%eax, %eax
	vpbroadcastq	.LCPI0_0(%rip), %ymm0 # ymm0 = [415615,415615,415615,415615]
	vpbroadcastd	.LCPI0_1(%rip), %ymm1 # ymm1 = [4294962129,4294962129,4294962129,4294962129,4294962129,4294962129,4294962129,4294962129]
	vpbroadcastd	.LCPI0_2(%rip), %ymm2 # ymm2 = [5167,5167,5167,5167,5167,5167,5167,5167]
	vmovdqa	.LCPI0_4(%rip), %xmm3   # xmm3 = [62953,62953,62953,62953,62953,62953,62953,62953]
	.p2align	4, 0x90
.LBB0_1:                                # =>This Inner Loop Header: Depth=1
	vmovdqu	864(%rsp,%rax,4), %ymm4
	vextracti128	$1, %ymm4, %xmm5
	vpmovzxdq	%xmm5, %ymm5    # ymm5 = xmm5[0],zero,xmm5[1],zero,xmm5[2],zero,xmm5[3],zero
	vpmovzxdq	%xmm4, %ymm6    # ymm6 = xmm4[0],zero,xmm4[1],zero,xmm4[2],zero,xmm4[3],zero
	vpmuludq	%ymm0, %ymm6, %ymm6
	vpmuludq	%ymm0, %ymm5, %ymm5
	vpsrlq	$31, %ymm5, %ymm5
	vpsrlq	$31, %ymm6, %ymm6
	vpshufd	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpshufd	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vinserti128	$1, %xmm5, %ymm6, %ymm5
	vpmulld	%ymm1, %ymm5, %ymm5
	vpaddd	%ymm4, %ymm5, %ymm4
	vextracti128	$1, %ymm4, %xmm5
	vpmovzxdq	%xmm5, %ymm5    # ymm5 = xmm5[0],zero,xmm5[1],zero,xmm5[2],zero,xmm5[3],zero
	vpmovzxdq	%xmm4, %ymm6    # ymm6 = xmm4[0],zero,xmm4[1],zero,xmm4[2],zero,xmm4[3],zero
	vpmuludq	%ymm0, %ymm6, %ymm6
	vpmuludq	%ymm0, %ymm5, %ymm5
	vpsrlq	$31, %ymm5, %ymm5
	vpsrlq	$31, %ymm6, %ymm6
	vpshufd	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpshufd	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vinserti128	$1, %xmm5, %ymm6, %ymm5
	vpmulld	%ymm1, %ymm5, %ymm5
	vpaddd	%ymm1, %ymm4, %ymm4
	vpaddd	%ymm4, %ymm5, %ymm4
	vpsrad	$31, %ymm4, %ymm5
	vpand	%ymm2, %ymm5, %ymm5
	vpaddd	%ymm4, %ymm5, %ymm4
	vpshufb	.LCPI0_3(%rip), %ymm4, %ymm4 # ymm4 = ymm4[0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vpaddw	%xmm3, %xmm4, %xmm4
	vmovdqa	%xmm4, 7744(%rsp,%rax,2)
	addq	$8, %rax
	cmpq	$856, %rax              # imm = 0x358
	jne	.LBB0_1
# %bb.2:
	movl	4288(%rsp), %eax
	imulq	$415615, %rax, %rcx     # imm = 0x6577F
	shrq	$31, %rcx
	imull	$-5167, %ecx, %ecx      # imm = 0xEBD1
	addl	%eax, %ecx
	imulq	$415615, %rcx, %rax     # imm = 0x6577F
	shrq	$31, %rax
	imull	$-5167, %eax, %eax      # imm = 0xEBD1
	leal	(%rax,%rcx), %edx
	addl	$-5167, %edx            # imm = 0xEBD1
                                        # kill: def $ecx killed $ecx killed $rcx def $rcx
	addl	%eax, %ecx
	sarl	$31, %edx
	andl	$5167, %edx             # imm = 0x142F
	leal	(%rdx,%rcx), %eax
	addl	$-7750, %eax            # imm = 0xE1BA
	movw	%ax, 9456(%rsp)
	leaq	4304(%rsp), %r15
	movl	$3428, %esi             # imm = 0xD64
	movq	%r15, %rdi
	vzeroupper
	callq	randombytes@PLT
	movq	%r15, %rdi
	movq	%r15, %rsi
	callq	crypto_decode_857xint32_little@PLT
	vpbroadcastd	.LCPI0_5(%rip), %ymm0 # ymm0 = [4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294]
	vpand	4304(%rsp), %ymm0, %ymm1
	vpand	4336(%rsp), %ymm0, %ymm2
	vpand	4368(%rsp), %ymm0, %ymm3
	vpand	4400(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 864(%rsp)
	vmovdqu	%ymm2, 896(%rsp)
	vmovdqu	%ymm3, 928(%rsp)
	vmovdqu	%ymm4, 960(%rsp)
	vpand	4432(%rsp), %ymm0, %ymm1
	vpand	4464(%rsp), %ymm0, %ymm2
	vpand	4496(%rsp), %ymm0, %ymm3
	vpand	4528(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 992(%rsp)
	vmovdqu	%ymm2, 1024(%rsp)
	vmovdqu	%ymm3, 1056(%rsp)
	vmovdqu	%ymm4, 1088(%rsp)
	vpand	4560(%rsp), %ymm0, %ymm1
	vpand	4592(%rsp), %ymm0, %ymm2
	vpand	4624(%rsp), %ymm0, %ymm3
	vpand	4656(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 1120(%rsp)
	vmovdqu	%ymm2, 1152(%rsp)
	vmovdqu	%ymm3, 1184(%rsp)
	vmovdqu	%ymm4, 1216(%rsp)
	vpand	4688(%rsp), %ymm0, %ymm1
	vpand	4720(%rsp), %ymm0, %ymm2
	vpand	4752(%rsp), %ymm0, %ymm3
	vpand	4784(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 1248(%rsp)
	vmovdqu	%ymm2, 1280(%rsp)
	vmovdqu	%ymm3, 1312(%rsp)
	vmovdqu	%ymm4, 1344(%rsp)
	vpand	4816(%rsp), %ymm0, %ymm1
	vpand	4848(%rsp), %ymm0, %ymm2
	vpand	4880(%rsp), %ymm0, %ymm3
	vpand	4912(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 1376(%rsp)
	vmovdqu	%ymm2, 1408(%rsp)
	vmovdqu	%ymm3, 1440(%rsp)
	vmovdqu	%ymm4, 1472(%rsp)
	vpand	4944(%rsp), %ymm0, %ymm1
	vpand	4976(%rsp), %ymm0, %ymm2
	vpand	5008(%rsp), %ymm0, %ymm3
	vpand	5040(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 1504(%rsp)
	vmovdqu	%ymm2, 1536(%rsp)
	vmovdqu	%ymm3, 1568(%rsp)
	vmovdqu	%ymm4, 1600(%rsp)
	vpand	5072(%rsp), %ymm0, %ymm1
	vpand	5104(%rsp), %ymm0, %ymm2
	vpand	5136(%rsp), %ymm0, %ymm3
	vpand	5168(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 1632(%rsp)
	vmovdqu	%ymm2, 1664(%rsp)
	vmovdqu	%ymm3, 1696(%rsp)
	vmovdqu	%ymm4, 1728(%rsp)
	vpand	5200(%rsp), %ymm0, %ymm1
	vpand	5232(%rsp), %ymm0, %ymm2
	vpand	5264(%rsp), %ymm0, %ymm3
	vpand	5296(%rsp), %ymm0, %ymm0
	vmovdqu	%ymm1, 1760(%rsp)
	vmovdqu	%ymm2, 1792(%rsp)
	vmovdqu	%ymm3, 1824(%rsp)
	vmovdqu	%ymm0, 1856(%rsp)
	movl	5328(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1888(%rsp)
	movl	5332(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1892(%rsp)
	movl	5336(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1896(%rsp)
	movl	5340(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1900(%rsp)
	movl	5344(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1904(%rsp)
	movl	5348(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1908(%rsp)
	movl	5352(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1912(%rsp)
	movl	5356(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1916(%rsp)
	movl	5360(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1920(%rsp)
	movl	5364(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1924(%rsp)
	movl	5368(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1928(%rsp)
	movl	5372(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1932(%rsp)
	movl	5376(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1936(%rsp)
	movl	5380(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1940(%rsp)
	movl	5384(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1944(%rsp)
	movl	5388(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1948(%rsp)
	movl	5392(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1952(%rsp)
	movl	5396(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1956(%rsp)
	movl	5400(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1960(%rsp)
	movl	5404(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1964(%rsp)
	movl	5408(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1968(%rsp)
	movl	5412(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1972(%rsp)
	movl	5416(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1976(%rsp)
	movl	5420(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1980(%rsp)
	movl	5424(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1984(%rsp)
	movl	$305, %eax              # imm = 0x131
	vpbroadcastd	.LCPI0_6(%rip), %ymm0 # ymm0 = [4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292]
	vpbroadcastd	.LCPI0_7(%rip), %ymm1 # ymm1 = [1,1,1,1,1,1,1,1]
	.p2align	4, 0x90
.LBB0_3:                                # =>This Inner Loop Header: Depth=1
	vpand	4208(%rsp,%rax,4), %ymm0, %ymm2
	vpand	4240(%rsp,%rax,4), %ymm0, %ymm3
	vpand	4272(%rsp,%rax,4), %ymm0, %ymm4
	vpand	4304(%rsp,%rax,4), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 768(%rsp,%rax,4)
	vmovdqu	%ymm3, 800(%rsp,%rax,4)
	vmovdqu	%ymm4, 832(%rsp,%rax,4)
	vmovdqu	%ymm5, 864(%rsp,%rax,4)
	addq	$32, %rax
	cmpq	$881, %rax              # imm = 0x371
	jne	.LBB0_3
# %bb.4:
	leaq	864(%rsp), %rdi
	movl	$857, %esi              # imm = 0x359
	vzeroupper
	callq	crypto_sort_uint32_useint32@PLT
	movl	$24, %eax
	vmovdqa	.LCPI0_8(%rip), %xmm0   # xmm0 = [3,3,3,3,3,3,3,3]
	vpcmpeqd	%xmm1, %xmm1, %xmm1
	vmovdqa	.LCPI0_9(%rip), %xmm2   # xmm2 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	vmovdqa	.LCPI0_3(%rip), %ymm7   # ymm7 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	.p2align	4, 0x90
.LBB0_5:                                # =>This Inner Loop Header: Depth=1
	vmovdqu	768(%rsp,%rax,4), %ymm3
	vmovdqu	800(%rsp,%rax,4), %ymm4
	vmovdqu	832(%rsp,%rax,4), %ymm5
	vmovdqu	864(%rsp,%rax,4), %ymm6
	vpshufb	%ymm7, %ymm3, %ymm3
	vpermq	$232, %ymm3, %ymm3      # ymm3 = ymm3[0,2,2,3]
	vpshufb	%ymm7, %ymm4, %ymm4
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vpshufb	%ymm7, %ymm5, %ymm5
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpshufb	%ymm7, %ymm6, %ymm6
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpand	%xmm0, %xmm3, %xmm3
	vpand	%xmm0, %xmm4, %xmm4
	vpand	%xmm0, %xmm5, %xmm5
	vpand	%xmm0, %xmm6, %xmm6
	vpaddb	%xmm1, %xmm3, %xmm3
	vpshufb	%xmm2, %xmm3, %xmm3
	vpaddb	%xmm1, %xmm4, %xmm4
	vpshufb	%xmm2, %xmm4, %xmm4
	vpunpcklqdq	%xmm4, %xmm3, %xmm3 # xmm3 = xmm3[0],xmm4[0]
	vmovdqa	%xmm3, -24(%rsp,%rax)
	vpaddb	%xmm1, %xmm5, %xmm3
	vpshufb	%xmm2, %xmm3, %xmm3
	vpaddb	%xmm1, %xmm6, %xmm4
	vpshufb	%xmm2, %xmm4, %xmm4
	vpunpcklqdq	%xmm4, %xmm3, %xmm3 # xmm3 = xmm3[0],xmm4[0]
	vmovdqa	%xmm3, -8(%rsp,%rax)
	addq	$32, %rax
	cmpq	$856, %rax              # imm = 0x358
	jne	.LBB0_5
# %bb.6:
	movb	4192(%rsp), %al
	movb	4196(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 832(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 833(%rsp)
	movb	4200(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 834(%rsp)
	movb	4204(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 835(%rsp)
	movb	4208(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 836(%rsp)
	movb	4212(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 837(%rsp)
	movb	4216(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 838(%rsp)
	movb	4220(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 839(%rsp)
	movb	4224(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 840(%rsp)
	movb	4228(%rsp), %al
	movb	4232(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 841(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 842(%rsp)
	movb	4236(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 843(%rsp)
	movb	4240(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 844(%rsp)
	movb	4244(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 845(%rsp)
	movb	4248(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 846(%rsp)
	movb	4252(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 847(%rsp)
	movb	4256(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 848(%rsp)
	movb	4260(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 849(%rsp)
	movb	4264(%rsp), %al
	movb	4268(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 850(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 851(%rsp)
	movb	4272(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 852(%rsp)
	movb	4276(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 853(%rsp)
	movb	4280(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 854(%rsp)
	movb	4284(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 855(%rsp)
	movb	4288(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 856(%rsp)
	leaq	864(%rsp), %r15
	leaq	7744(%rsp), %rsi
	movq	%r15, %rdi
	vzeroupper
	callq	crypto_encode_857xint16_little@PLT
	xorl	%ebx, %ebx
	leaq	4304(%rsp), %r12
	movq	%rsp, %rdx
	xorl	%ecx, %ecx
	movq	%r12, %rdi
	movq	%r15, %rsi
	callq	crypto_core_multsntrup857_avx@PLT
	leaq	9472(%rsp), %r15
	movq	%r15, %rdi
	movq	%r12, %rsi
	callq	crypto_decode_857xint16_little@PLT
	leaq	32(%r13), %rdi
	movq	%r15, %rsi
	callq	crypto_encode_857x1723round_ref@PLT
	leaq	215(%r14), %rax
	leaq	1399(%r14), %r15
	leaq	1184(%r13), %rcx
	cmpq	%rcx, %rax
	jae	.LBB0_8
# %bb.7:
	cmpq	%r13, %r15
	ja	.LBB0_9
.LBB0_8:
	vmovups	(%r13), %ymm0
	vmovups	32(%r13), %ymm1
	vmovups	64(%r13), %ymm2
	vmovups	96(%r13), %ymm3
	vmovups	%ymm0, 215(%r14)
	vmovups	%ymm1, 247(%r14)
	vmovups	%ymm2, 279(%r14)
	vmovups	%ymm3, 311(%r14)
	vmovups	128(%r13), %ymm0
	vmovups	160(%r13), %ymm1
	vmovups	192(%r13), %ymm2
	vmovups	224(%r13), %ymm3
	vmovups	%ymm0, 343(%r14)
	vmovups	%ymm1, 375(%r14)
	vmovups	%ymm2, 407(%r14)
	vmovups	%ymm3, 439(%r14)
	vmovups	256(%r13), %ymm0
	vmovups	288(%r13), %ymm1
	vmovups	320(%r13), %ymm2
	vmovups	352(%r13), %ymm3
	vmovups	%ymm0, 471(%r14)
	vmovups	%ymm1, 503(%r14)
	vmovups	%ymm2, 535(%r14)
	vmovups	%ymm3, 567(%r14)
	vmovups	384(%r13), %ymm0
	vmovups	416(%r13), %ymm1
	vmovups	448(%r13), %ymm2
	vmovups	480(%r13), %ymm3
	vmovups	%ymm0, 599(%r14)
	vmovups	%ymm1, 631(%r14)
	vmovups	%ymm2, 663(%r14)
	vmovups	%ymm3, 695(%r14)
	vmovups	512(%r13), %ymm0
	vmovups	544(%r13), %ymm1
	vmovups	576(%r13), %ymm2
	vmovups	608(%r13), %ymm3
	vmovups	%ymm0, 727(%r14)
	vmovups	%ymm1, 759(%r14)
	vmovups	%ymm2, 791(%r14)
	vmovups	%ymm3, 823(%r14)
	vmovups	640(%r13), %ymm0
	vmovups	672(%r13), %ymm1
	vmovups	704(%r13), %ymm2
	vmovups	736(%r13), %ymm3
	vmovups	%ymm0, 855(%r14)
	vmovups	%ymm1, 887(%r14)
	vmovups	%ymm2, 919(%r14)
	vmovups	%ymm3, 951(%r14)
	vmovups	768(%r13), %ymm0
	vmovups	800(%r13), %ymm1
	vmovups	832(%r13), %ymm2
	vmovups	864(%r13), %ymm3
	vmovups	%ymm0, 983(%r14)
	vmovups	%ymm1, 1015(%r14)
	vmovups	%ymm2, 1047(%r14)
	vmovups	%ymm3, 1079(%r14)
	vmovups	896(%r13), %ymm0
	vmovups	928(%r13), %ymm1
	vmovups	960(%r13), %ymm2
	vmovups	992(%r13), %ymm3
	vmovups	%ymm0, 1111(%r14)
	vmovups	%ymm1, 1143(%r14)
	vmovups	%ymm2, 1175(%r14)
	vmovups	%ymm3, 1207(%r14)
	vmovdqu	1024(%r13), %ymm0
	vmovdqu	1056(%r13), %ymm1
	vmovdqu	1088(%r13), %ymm2
	vmovdqu	1120(%r13), %ymm3
	vmovdqu	%ymm0, 1239(%r14)
	vmovdqu	%ymm1, 1271(%r14)
	vmovdqu	%ymm2, 1303(%r14)
	vmovdqu	%ymm3, 1335(%r14)
	movl	$1152, %ebx             # imm = 0x480
	.p2align	4, 0x90
.LBB0_9:                                # =>This Inner Loop Header: Depth=1
	movzbl	(%r13,%rbx), %eax
	movb	%al, 215(%r14,%rbx)
	movzbl	1(%r13,%rbx), %eax
	movb	%al, 216(%r14,%rbx)
	movzbl	2(%r13,%rbx), %eax
	movb	%al, 217(%r14,%rbx)
	movzbl	3(%r13,%rbx), %eax
	movb	%al, 218(%r14,%rbx)
	addq	$4, %rbx
	cmpq	$1184, %rbx             # imm = 0x4A0
	jne	.LBB0_9
# %bb.10:
	leaq	214(%r14), %rsi
	movb	$4, 214(%r14)
	leaq	4304(%rsp), %rdi
	movl	$1185, %edx             # imm = 0x4A1
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	4304(%rsp), %ymm0
	vmovups	%ymm0, 1431(%r14)
	movl	$32, %esi
	movq	%r15, %rdi
	vzeroupper
	callq	randombytes@PLT
	movq	%rsp, %rsi
	movq	%r14, %rdi
	callq	crypto_encode_857x3_ref@PLT
	xorl	%eax, %eax
	addq	$11200, %rsp            # imm = 0x2BC0
	.cfi_def_cfa_offset 48
	popq	%rbx
	.cfi_def_cfa_offset 40
	popq	%r12
	.cfi_def_cfa_offset 32
	popq	%r13
	.cfi_def_cfa_offset 24
	popq	%r14
	.cfi_def_cfa_offset 16
	popq	%r15
	.cfi_def_cfa_offset 8
	retq
.Lfunc_end0:
	.size	crypto_kem_keypair, .Lfunc_end0-crypto_kem_keypair
	.cfi_endproc
                                        # -- End function
	.globl	crypto_kem_enc          # -- Begin function crypto_kem_enc
	.p2align	4, 0x90
	.type	crypto_kem_enc,@function
crypto_kem_enc:                         # @crypto_kem_enc
	.cfi_startproc
# %bb.0:
	pushq	%rbp
	.cfi_def_cfa_offset 16
	pushq	%r15
	.cfi_def_cfa_offset 24
	pushq	%r14
	.cfi_def_cfa_offset 32
	pushq	%r13
	.cfi_def_cfa_offset 40
	pushq	%r12
	.cfi_def_cfa_offset 48
	pushq	%rbx
	.cfi_def_cfa_offset 56
	subq	$2936, %rsp             # imm = 0xB78
	.cfi_def_cfa_offset 2992
	.cfi_offset %rbx, -56
	.cfi_offset %r12, -48
	.cfi_offset %r13, -40
	.cfi_offset %r14, -32
	.cfi_offset %r15, -24
	.cfi_offset %rbp, -16
	movq	%rdx, %r13
	movq	%rsi, %r14
	movq	%rdi, %r12
	leaq	385(%rsp), %rdi
	movl	$1184, %edx             # imm = 0x4A0
	movq	%r13, %rsi
	callq	memcpy@PLT
	movb	$4, 384(%rsp)
	leaq	32(%rsp), %r15
	leaq	384(%rsp), %rsi
	movl	$1185, %edx             # imm = 0x4A1
	movq	%r15, %rdi
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	32(%rsp), %ymm0
	vmovups	%ymm0, (%rsp)
	leaq	96(%rsp), %rbx
	movl	$32, %esi
	movq	%rbx, %rdi
	vzeroupper
	callq	randombytes@PLT
	leaq	128(%rsp), %rbp
	movq	%rbp, %rdi
	movq	%rbx, %rsi
	callq	crypto_decode_256x2_avx@PLT
	leaq	1584(%rsp), %rbx
	movq	%rsp, %r8
	movq	%r12, %rdi
	movq	%rbx, %rsi
	movq	%rbp, %rdx
	movq	%r13, %rcx
	callq	Hide
	leaq	1617(%rsp), %rdi
	movl	$1312, %edx             # imm = 0x520
	movq	%r12, %rsi
	callq	memcpy@PLT
	movb	$1, 1584(%rsp)
	movl	$1345, %edx             # imm = 0x541
	movq	%r15, %rdi
	movq	%rbx, %rsi
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	32(%rsp), %ymm0
	vmovups	%ymm0, (%r14)
	xorl	%eax, %eax
	addq	$2936, %rsp             # imm = 0xB78
	.cfi_def_cfa_offset 56
	popq	%rbx
	.cfi_def_cfa_offset 48
	popq	%r12
	.cfi_def_cfa_offset 40
	popq	%r13
	.cfi_def_cfa_offset 32
	popq	%r14
	.cfi_def_cfa_offset 24
	popq	%r15
	.cfi_def_cfa_offset 16
	popq	%rbp
	.cfi_def_cfa_offset 8
	vzeroupper
	retq
.Lfunc_end1:
	.size	crypto_kem_enc, .Lfunc_end1-crypto_kem_enc
	.cfi_endproc
                                        # -- End function
	.section	.rodata.cst8,"aM",@progbits,8
	.p2align	3               # -- Begin function Hide
.LCPI2_0:
	.quad	415615                  # 0x6577f
	.section	.rodata.cst4,"aM",@progbits,4
	.p2align	2
.LCPI2_1:
	.long	4294962129              # 0xffffebd1
.LCPI2_2:
	.long	5167                    # 0x142f
.LCPI2_5:
	.long	4294967294              # 0xfffffffe
.LCPI2_6:
	.long	4294967292              # 0xfffffffc
.LCPI2_7:
	.long	1                       # 0x1
.LCPI2_10:
	.long	2583                    # 0xa17
.LCPI2_11:
	.long	51                      # 0x33
.LCPI2_12:
	.long	25976                   # 0x6578
.LCPI2_13:
	.long	67108864                # 0x4000000
.LCPI2_14:
	.long	101                     # 0x65
.LCPI2_15:
	.long	262117                  # 0x3ffe5
	.section	.rodata.cst32,"aM",@progbits,32
	.p2align	5
.LCPI2_3:
	.byte	0                       # 0x0
	.byte	1                       # 0x1
	.byte	4                       # 0x4
	.byte	5                       # 0x5
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	14                      # 0xe
	.byte	15                      # 0xf
	.byte	16                      # 0x10
	.byte	17                      # 0x11
	.byte	20                      # 0x14
	.byte	21                      # 0x15
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	30                      # 0x1e
	.byte	31                      # 0x1f
	.section	.rodata.cst16,"aM",@progbits,16
	.p2align	4
.LCPI2_4:
	.short	62953                   # 0xf5e9
	.short	62953                   # 0xf5e9
	.short	62953                   # 0xf5e9
	.short	62953                   # 0xf5e9
	.short	62953                   # 0xf5e9
	.short	62953                   # 0xf5e9
	.short	62953                   # 0xf5e9
	.short	62953                   # 0xf5e9
.LCPI2_8:
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
.LCPI2_9:
	.byte	0                       # 0x0
	.byte	2                       # 0x2
	.byte	4                       # 0x4
	.byte	6                       # 0x6
	.byte	8                       # 0x8
	.byte	10                      # 0xa
	.byte	12                      # 0xc
	.byte	14                      # 0xe
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.text
	.p2align	4, 0x90
	.type	Hide,@function
Hide:                                   # @Hide
	.cfi_startproc
# %bb.0:
	pushq	%rbp
	.cfi_def_cfa_offset 16
	pushq	%r15
	.cfi_def_cfa_offset 24
	pushq	%r14
	.cfi_def_cfa_offset 32
	pushq	%r13
	.cfi_def_cfa_offset 40
	pushq	%r12
	.cfi_def_cfa_offset 48
	pushq	%rbx
	.cfi_def_cfa_offset 56
	subq	$16584, %rsp            # imm = 0x40C8
	.cfi_def_cfa_offset 16640
	.cfi_offset %rbx, -56
	.cfi_offset %r12, -48
	.cfi_offset %r13, -40
	.cfi_offset %r14, -32
	.cfi_offset %r15, -24
	.cfi_offset %rbp, -16
	movq	%r8, (%rsp)             # 8-byte Spill
	movq	%rcx, %r13
	movq	%rdx, %rbx
	movq	%rsi, %r12
	movq	%rdi, 8(%rsp)           # 8-byte Spill
	addq	$1, %r12
	movq	%r12, %rdi
	movq	%rdx, %rsi
	callq	crypto_encode_256x2_avx@PLT
	leaq	32(%r13), %rsi
	leaq	14864(%rsp), %rdi
	callq	crypto_decode_857x1723_avx@PLT
	leaq	aes_nonce(%rip), %rdx
	leaq	1072(%rsp), %rbp
	movl	$3428, %esi             # imm = 0xD64
	movq	%rbp, %rdi
	movq	%r13, %rcx
	callq	crypto_stream_aes256ctr_openssl@PLT
	movq	%rbp, %rdi
	movq	%rbp, %rsi
	callq	crypto_decode_857xint32_little@PLT
	xorl	%eax, %eax
	vpbroadcastq	.LCPI2_0(%rip), %ymm0 # ymm0 = [415615,415615,415615,415615]
	vpbroadcastd	.LCPI2_1(%rip), %ymm6 # ymm6 = [4294962129,4294962129,4294962129,4294962129,4294962129,4294962129,4294962129,4294962129]
	vpbroadcastd	.LCPI2_2(%rip), %ymm1 # ymm1 = [5167,5167,5167,5167,5167,5167,5167,5167]
	vmovdqa	.LCPI2_4(%rip), %xmm2   # xmm2 = [62953,62953,62953,62953,62953,62953,62953,62953]
	.p2align	4, 0x90
.LBB2_1:                                # =>This Inner Loop Header: Depth=1
	vmovdqu	1072(%rsp,%rax,4), %ymm3
	vextracti128	$1, %ymm3, %xmm4
	vpmovzxdq	%xmm4, %ymm4    # ymm4 = xmm4[0],zero,xmm4[1],zero,xmm4[2],zero,xmm4[3],zero
	vpmovzxdq	%xmm3, %ymm5    # ymm5 = xmm3[0],zero,xmm3[1],zero,xmm3[2],zero,xmm3[3],zero
	vpmuludq	%ymm0, %ymm5, %ymm5
	vpmuludq	%ymm0, %ymm4, %ymm4
	vpsrlq	$31, %ymm4, %ymm4
	vpsrlq	$31, %ymm5, %ymm5
	vpshufd	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpshufd	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vinserti128	$1, %xmm4, %ymm5, %ymm4
	vpmulld	%ymm6, %ymm4, %ymm4
	vpaddd	%ymm3, %ymm4, %ymm3
	vextracti128	$1, %ymm3, %xmm4
	vpmovzxdq	%xmm4, %ymm4    # ymm4 = xmm4[0],zero,xmm4[1],zero,xmm4[2],zero,xmm4[3],zero
	vpmovzxdq	%xmm3, %ymm5    # ymm5 = xmm3[0],zero,xmm3[1],zero,xmm3[2],zero,xmm3[3],zero
	vpmuludq	%ymm0, %ymm5, %ymm5
	vpmuludq	%ymm0, %ymm4, %ymm4
	vpsrlq	$31, %ymm4, %ymm4
	vpsrlq	$31, %ymm5, %ymm5
	vpshufd	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpshufd	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vinserti128	$1, %xmm4, %ymm5, %ymm4
	vpmulld	%ymm6, %ymm4, %ymm4
	vpaddd	%ymm6, %ymm3, %ymm3
	vpaddd	%ymm3, %ymm4, %ymm3
	vpsrad	$31, %ymm3, %ymm4
	vpand	%ymm1, %ymm4, %ymm4
	vpaddd	%ymm3, %ymm4, %ymm3
	vpshufb	.LCPI2_3(%rip), %ymm3, %ymm3 # ymm3 = ymm3[0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	vpermq	$232, %ymm3, %ymm3      # ymm3 = ymm3[0,2,2,3]
	vpaddw	%xmm2, %xmm3, %xmm3
	vmovdqa	%xmm3, 11408(%rsp,%rax,2)
	addq	$8, %rax
	cmpq	$856, %rax              # imm = 0x358
	jne	.LBB2_1
# %bb.2:
	vmovdqu	%ymm6, 64(%rsp)         # 32-byte Spill
	movl	4496(%rsp), %eax
	imulq	$415615, %rax, %rcx     # imm = 0x6577F
	shrq	$31, %rcx
	imull	$-5167, %ecx, %ecx      # imm = 0xEBD1
	addl	%eax, %ecx
	imulq	$415615, %rcx, %rax     # imm = 0x6577F
	shrq	$31, %rax
	imull	$-5167, %eax, %eax      # imm = 0xEBD1
	leal	(%rax,%rcx), %edx
	addl	$-5167, %edx            # imm = 0xEBD1
                                        # kill: def $ecx killed $ecx killed $rcx def $rcx
	addl	%eax, %ecx
	sarl	$31, %edx
	andl	$5167, %edx             # imm = 0x142F
	leal	(%rdx,%rcx), %eax
	addl	$-7750, %eax            # imm = 0xE1BA
	movw	%ax, 13120(%rsp)
	leaq	17(%rsp), %rdi
	movq	%rbx, %rsi
	vzeroupper
	callq	crypto_encode_256x2_avx@PLT
	movb	$5, 16(%rsp)
	leaq	144(%rsp), %rdi
	leaq	16(%rsp), %rsi
	movl	$33, %edx
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	144(%rsp), %ymm0
	vmovups	%ymm0, 112(%rsp)
	leaq	aes_nonce(%rip), %rdx
	leaq	4512(%rsp), %rbp
	leaq	112(%rsp), %rcx
	movl	$3428, %esi             # imm = 0xD64
	movq	%rbp, %rdi
	vzeroupper
	callq	crypto_stream_aes256ctr_openssl@PLT
	movq	%rbp, %rdi
	movq	%rbp, %rsi
	callq	crypto_decode_857xint32_little@PLT
	vpbroadcastd	.LCPI2_5(%rip), %ymm0 # ymm0 = [4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294]
	vpand	4512(%rsp), %ymm0, %ymm1
	vpand	4544(%rsp), %ymm0, %ymm2
	vpand	4576(%rsp), %ymm0, %ymm3
	vpand	4608(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 1072(%rsp)
	vmovdqu	%ymm2, 1104(%rsp)
	vmovdqu	%ymm3, 1136(%rsp)
	vmovdqu	%ymm4, 1168(%rsp)
	vpand	4640(%rsp), %ymm0, %ymm1
	vpand	4672(%rsp), %ymm0, %ymm2
	vpand	4704(%rsp), %ymm0, %ymm3
	vpand	4736(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 1200(%rsp)
	vmovdqu	%ymm2, 1232(%rsp)
	vmovdqu	%ymm3, 1264(%rsp)
	vmovdqu	%ymm4, 1296(%rsp)
	vpand	4768(%rsp), %ymm0, %ymm1
	vpand	4800(%rsp), %ymm0, %ymm2
	vpand	4832(%rsp), %ymm0, %ymm3
	vpand	4864(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 1328(%rsp)
	vmovdqu	%ymm2, 1360(%rsp)
	vmovdqu	%ymm3, 1392(%rsp)
	vmovdqu	%ymm4, 1424(%rsp)
	vpand	4896(%rsp), %ymm0, %ymm1
	vpand	4928(%rsp), %ymm0, %ymm2
	vpand	4960(%rsp), %ymm0, %ymm3
	vpand	4992(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 1456(%rsp)
	vmovdqu	%ymm2, 1488(%rsp)
	vmovdqu	%ymm3, 1520(%rsp)
	vmovdqu	%ymm4, 1552(%rsp)
	vpand	5024(%rsp), %ymm0, %ymm1
	vpand	5056(%rsp), %ymm0, %ymm2
	vpand	5088(%rsp), %ymm0, %ymm3
	vpand	5120(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 1584(%rsp)
	vmovdqu	%ymm2, 1616(%rsp)
	vmovdqu	%ymm3, 1648(%rsp)
	vmovdqu	%ymm4, 1680(%rsp)
	vpand	5152(%rsp), %ymm0, %ymm1
	vpand	5184(%rsp), %ymm0, %ymm2
	vpand	5216(%rsp), %ymm0, %ymm3
	vpand	5248(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 1712(%rsp)
	vmovdqu	%ymm2, 1744(%rsp)
	vmovdqu	%ymm3, 1776(%rsp)
	vmovdqu	%ymm4, 1808(%rsp)
	vpand	5280(%rsp), %ymm0, %ymm1
	vpand	5312(%rsp), %ymm0, %ymm2
	vpand	5344(%rsp), %ymm0, %ymm3
	vpand	5376(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 1840(%rsp)
	vmovdqu	%ymm2, 1872(%rsp)
	vmovdqu	%ymm3, 1904(%rsp)
	vmovdqu	%ymm4, 1936(%rsp)
	vpand	5408(%rsp), %ymm0, %ymm1
	vpand	5440(%rsp), %ymm0, %ymm2
	vpand	5472(%rsp), %ymm0, %ymm3
	vpand	5504(%rsp), %ymm0, %ymm0
	vmovdqu	%ymm1, 1968(%rsp)
	vmovdqu	%ymm2, 2000(%rsp)
	vmovdqu	%ymm3, 2032(%rsp)
	vmovdqu	%ymm0, 2064(%rsp)
	movl	5536(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2096(%rsp)
	movl	5540(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2100(%rsp)
	movl	5544(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2104(%rsp)
	movl	5548(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2108(%rsp)
	movl	5552(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2112(%rsp)
	movl	5556(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2116(%rsp)
	movl	5560(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2120(%rsp)
	movl	5564(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2124(%rsp)
	movl	5568(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2128(%rsp)
	movl	5572(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2132(%rsp)
	movl	5576(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2136(%rsp)
	movl	5580(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2140(%rsp)
	movl	5584(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2144(%rsp)
	movl	5588(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2148(%rsp)
	movl	5592(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2152(%rsp)
	movl	5596(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2156(%rsp)
	movl	5600(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2160(%rsp)
	movl	5604(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2164(%rsp)
	movl	5608(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2168(%rsp)
	movl	5612(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2172(%rsp)
	movl	5616(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2176(%rsp)
	movl	5620(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2180(%rsp)
	movl	5624(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2184(%rsp)
	movl	5628(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2188(%rsp)
	movl	5632(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 2192(%rsp)
	movl	$305, %eax              # imm = 0x131
	vpbroadcastd	.LCPI2_6(%rip), %ymm0 # ymm0 = [4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292]
	vpbroadcastd	.LCPI2_7(%rip), %ymm1 # ymm1 = [1,1,1,1,1,1,1,1]
	.p2align	4, 0x90
.LBB2_3:                                # =>This Inner Loop Header: Depth=1
	vpand	4416(%rsp,%rax,4), %ymm0, %ymm2
	vpand	4448(%rsp,%rax,4), %ymm0, %ymm3
	vpand	4480(%rsp,%rax,4), %ymm0, %ymm4
	vpand	4512(%rsp,%rax,4), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 976(%rsp,%rax,4)
	vmovdqu	%ymm3, 1008(%rsp,%rax,4)
	vmovdqu	%ymm4, 1040(%rsp,%rax,4)
	vmovdqu	%ymm5, 1072(%rsp,%rax,4)
	addq	$32, %rax
	cmpq	$881, %rax              # imm = 0x371
	jne	.LBB2_3
# %bb.4:
	leaq	1072(%rsp), %rdi
	movl	$857, %esi              # imm = 0x359
	vzeroupper
	callq	crypto_sort_uint32_useint32@PLT
	movl	$24, %eax
	vmovdqa	.LCPI2_8(%rip), %xmm0   # xmm0 = [3,3,3,3,3,3,3,3]
	vpcmpeqd	%xmm1, %xmm1, %xmm1
	vmovdqa	.LCPI2_9(%rip), %xmm7   # xmm7 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	vmovdqa	.LCPI2_3(%rip), %ymm6   # ymm6 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	.p2align	4, 0x90
.LBB2_5:                                # =>This Inner Loop Header: Depth=1
	vmovdqu	976(%rsp,%rax,4), %ymm2
	vmovdqu	1008(%rsp,%rax,4), %ymm3
	vmovdqu	1040(%rsp,%rax,4), %ymm4
	vmovdqu	1072(%rsp,%rax,4), %ymm5
	vpshufb	%ymm6, %ymm2, %ymm2
	vpermq	$232, %ymm2, %ymm2      # ymm2 = ymm2[0,2,2,3]
	vpshufb	%ymm6, %ymm3, %ymm3
	vpermq	$232, %ymm3, %ymm3      # ymm3 = ymm3[0,2,2,3]
	vpshufb	%ymm6, %ymm4, %ymm4
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vpshufb	%ymm6, %ymm5, %ymm5
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpand	%xmm0, %xmm2, %xmm2
	vpand	%xmm0, %xmm3, %xmm3
	vpand	%xmm0, %xmm4, %xmm4
	vpand	%xmm0, %xmm5, %xmm5
	vpaddb	%xmm1, %xmm2, %xmm2
	vpshufb	%xmm7, %xmm2, %xmm2
	vpaddb	%xmm1, %xmm3, %xmm3
	vpshufb	%xmm7, %xmm3, %xmm3
	vpunpcklqdq	%xmm3, %xmm2, %xmm2 # xmm2 = xmm2[0],xmm3[0]
	vmovdqa	%xmm2, 184(%rsp,%rax)
	vpaddb	%xmm1, %xmm4, %xmm2
	vpshufb	%xmm7, %xmm2, %xmm2
	vpaddb	%xmm1, %xmm5, %xmm3
	vpshufb	%xmm7, %xmm3, %xmm3
	vpunpcklqdq	%xmm3, %xmm2, %xmm2 # xmm2 = xmm2[0],xmm3[0]
	vmovdqa	%xmm2, 200(%rsp,%rax)
	addq	$32, %rax
	cmpq	$856, %rax              # imm = 0x358
	jne	.LBB2_5
# %bb.6:
	movb	4400(%rsp), %al
	movb	4404(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1040(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 1041(%rsp)
	movb	4408(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1042(%rsp)
	movb	4412(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1043(%rsp)
	movb	4416(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1044(%rsp)
	movb	4420(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1045(%rsp)
	movb	4424(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1046(%rsp)
	movb	4428(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1047(%rsp)
	movb	4432(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1048(%rsp)
	movb	4436(%rsp), %al
	movb	4440(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1049(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 1050(%rsp)
	movb	4444(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1051(%rsp)
	movb	4448(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1052(%rsp)
	movb	4452(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1053(%rsp)
	movb	4456(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1054(%rsp)
	movb	4460(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1055(%rsp)
	movb	4464(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1056(%rsp)
	movb	4468(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1057(%rsp)
	movb	4472(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1058(%rsp)
	movb	4476(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1059(%rsp)
	movb	4480(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1060(%rsp)
	movb	4484(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1061(%rsp)
	movb	4488(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1062(%rsp)
	movb	4492(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1063(%rsp)
	movb	4496(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 1064(%rsp)
	leaq	7952(%rsp), %r13
	leaq	11408(%rsp), %rsi
	movq	%r13, %rdi
	vzeroupper
	callq	crypto_encode_857xint16_little@PLT
	xorl	%r15d, %r15d
	leaq	1072(%rsp), %rbp
	leaq	208(%rsp), %r14
	xorl	%ecx, %ecx
	movq	%rbp, %rdi
	movq	%r13, %rsi
	movq	%r14, %rdx
	callq	crypto_core_multsntrup857_avx@PLT
	leaq	13136(%rsp), %rdi
	movq	%rbp, %rsi
	callq	crypto_decode_857xint16_little@PLT
	leaq	14864(%rsp), %rsi
	movq	%r13, %rdi
	callq	crypto_encode_857xint16_little@PLT
	xorl	%ecx, %ecx
	movq	%rbp, %rdi
	movq	%r13, %rsi
	movq	%r14, %rdx
	callq	crypto_core_multsntrup857_avx@PLT
	leaq	9680(%rsp), %rdi
	movq	%rbp, %rsi
	callq	crypto_decode_857xint16_little@PLT
	vmovdqa	.LCPI2_9(%rip), %xmm12  # xmm12 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	vmovdqa	.LCPI2_3(%rip), %ymm11  # ymm11 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	vpbroadcastd	.LCPI2_10(%rip), %ymm0 # ymm0 = [2583,2583,2583,2583,2583,2583,2583,2583]
	vpbroadcastd	.LCPI2_11(%rip), %ymm1 # ymm1 = [51,51,51,51,51,51,51,51]
	vpbroadcastd	.LCPI2_12(%rip), %ymm2 # ymm2 = [25976,25976,25976,25976,25976,25976,25976,25976]
	vpbroadcastd	.LCPI2_13(%rip), %ymm3 # ymm3 = [67108864,67108864,67108864,67108864,67108864,67108864,67108864,67108864]
	vpbroadcastd	.LCPI2_14(%rip), %ymm4 # ymm4 = [101,101,101,101,101,101,101,101]
	vpbroadcastd	.LCPI2_15(%rip), %ymm5 # ymm5 = [262117,262117,262117,262117,262117,262117,262117,262117]
	vmovdqu	64(%rsp), %ymm10        # 32-byte Reload
	.p2align	4, 0x90
.LBB2_7:                                # =>This Inner Loop Header: Depth=1
	vpmovsxwd	9680(%rsp,%r15,2), %ymm6
	vpmovsxwd	9696(%rsp,%r15,2), %ymm7
	vpmovsxbd	8(%rbx,%r15), %ymm8
	vpmovsxbd	(%rbx,%r15), %ymm9
	vpmulld	%ymm0, %ymm9, %ymm9
	vpaddd	%ymm6, %ymm9, %ymm6
	vpmulld	%ymm0, %ymm8, %ymm8
	vpaddd	%ymm7, %ymm8, %ymm7
	vpmulld	%ymm1, %ymm6, %ymm8
	vpmulld	%ymm1, %ymm7, %ymm9
	vpsrad	$18, %ymm9, %ymm9
	vpsrad	$18, %ymm8, %ymm8
	vpmulld	%ymm10, %ymm8, %ymm8
	vpmulld	%ymm10, %ymm9, %ymm9
	vpaddd	%ymm7, %ymm9, %ymm7
	vpaddd	%ymm6, %ymm8, %ymm6
	vpmulld	%ymm2, %ymm6, %ymm8
	vpmulld	%ymm2, %ymm7, %ymm9
	vpaddd	%ymm3, %ymm9, %ymm9
	vpaddd	%ymm3, %ymm8, %ymm8
	vpsrad	$27, %ymm8, %ymm8
	vpsrad	$27, %ymm9, %ymm9
	vpmulld	%ymm10, %ymm9, %ymm9
	vpmulld	%ymm10, %ymm8, %ymm8
	vpaddd	%ymm6, %ymm8, %ymm6
	vpaddd	%ymm7, %ymm9, %ymm7
	vpslld	$16, %ymm7, %ymm7
	vpsrad	$16, %ymm7, %ymm7
	vpslld	$16, %ymm6, %ymm6
	vpsrad	$16, %ymm6, %ymm6
	vpmulld	%ymm4, %ymm6, %ymm6
	vpmulld	%ymm4, %ymm7, %ymm7
	vpaddd	%ymm5, %ymm7, %ymm7
	vpaddd	%ymm5, %ymm6, %ymm6
	vpsrld	$15, %ymm6, %ymm6
	vpsrld	$15, %ymm7, %ymm7
	vpshufb	%ymm11, %ymm7, %ymm7
	vpermq	$232, %ymm7, %ymm7      # ymm7 = ymm7[0,2,2,3]
	vpshufb	%xmm12, %xmm7, %xmm7
	vpshufb	%ymm11, %ymm6, %ymm6
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpshufb	%xmm12, %xmm6, %xmm6
	vpunpcklqdq	%xmm7, %xmm6, %xmm6 # xmm6 = xmm6[0],xmm7[0]
	vmovdqa	%xmm6, 1072(%rsp,%r15)
	addq	$16, %r15
	cmpq	$256, %r15              # imm = 0x100
	jne	.LBB2_7
# %bb.8:
	leaq	13136(%rsp), %rsi
	movq	8(%rsp), %rbx           # 8-byte Reload
	movq	%rbx, %rdi
	vzeroupper
	callq	crypto_encode_857x1723round_ref@PLT
	leaq	1152(%rbx), %rdi
	leaq	1072(%rsp), %rsi
	callq	crypto_encode_256x16_ref@PLT
	vmovups	(%r12), %ymm0
	vmovups	%ymm0, 7953(%rsp)
	movq	(%rsp), %rax            # 8-byte Reload
	vmovups	(%rax), %ymm0
	vmovups	%ymm0, 7985(%rsp)
	movb	$2, 7952(%rsp)
	leaq	144(%rsp), %rdi
	leaq	7952(%rsp), %rsi
	movl	$65, %edx
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	144(%rsp), %ymm0
	vmovups	%ymm0, 1280(%rbx)
	addq	$16584, %rsp            # imm = 0x40C8
	.cfi_def_cfa_offset 56
	popq	%rbx
	.cfi_def_cfa_offset 48
	popq	%r12
	.cfi_def_cfa_offset 40
	popq	%r13
	.cfi_def_cfa_offset 32
	popq	%r14
	.cfi_def_cfa_offset 24
	popq	%r15
	.cfi_def_cfa_offset 16
	popq	%rbp
	.cfi_def_cfa_offset 8
	vzeroupper
	retq
.Lfunc_end2:
	.size	Hide, .Lfunc_end2-Hide
	.cfi_endproc
                                        # -- End function
	.section	.rodata.cst4,"aM",@progbits,4
	.p2align	2               # -- Begin function crypto_kem_dec
.LCPI3_0:
	.long	324                     # 0x144
.LCPI3_1:
	.long	4294965031              # 0xfffff727
.LCPI3_2:
	.long	51                      # 0x33
.LCPI3_3:
	.long	4294962129              # 0xffffebd1
.LCPI3_4:
	.long	25976                   # 0x6578
.LCPI3_5:
	.long	67108864                # 0x4000000
.LCPI3_6:
	.long	1125                    # 0x465
	.section	.rodata.cst32,"aM",@progbits,32
	.p2align	5
.LCPI3_7:
	.byte	0                       # 0x0
	.byte	1                       # 0x1
	.byte	4                       # 0x4
	.byte	5                       # 0x5
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	14                      # 0xe
	.byte	15                      # 0xf
	.byte	16                      # 0x10
	.byte	17                      # 0x11
	.byte	20                      # 0x14
	.byte	21                      # 0x15
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	30                      # 0x1e
	.byte	31                      # 0x1f
	.text
	.globl	crypto_kem_dec
	.p2align	4, 0x90
	.type	crypto_kem_dec,@function
crypto_kem_dec:                         # @crypto_kem_dec
	.cfi_startproc
# %bb.0:
	pushq	%rbp
	.cfi_def_cfa_offset 16
	pushq	%r15
	.cfi_def_cfa_offset 24
	pushq	%r14
	.cfi_def_cfa_offset 32
	pushq	%r13
	.cfi_def_cfa_offset 40
	pushq	%r12
	.cfi_def_cfa_offset 48
	pushq	%rbx
	.cfi_def_cfa_offset 56
	subq	$8360, %rsp             # imm = 0x20A8
	.cfi_def_cfa_offset 8416
	.cfi_offset %rbx, -56
	.cfi_offset %r12, -48
	.cfi_offset %r13, -40
	.cfi_offset %r14, -32
	.cfi_offset %r15, -24
	.cfi_offset %rbp, -16
	movq	%rdx, %r15
	movq	%rsi, %rbx
	movq	%rdi, 8(%rsp)           # 8-byte Spill
	leaq	5776(%rsp), %r12
	movq	%r12, %rdi
	movq	%rdx, %rsi
	callq	crypto_decode_857x3_ref@PLT
	leaq	6640(%rsp), %r13
	movq	%r13, %rdi
	movq	%rbx, %rsi
	callq	crypto_decode_857x1723_avx@PLT
	leaq	1152(%rbx), %rsi
	leaq	80(%rsp), %rdi
	callq	crypto_decode_256x16_ref@PLT
	leaq	2320(%rsp), %r14
	movq	%r14, %rdi
	movq	%r13, %rsi
	callq	crypto_encode_857xint16_little@PLT
	xorl	%ebp, %ebp
	leaq	592(%rsp), %r13
	xorl	%ecx, %ecx
	movq	%r13, %rdi
	movq	%r14, %rsi
	movq	%r12, %rdx
	callq	crypto_core_multsntrup857_avx@PLT
	leaq	4048(%rsp), %rdi
	movq	%r13, %rsi
	callq	crypto_decode_857xint16_little@PLT
	vpbroadcastd	.LCPI3_0(%rip), %ymm0 # ymm0 = [324,324,324,324,324,324,324,324]
	vpbroadcastd	.LCPI3_1(%rip), %ymm1 # ymm1 = [4294965031,4294965031,4294965031,4294965031,4294965031,4294965031,4294965031,4294965031]
	vpbroadcastd	.LCPI3_2(%rip), %ymm2 # ymm2 = [51,51,51,51,51,51,51,51]
	vpbroadcastd	.LCPI3_3(%rip), %ymm3 # ymm3 = [4294962129,4294962129,4294962129,4294962129,4294962129,4294962129,4294962129,4294962129]
	vpbroadcastd	.LCPI3_4(%rip), %ymm4 # ymm4 = [25976,25976,25976,25976,25976,25976,25976,25976]
	vpbroadcastd	.LCPI3_5(%rip), %ymm5 # ymm5 = [67108864,67108864,67108864,67108864,67108864,67108864,67108864,67108864]
	vpbroadcastd	.LCPI3_6(%rip), %ymm6 # ymm6 = [1125,1125,1125,1125,1125,1125,1125,1125]
	vmovdqa	.LCPI3_7(%rip), %ymm12  # ymm12 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	.p2align	4, 0x90
.LBB3_1:                                # =>This Inner Loop Header: Depth=1
	vpmovsxbd	80(%rsp,%rbp), %ymm8
	vpmovsxbd	88(%rsp,%rbp), %ymm9
	vpmulld	%ymm0, %ymm9, %ymm9
	vpmulld	%ymm0, %ymm8, %ymm8
	vpaddd	%ymm1, %ymm8, %ymm8
	vpaddd	%ymm1, %ymm9, %ymm9
	vpmulld	%ymm2, %ymm9, %ymm10
	vpmulld	%ymm2, %ymm8, %ymm11
	vpsrad	$18, %ymm11, %ymm11
	vpsrad	$18, %ymm10, %ymm10
	vpmulld	%ymm3, %ymm10, %ymm10
	vpmulld	%ymm3, %ymm11, %ymm11
	vpaddd	%ymm8, %ymm11, %ymm8
	vpaddd	%ymm9, %ymm10, %ymm9
	vpmulld	%ymm4, %ymm9, %ymm10
	vpmulld	%ymm4, %ymm8, %ymm11
	vpaddd	%ymm5, %ymm11, %ymm11
	vpaddd	%ymm5, %ymm10, %ymm10
	vpsrad	$27, %ymm10, %ymm10
	vpsrad	$27, %ymm11, %ymm11
	vpmulld	%ymm3, %ymm11, %ymm11
	vpmulld	%ymm3, %ymm10, %ymm10
	vpaddd	%ymm9, %ymm10, %ymm9
	vpaddd	%ymm8, %ymm11, %ymm8
	vpslld	$16, %ymm8, %ymm8
	vpsrad	$16, %ymm8, %ymm8
	vpslld	$16, %ymm9, %ymm9
	vpmovsxwd	4048(%rsp,%rbp,2), %ymm10
	vpsrad	$16, %ymm9, %ymm9
	vpsubd	%ymm10, %ymm8, %ymm8
	vpmovsxwd	4064(%rsp,%rbp,2), %ymm10
	vpsubd	%ymm10, %ymm9, %ymm9
	vpaddd	%ymm6, %ymm8, %ymm8
	vpaddd	%ymm6, %ymm9, %ymm9
	vpmulld	%ymm2, %ymm9, %ymm10
	vpmulld	%ymm2, %ymm8, %ymm11
	vpsrad	$18, %ymm11, %ymm11
	vpsrad	$18, %ymm10, %ymm10
	vpmulld	%ymm3, %ymm10, %ymm10
	vpmulld	%ymm3, %ymm11, %ymm11
	vpaddd	%ymm8, %ymm11, %ymm8
	vpaddd	%ymm9, %ymm10, %ymm9
	vpmulld	%ymm4, %ymm9, %ymm10
	vpmulld	%ymm4, %ymm8, %ymm11
	vpaddd	%ymm5, %ymm11, %ymm11
	vpaddd	%ymm5, %ymm10, %ymm10
	vpsrad	$27, %ymm10, %ymm10
	vpsrad	$27, %ymm11, %ymm11
	vpmulld	%ymm3, %ymm11, %ymm11
	vpmulld	%ymm3, %ymm10, %ymm10
	vpaddd	%ymm9, %ymm10, %ymm9
	vpaddd	%ymm8, %ymm11, %ymm8
	vpshufb	%ymm12, %ymm8, %ymm8
	vpermq	$232, %ymm8, %ymm8      # ymm8 = ymm8[0,2,2,3]
	vpshufb	%ymm12, %ymm9, %ymm9
	vpermq	$232, %ymm9, %ymm9      # ymm9 = ymm9[0,2,2,3]
	vinserti128	$1, %xmm9, %ymm8, %ymm8
	vpsrlw	$15, %ymm8, %ymm8
	vextracti128	$1, %ymm8, %xmm7
	vpackuswb	%xmm7, %xmm8, %xmm7
	vmovdqa	%xmm7, 336(%rsp,%rbp)
	addq	$16, %rbp
	cmpq	$256, %rbp              # imm = 0x100
	jne	.LBB3_1
# %bb.2:
	leaq	215(%r15), %rcx
	leaq	1431(%r15), %r8
	leaq	2320(%rsp), %rdi
	leaq	592(%rsp), %rsi
	leaq	336(%rsp), %rdx
	vzeroupper
	callq	Hide
	vpxor	%xmm0, %xmm0, %xmm0
	movl	$24, %eax
	vpxor	%xmm1, %xmm1, %xmm1
	vpxor	%xmm2, %xmm2, %xmm2
	vpxor	%xmm3, %xmm3, %xmm3
	.p2align	4, 0x90
.LBB3_3:                                # =>This Inner Loop Header: Depth=1
	vpmovzxbw	-24(%rbx,%rax), %xmm4 # xmm4 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	-16(%rbx,%rax), %xmm5 # xmm5 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	-8(%rbx,%rax), %xmm6 # xmm6 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	(%rbx,%rax), %xmm8 # xmm8 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	2296(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm4, %xmm7, %xmm4
	vpackuswb	%xmm0, %xmm4, %xmm4
	vpmovzxbw	2304(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm5, %xmm7, %xmm5
	vpackuswb	%xmm0, %xmm5, %xmm5
	vpmovzxbw	2312(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm6, %xmm7, %xmm6
	vpackuswb	%xmm0, %xmm6, %xmm6
	vpmovzxbw	2320(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm8, %xmm7, %xmm7
	vpackuswb	%xmm0, %xmm7, %xmm7
	vpmovzxbd	%xmm4, %ymm4    # ymm4 = xmm4[0],zero,zero,zero,xmm4[1],zero,zero,zero,xmm4[2],zero,zero,zero,xmm4[3],zero,zero,zero,xmm4[4],zero,zero,zero,xmm4[5],zero,zero,zero,xmm4[6],zero,zero,zero,xmm4[7],zero,zero,zero
	vpor	%ymm4, %ymm0, %ymm0
	vpmovzxbd	%xmm5, %ymm4    # ymm4 = xmm5[0],zero,zero,zero,xmm5[1],zero,zero,zero,xmm5[2],zero,zero,zero,xmm5[3],zero,zero,zero,xmm5[4],zero,zero,zero,xmm5[5],zero,zero,zero,xmm5[6],zero,zero,zero,xmm5[7],zero,zero,zero
	vpor	%ymm4, %ymm1, %ymm1
	vpmovzxbd	%xmm6, %ymm4    # ymm4 = xmm6[0],zero,zero,zero,xmm6[1],zero,zero,zero,xmm6[2],zero,zero,zero,xmm6[3],zero,zero,zero,xmm6[4],zero,zero,zero,xmm6[5],zero,zero,zero,xmm6[6],zero,zero,zero,xmm6[7],zero,zero,zero
	vpor	%ymm4, %ymm2, %ymm2
	vpmovzxbd	%xmm7, %ymm4    # ymm4 = xmm7[0],zero,zero,zero,xmm7[1],zero,zero,zero,xmm7[2],zero,zero,zero,xmm7[3],zero,zero,zero,xmm7[4],zero,zero,zero,xmm7[5],zero,zero,zero,xmm7[6],zero,zero,zero,xmm7[7],zero,zero,zero
	vpor	%ymm4, %ymm3, %ymm3
	addq	$32, %rax
	cmpq	$1336, %rax             # imm = 0x538
	jne	.LBB3_3
# %bb.4:
	vpor	%ymm0, %ymm1, %ymm0
	vpor	%ymm0, %ymm2, %ymm0
	vpor	%ymm0, %ymm3, %ymm0
	vextracti128	$1, %ymm0, %xmm1
	vpor	%ymm1, %ymm0, %ymm0
	vpshufd	$78, %xmm0, %xmm1       # xmm1 = xmm0[2,3,0,1]
	vpor	%ymm1, %ymm0, %ymm0
	vpshufd	$229, %xmm0, %xmm1      # xmm1 = xmm0[1,1,2,3]
	vpor	%ymm1, %ymm0, %ymm0
	vmovd	%xmm0, %ebp
	addl	$-1, %ebp
	shrl	$8, %ebp
	andb	$1, %bpl
	movl	%ebp, %eax
	addb	$-1, %al
	vmovd	%eax, %xmm0
	vpbroadcastb	%xmm0, %xmm0
	vmovdqu	593(%rsp), %xmm1
	vmovdqu	609(%rsp), %xmm2
	vpblendvb	%xmm0, 1399(%r15), %xmm1, %xmm1
	vmovdqu	%xmm1, 593(%rsp)
	vpblendvb	%xmm0, 1415(%r15), %xmm2, %xmm0
	vmovdqu	%xmm0, 609(%rsp)
	leaq	625(%rsp), %rdi
	movl	$1312, %edx             # imm = 0x520
	movq	%rbx, %rsi
	vzeroupper
	callq	memcpy@PLT
	movb	%bpl, 592(%rsp)
	leaq	16(%rsp), %rdi
	leaq	592(%rsp), %rsi
	movl	$1345, %edx             # imm = 0x541
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	16(%rsp), %ymm0
	movq	8(%rsp), %rax           # 8-byte Reload
	vmovups	%ymm0, (%rax)
	xorl	%eax, %eax
	addq	$8360, %rsp             # imm = 0x20A8
	.cfi_def_cfa_offset 56
	popq	%rbx
	.cfi_def_cfa_offset 48
	popq	%r12
	.cfi_def_cfa_offset 40
	popq	%r13
	.cfi_def_cfa_offset 32
	popq	%r14
	.cfi_def_cfa_offset 24
	popq	%r15
	.cfi_def_cfa_offset 16
	popq	%rbp
	.cfi_def_cfa_offset 8
	vzeroupper
	retq
.Lfunc_end3:
	.size	crypto_kem_dec, .Lfunc_end3-crypto_kem_dec
	.cfi_endproc
                                        # -- End function
	.type	aes_nonce,@object       # @aes_nonce
	.section	.rodata,"a",@progbits
	.p2align	4
aes_nonce:
	.zero	16
	.size	aes_nonce, 16


	.ident	"clang version 7.0.1-8 (tags/RELEASE_701/final)"
	.section	".note.GNU-stack","",@progbits
