	.text
	.file	"kem.c"
	.section	.rodata.cst4,"aM",@progbits,4
	.p2align	2               # -- Begin function crypto_kem_keypair
.LCPI0_0:
	.long	1073741823              # 0x3fffffff
.LCPI0_1:
	.long	3                       # 0x3
.LCPI0_3:
	.long	4294967294              # 0xfffffffe
.LCPI0_4:
	.long	4294967292              # 0xfffffffc
.LCPI0_5:
	.long	1                       # 0x1
	.section	.rodata.cst16,"aM",@progbits,16
	.p2align	4
.LCPI0_2:
	.byte	0                       # 0x0
	.byte	2                       # 0x2
	.byte	4                       # 0x4
	.byte	6                       # 0x6
	.byte	8                       # 0x8
	.byte	10                      # 0xa
	.byte	12                      # 0xc
	.byte	14                      # 0xe
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
.LCPI0_7:
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.section	.rodata.cst32,"aM",@progbits,32
	.p2align	5
.LCPI0_6:
	.byte	0                       # 0x0
	.byte	1                       # 0x1
	.byte	4                       # 0x4
	.byte	5                       # 0x5
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	14                      # 0xe
	.byte	15                      # 0xf
	.byte	16                      # 0x10
	.byte	17                      # 0x11
	.byte	20                      # 0x14
	.byte	21                      # 0x15
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	30                      # 0x1e
	.byte	31                      # 0x1f
	.text
	.globl	crypto_kem_keypair
	.p2align	4, 0x90
	.type	crypto_kem_keypair,@function
crypto_kem_keypair:                     # @crypto_kem_keypair
	.cfi_startproc
# %bb.0:
	pushq	%rbp
	.cfi_def_cfa_offset 16
	pushq	%r15
	.cfi_def_cfa_offset 24
	pushq	%r14
	.cfi_def_cfa_offset 32
	pushq	%r13
	.cfi_def_cfa_offset 40
	pushq	%r12
	.cfi_def_cfa_offset 48
	pushq	%rbx
	.cfi_def_cfa_offset 56
	subq	$11304, %rsp            # imm = 0x2C28
	.cfi_def_cfa_offset 11360
	.cfi_offset %rbx, -56
	.cfi_offset %r12, -48
	.cfi_offset %r13, -40
	.cfi_offset %r14, -32
	.cfi_offset %r15, -24
	.cfi_offset %rbp, -16
	movq	%rsi, %rbx
	movq	%rdi, %r14
	vbroadcastss	.LCPI0_0(%rip), %ymm0 # ymm0 = [1073741823,1073741823,1073741823,1073741823,1073741823,1073741823,1073741823,1073741823]
	vmovups	%ymm0, 3488(%rsp)       # 32-byte Spill
	leaq	16(%rsp), %r15
	vpbroadcastd	.LCPI0_1(%rip), %ymm0 # ymm0 = [3,3,3,3,3,3,3,3]
	vmovdqu	%ymm0, 3456(%rsp)       # 32-byte Spill
	movl	$1073741823, %ebp       # imm = 0x3FFFFFFF
	leaq	5264(%rsp), %r12
	leaq	3536(%rsp), %r13
	.p2align	4, 0x90
.LBB0_1:                                # =>This Loop Header: Depth=1
                                        #     Child Loop BB0_2 Depth 2
	movl	$3428, %esi             # imm = 0xD64
	movq	%r15, %rdi
	vzeroupper
	callq	randombytes@PLT
	movq	%r15, %rdi
	movq	%r15, %rsi
	callq	crypto_decode_857xint32_little@PLT
	movl	$24, %eax
	vmovdqa	.LCPI0_2(%rip), %xmm5   # xmm5 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	vmovdqa	%xmm5, %xmm8
	vmovdqu	3488(%rsp), %ymm6       # 32-byte Reload
	vmovdqu	3456(%rsp), %ymm7       # 32-byte Reload
	vpcmpeqd	%xmm5, %xmm5, %xmm5
	.p2align	4, 0x90
.LBB0_2:                                #   Parent Loop BB0_1 Depth=1
                                        # =>  This Inner Loop Header: Depth=2
	vpand	-80(%rsp,%rax,4), %ymm6, %ymm0
	vpand	-48(%rsp,%rax,4), %ymm6, %ymm1
	vpand	-16(%rsp,%rax,4), %ymm6, %ymm2
	vpand	16(%rsp,%rax,4), %ymm6, %ymm3
	vpmulld	%ymm7, %ymm0, %ymm0
	vpmulld	%ymm7, %ymm1, %ymm1
	vpmulld	%ymm7, %ymm2, %ymm2
	vpmulld	%ymm7, %ymm3, %ymm3
	vpsrld	$30, %ymm0, %ymm0
	vpsrld	$30, %ymm1, %ymm1
	vpsrld	$30, %ymm2, %ymm2
	vpsrld	$30, %ymm3, %ymm3
	vextracti128	$1, %ymm0, %xmm4
	vpackusdw	%xmm4, %xmm0, %xmm0
	vextracti128	$1, %ymm1, %xmm4
	vpackusdw	%xmm4, %xmm1, %xmm1
	vextracti128	$1, %ymm2, %xmm4
	vpackusdw	%xmm4, %xmm2, %xmm2
	vextracti128	$1, %ymm3, %xmm4
	vpackusdw	%xmm4, %xmm3, %xmm3
	vpaddb	%xmm5, %xmm0, %xmm0
	vpshufb	%xmm8, %xmm0, %xmm0
	vpaddb	%xmm5, %xmm1, %xmm1
	vpshufb	%xmm8, %xmm1, %xmm1
	vpunpcklqdq	%xmm1, %xmm0, %xmm0 # xmm0 = xmm0[0],xmm1[0]
	vmovdqa	%xmm0, 3512(%rsp,%rax)
	vpaddb	%xmm5, %xmm2, %xmm0
	vpshufb	%xmm8, %xmm0, %xmm0
	vpaddb	%xmm5, %xmm3, %xmm1
	vpshufb	%xmm8, %xmm1, %xmm1
	vpunpcklqdq	%xmm1, %xmm0, %xmm0 # xmm0 = xmm0[0],xmm1[0]
	vmovdqa	%xmm0, 3528(%rsp,%rax)
	addq	$32, %rax
	cmpq	$856, %rax              # imm = 0x358
	jne	.LBB0_2
# %bb.3:                                #   in Loop: Header=BB0_1 Depth=1
	movl	3344(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4368(%rsp)
	movl	3348(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4369(%rsp)
	movl	3352(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4370(%rsp)
	movl	3356(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4371(%rsp)
	movl	3360(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4372(%rsp)
	movl	3364(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4373(%rsp)
	movl	3368(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4374(%rsp)
	movl	3372(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4375(%rsp)
	movl	3376(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4376(%rsp)
	movl	3380(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4377(%rsp)
	movl	3384(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4378(%rsp)
	movl	3388(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4379(%rsp)
	movl	3392(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4380(%rsp)
	movl	3396(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4381(%rsp)
	movl	3400(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4382(%rsp)
	movl	3404(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4383(%rsp)
	movl	3408(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4384(%rsp)
	movl	3412(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4385(%rsp)
	movl	3416(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4386(%rsp)
	movl	3420(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4387(%rsp)
	movl	3424(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4388(%rsp)
	movl	3428(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4389(%rsp)
	movl	3432(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4390(%rsp)
	movl	3436(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4391(%rsp)
	movl	3440(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 4392(%rsp)
	xorl	%edx, %edx
	xorl	%ecx, %ecx
	movq	%r12, %rdi
	movq	%r13, %rsi
	vzeroupper
	callq	crypto_core_inv3sntrup857_avx@PLT
	cmpb	$0, 6121(%rsp)
	jne	.LBB0_1
# %bb.4:
	leaq	16(%rsp), %r15
	movl	$3428, %esi             # imm = 0xD64
	movq	%r15, %rdi
	callq	randombytes@PLT
	movq	%r15, %rdi
	movq	%r15, %rsi
	callq	crypto_decode_857xint32_little@PLT
	vbroadcastss	.LCPI0_3(%rip), %ymm0 # ymm0 = [4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294]
	vandps	16(%rsp), %ymm0, %ymm1
	vandps	48(%rsp), %ymm0, %ymm2
	vandps	80(%rsp), %ymm0, %ymm3
	vandps	112(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 16(%rsp)
	vmovups	%ymm2, 48(%rsp)
	vmovups	%ymm3, 80(%rsp)
	vmovups	%ymm4, 112(%rsp)
	vandps	144(%rsp), %ymm0, %ymm1
	vandps	176(%rsp), %ymm0, %ymm2
	vandps	208(%rsp), %ymm0, %ymm3
	vandps	240(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 144(%rsp)
	vmovups	%ymm2, 176(%rsp)
	vmovups	%ymm3, 208(%rsp)
	vmovups	%ymm4, 240(%rsp)
	vandps	272(%rsp), %ymm0, %ymm1
	vandps	304(%rsp), %ymm0, %ymm2
	vandps	336(%rsp), %ymm0, %ymm3
	vandps	368(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 272(%rsp)
	vmovups	%ymm2, 304(%rsp)
	vmovups	%ymm3, 336(%rsp)
	vmovups	%ymm4, 368(%rsp)
	vandps	400(%rsp), %ymm0, %ymm1
	vandps	432(%rsp), %ymm0, %ymm2
	vandps	464(%rsp), %ymm0, %ymm3
	vandps	496(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 400(%rsp)
	vmovups	%ymm2, 432(%rsp)
	vmovups	%ymm3, 464(%rsp)
	vmovups	%ymm4, 496(%rsp)
	vandps	528(%rsp), %ymm0, %ymm1
	vandps	560(%rsp), %ymm0, %ymm2
	vandps	592(%rsp), %ymm0, %ymm3
	vandps	624(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 528(%rsp)
	vmovups	%ymm2, 560(%rsp)
	vmovups	%ymm3, 592(%rsp)
	vmovups	%ymm4, 624(%rsp)
	vandps	656(%rsp), %ymm0, %ymm1
	vandps	688(%rsp), %ymm0, %ymm2
	vandps	720(%rsp), %ymm0, %ymm3
	vandps	752(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 656(%rsp)
	vmovups	%ymm2, 688(%rsp)
	vmovups	%ymm3, 720(%rsp)
	vmovups	%ymm4, 752(%rsp)
	vandps	784(%rsp), %ymm0, %ymm1
	vandps	816(%rsp), %ymm0, %ymm2
	vandps	848(%rsp), %ymm0, %ymm3
	vandps	880(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 784(%rsp)
	vmovups	%ymm2, 816(%rsp)
	vmovups	%ymm3, 848(%rsp)
	vmovups	%ymm4, 880(%rsp)
	vandps	912(%rsp), %ymm0, %ymm1
	vandps	944(%rsp), %ymm0, %ymm2
	vandps	976(%rsp), %ymm0, %ymm3
	vandps	1008(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 912(%rsp)
	vmovups	%ymm2, 944(%rsp)
	vmovups	%ymm3, 976(%rsp)
	vmovups	%ymm4, 1008(%rsp)
	vandps	1040(%rsp), %ymm0, %ymm1
	vandps	1072(%rsp), %ymm0, %ymm2
	vandps	1104(%rsp), %ymm0, %ymm3
	vandps	1136(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 1040(%rsp)
	vmovups	%ymm2, 1072(%rsp)
	vmovups	%ymm3, 1104(%rsp)
	vmovups	%ymm4, 1136(%rsp)
	vandps	1168(%rsp), %ymm0, %ymm1
	vandps	1200(%rsp), %ymm0, %ymm2
	vandps	1232(%rsp), %ymm0, %ymm3
	vandps	1264(%rsp), %ymm0, %ymm0
	vmovups	%ymm1, 1168(%rsp)
	vmovups	%ymm2, 1200(%rsp)
	vmovups	%ymm3, 1232(%rsp)
	vmovups	%ymm0, 1264(%rsp)
	andb	$-2, 1296(%rsp)
	andb	$-2, 1300(%rsp)
	vpbroadcastd	.LCPI0_4(%rip), %ymm0 # ymm0 = [4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292]
	vpand	1304(%rsp), %ymm0, %ymm2
	vpand	1336(%rsp), %ymm0, %ymm3
	vpand	1368(%rsp), %ymm0, %ymm4
	vpand	1400(%rsp), %ymm0, %ymm5
	vpbroadcastd	.LCPI0_5(%rip), %ymm1 # ymm1 = [1,1,1,1,1,1,1,1]
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1304(%rsp)
	vmovdqu	%ymm3, 1336(%rsp)
	vmovdqu	%ymm4, 1368(%rsp)
	vmovdqu	%ymm5, 1400(%rsp)
	vpand	1432(%rsp), %ymm0, %ymm2
	vpand	1464(%rsp), %ymm0, %ymm3
	vpand	1496(%rsp), %ymm0, %ymm4
	vpand	1528(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1432(%rsp)
	vmovdqu	%ymm3, 1464(%rsp)
	vmovdqu	%ymm4, 1496(%rsp)
	vmovdqu	%ymm5, 1528(%rsp)
	vpand	1560(%rsp), %ymm0, %ymm2
	vpand	1592(%rsp), %ymm0, %ymm3
	vpand	1624(%rsp), %ymm0, %ymm4
	vpand	1656(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1560(%rsp)
	vmovdqu	%ymm3, 1592(%rsp)
	vmovdqu	%ymm4, 1624(%rsp)
	vmovdqu	%ymm5, 1656(%rsp)
	vpand	1688(%rsp), %ymm0, %ymm2
	vpand	1720(%rsp), %ymm0, %ymm3
	vpand	1752(%rsp), %ymm0, %ymm4
	vpand	1784(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1688(%rsp)
	vmovdqu	%ymm3, 1720(%rsp)
	vmovdqu	%ymm4, 1752(%rsp)
	vmovdqu	%ymm5, 1784(%rsp)
	vpand	1816(%rsp), %ymm0, %ymm2
	vpand	1848(%rsp), %ymm0, %ymm3
	vpand	1880(%rsp), %ymm0, %ymm4
	vpand	1912(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1816(%rsp)
	vmovdqu	%ymm3, 1848(%rsp)
	vmovdqu	%ymm4, 1880(%rsp)
	vmovdqu	%ymm5, 1912(%rsp)
	vpand	1944(%rsp), %ymm0, %ymm2
	vpand	1976(%rsp), %ymm0, %ymm3
	vpand	2008(%rsp), %ymm0, %ymm4
	vpand	2040(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1944(%rsp)
	vmovdqu	%ymm3, 1976(%rsp)
	vmovdqu	%ymm4, 2008(%rsp)
	vmovdqu	%ymm5, 2040(%rsp)
	vpand	2072(%rsp), %ymm0, %ymm2
	vpand	2104(%rsp), %ymm0, %ymm3
	vpand	2136(%rsp), %ymm0, %ymm4
	vpand	2168(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2072(%rsp)
	vmovdqu	%ymm3, 2104(%rsp)
	vmovdqu	%ymm4, 2136(%rsp)
	vmovdqu	%ymm5, 2168(%rsp)
	vpand	2200(%rsp), %ymm0, %ymm2
	vpand	2232(%rsp), %ymm0, %ymm3
	vpand	2264(%rsp), %ymm0, %ymm4
	vpand	2296(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2200(%rsp)
	vmovdqu	%ymm3, 2232(%rsp)
	vmovdqu	%ymm4, 2264(%rsp)
	vmovdqu	%ymm5, 2296(%rsp)
	vpand	2328(%rsp), %ymm0, %ymm2
	vpand	2360(%rsp), %ymm0, %ymm3
	vpand	2392(%rsp), %ymm0, %ymm4
	vpand	2424(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2328(%rsp)
	vmovdqu	%ymm3, 2360(%rsp)
	vmovdqu	%ymm4, 2392(%rsp)
	vmovdqu	%ymm5, 2424(%rsp)
	vpand	2456(%rsp), %ymm0, %ymm2
	vpand	2488(%rsp), %ymm0, %ymm3
	vpand	2520(%rsp), %ymm0, %ymm4
	vpand	2552(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2456(%rsp)
	vmovdqu	%ymm3, 2488(%rsp)
	vmovdqu	%ymm4, 2520(%rsp)
	vmovdqu	%ymm5, 2552(%rsp)
	vpand	2584(%rsp), %ymm0, %ymm2
	vpand	2616(%rsp), %ymm0, %ymm3
	vpand	2648(%rsp), %ymm0, %ymm4
	vpand	2680(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2584(%rsp)
	vmovdqu	%ymm3, 2616(%rsp)
	vmovdqu	%ymm4, 2648(%rsp)
	vmovdqu	%ymm5, 2680(%rsp)
	vpand	2712(%rsp), %ymm0, %ymm2
	vpand	2744(%rsp), %ymm0, %ymm3
	vpand	2776(%rsp), %ymm0, %ymm4
	vpand	2808(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2712(%rsp)
	vmovdqu	%ymm3, 2744(%rsp)
	vmovdqu	%ymm4, 2776(%rsp)
	vmovdqu	%ymm5, 2808(%rsp)
	vpand	2840(%rsp), %ymm0, %ymm2
	vpand	2872(%rsp), %ymm0, %ymm3
	vpand	2904(%rsp), %ymm0, %ymm4
	vpand	2936(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2840(%rsp)
	vmovdqu	%ymm3, 2872(%rsp)
	vmovdqu	%ymm4, 2904(%rsp)
	vmovdqu	%ymm5, 2936(%rsp)
	vpand	2968(%rsp), %ymm0, %ymm2
	vpand	3000(%rsp), %ymm0, %ymm3
	vpand	3032(%rsp), %ymm0, %ymm4
	vpand	3064(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2968(%rsp)
	vmovdqu	%ymm3, 3000(%rsp)
	vmovdqu	%ymm4, 3032(%rsp)
	vmovdqu	%ymm5, 3064(%rsp)
	vpand	3096(%rsp), %ymm0, %ymm2
	vpand	3128(%rsp), %ymm0, %ymm3
	vpand	3160(%rsp), %ymm0, %ymm4
	vpand	3192(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 3096(%rsp)
	vmovdqu	%ymm3, 3128(%rsp)
	vmovdqu	%ymm4, 3160(%rsp)
	vmovdqu	%ymm5, 3192(%rsp)
	vpand	3224(%rsp), %ymm0, %ymm2
	vpand	3256(%rsp), %ymm0, %ymm3
	vpand	3288(%rsp), %ymm0, %ymm4
	vpand	3320(%rsp), %ymm0, %ymm0
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm0, %ymm0
	vmovdqu	%ymm2, 3224(%rsp)
	vmovdqu	%ymm3, 3256(%rsp)
	vmovdqu	%ymm4, 3288(%rsp)
	vmovdqu	%ymm0, 3320(%rsp)
	movl	3352(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3352(%rsp)
	movl	3356(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3356(%rsp)
	movl	3360(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3360(%rsp)
	movl	3364(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3364(%rsp)
	movl	3368(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3368(%rsp)
	movl	3372(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3372(%rsp)
	movl	3376(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3376(%rsp)
	movl	3380(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3380(%rsp)
	movl	3384(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3384(%rsp)
	movl	3388(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3388(%rsp)
	movl	3392(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3392(%rsp)
	movl	3396(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3396(%rsp)
	movl	3400(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3400(%rsp)
	movl	3404(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3404(%rsp)
	movl	3408(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3408(%rsp)
	movl	3412(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3412(%rsp)
	movl	3416(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3416(%rsp)
	movl	3420(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3420(%rsp)
	movl	3424(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3424(%rsp)
	movl	3428(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3428(%rsp)
	movl	3432(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3432(%rsp)
	movl	3436(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3436(%rsp)
	movl	3440(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3440(%rsp)
	movl	$857, %esi              # imm = 0x359
	movq	%r15, %rdi
	vzeroupper
	callq	crypto_sort_uint32_useint32@PLT
	movl	$24, %eax
	vmovdqa	.LCPI0_6(%rip), %ymm0   # ymm0 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	vmovdqa	.LCPI0_7(%rip), %xmm1   # xmm1 = [3,3,3,3,3,3,3,3]
	vpcmpeqd	%xmm2, %xmm2, %xmm2
	vmovdqa	.LCPI0_2(%rip), %xmm7   # xmm7 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	.p2align	4, 0x90
.LBB0_5:                                # =>This Inner Loop Header: Depth=1
	vmovdqu	-80(%rsp,%rax,4), %ymm3
	vmovdqu	-48(%rsp,%rax,4), %ymm4
	vmovdqu	-16(%rsp,%rax,4), %ymm5
	vmovdqu	16(%rsp,%rax,4), %ymm6
	vpshufb	%ymm0, %ymm3, %ymm3
	vpermq	$232, %ymm3, %ymm3      # ymm3 = ymm3[0,2,2,3]
	vpshufb	%ymm0, %ymm4, %ymm4
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vpshufb	%ymm0, %ymm5, %ymm5
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpshufb	%ymm0, %ymm6, %ymm6
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpand	%xmm1, %xmm3, %xmm3
	vpand	%xmm1, %xmm4, %xmm4
	vpand	%xmm1, %xmm5, %xmm5
	vpand	%xmm1, %xmm6, %xmm6
	vpaddb	%xmm2, %xmm3, %xmm3
	vpshufb	%xmm7, %xmm3, %xmm3
	vpaddb	%xmm2, %xmm4, %xmm4
	vpshufb	%xmm7, %xmm4, %xmm4
	vpunpcklqdq	%xmm4, %xmm3, %xmm3 # xmm3 = xmm3[0],xmm4[0]
	vmovdqa	%xmm3, 4376(%rsp,%rax)
	vpaddb	%xmm2, %xmm5, %xmm3
	vpshufb	%xmm7, %xmm3, %xmm3
	vpaddb	%xmm2, %xmm6, %xmm4
	vpshufb	%xmm7, %xmm4, %xmm4
	vpunpcklqdq	%xmm4, %xmm3, %xmm3 # xmm3 = xmm3[0],xmm4[0]
	vmovdqa	%xmm3, 4392(%rsp,%rax)
	addq	$32, %rax
	cmpq	$856, %rax              # imm = 0x358
	jne	.LBB0_5
# %bb.6:
	movb	3344(%rsp), %al
	movb	3348(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5232(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 5233(%rsp)
	movb	3352(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5234(%rsp)
	movb	3356(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5235(%rsp)
	movb	3360(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5236(%rsp)
	movb	3364(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5237(%rsp)
	movb	3368(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5238(%rsp)
	movb	3372(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5239(%rsp)
	movb	3376(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5240(%rsp)
	movb	3380(%rsp), %al
	movb	3384(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5241(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 5242(%rsp)
	movb	3388(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5243(%rsp)
	movb	3392(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5244(%rsp)
	movb	3396(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5245(%rsp)
	movb	3400(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5246(%rsp)
	movb	3404(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5247(%rsp)
	movb	3408(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5248(%rsp)
	movb	3412(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5249(%rsp)
	movb	3416(%rsp), %al
	movb	3420(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5250(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 5251(%rsp)
	movb	3424(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5252(%rsp)
	movb	3428(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5253(%rsp)
	movb	3432(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5254(%rsp)
	movb	3436(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5255(%rsp)
	movb	3440(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5256(%rsp)
	xorl	%ebp, %ebp
	leaq	16(%rsp), %r15
	leaq	4400(%rsp), %rsi
	xorl	%edx, %edx
	xorl	%ecx, %ecx
	movq	%r15, %rdi
	vzeroupper
	callq	crypto_core_invsntrup857_avx@PLT
	leaq	7856(%rsp), %r12
	movq	%r12, %rdi
	movq	%r15, %rsi
	callq	crypto_decode_857xint16_little@PLT
	leaq	9584(%rsp), %r15
	movq	%r15, %rdi
	movq	%r12, %rsi
	callq	crypto_encode_857xint16_little@PLT
	leaq	16(%rsp), %r12
	leaq	3536(%rsp), %rdx
	xorl	%ecx, %ecx
	movq	%r12, %rdi
	movq	%r15, %rsi
	callq	crypto_core_multsntrup857_avx@PLT
	leaq	6128(%rsp), %r15
	movq	%r15, %rdi
	movq	%r12, %rsi
	callq	crypto_decode_857xint16_little@PLT
	movq	%r14, %rdi
	movq	%r15, %rsi
	callq	crypto_encode_857x5167_portable@PLT
	leaq	430(%rbx), %rax
	leaq	1752(%rbx), %r15
	leaq	1322(%r14), %rcx
	cmpq	%rcx, %rax
	jae	.LBB0_8
# %bb.7:
	cmpq	%r14, %r15
	ja	.LBB0_9
.LBB0_8:
	vmovups	(%r14), %ymm0
	vmovups	32(%r14), %ymm1
	vmovups	64(%r14), %ymm2
	vmovups	96(%r14), %ymm3
	vmovups	%ymm0, 430(%rbx)
	vmovups	%ymm1, 462(%rbx)
	vmovups	%ymm2, 494(%rbx)
	vmovups	%ymm3, 526(%rbx)
	vmovups	128(%r14), %ymm0
	vmovups	160(%r14), %ymm1
	vmovups	192(%r14), %ymm2
	vmovups	224(%r14), %ymm3
	vmovups	%ymm0, 558(%rbx)
	vmovups	%ymm1, 590(%rbx)
	vmovups	%ymm2, 622(%rbx)
	vmovups	%ymm3, 654(%rbx)
	vmovups	256(%r14), %ymm0
	vmovups	288(%r14), %ymm1
	vmovups	320(%r14), %ymm2
	vmovups	352(%r14), %ymm3
	vmovups	%ymm0, 686(%rbx)
	vmovups	%ymm1, 718(%rbx)
	vmovups	%ymm2, 750(%rbx)
	vmovups	%ymm3, 782(%rbx)
	vmovups	384(%r14), %ymm0
	vmovups	416(%r14), %ymm1
	vmovups	448(%r14), %ymm2
	vmovups	480(%r14), %ymm3
	vmovups	%ymm0, 814(%rbx)
	vmovups	%ymm1, 846(%rbx)
	vmovups	%ymm2, 878(%rbx)
	vmovups	%ymm3, 910(%rbx)
	vmovups	512(%r14), %ymm0
	vmovups	544(%r14), %ymm1
	vmovups	576(%r14), %ymm2
	vmovups	608(%r14), %ymm3
	vmovups	%ymm0, 942(%rbx)
	vmovups	%ymm1, 974(%rbx)
	vmovups	%ymm2, 1006(%rbx)
	vmovups	%ymm3, 1038(%rbx)
	vmovups	640(%r14), %ymm0
	vmovups	672(%r14), %ymm1
	vmovups	704(%r14), %ymm2
	vmovups	736(%r14), %ymm3
	vmovups	%ymm0, 1070(%rbx)
	vmovups	%ymm1, 1102(%rbx)
	vmovups	%ymm2, 1134(%rbx)
	vmovups	%ymm3, 1166(%rbx)
	vmovups	768(%r14), %ymm0
	vmovups	800(%r14), %ymm1
	vmovups	832(%r14), %ymm2
	vmovups	864(%r14), %ymm3
	vmovups	%ymm0, 1198(%rbx)
	vmovups	%ymm1, 1230(%rbx)
	vmovups	%ymm2, 1262(%rbx)
	vmovups	%ymm3, 1294(%rbx)
	vmovups	896(%r14), %ymm0
	vmovups	928(%r14), %ymm1
	vmovups	960(%r14), %ymm2
	vmovups	992(%r14), %ymm3
	vmovups	%ymm0, 1326(%rbx)
	vmovups	%ymm1, 1358(%rbx)
	vmovups	%ymm2, 1390(%rbx)
	vmovups	%ymm3, 1422(%rbx)
	vmovups	1024(%r14), %ymm0
	vmovups	1056(%r14), %ymm1
	vmovups	1088(%r14), %ymm2
	vmovups	1120(%r14), %ymm3
	vmovups	%ymm0, 1454(%rbx)
	vmovups	%ymm1, 1486(%rbx)
	vmovups	%ymm2, 1518(%rbx)
	vmovups	%ymm3, 1550(%rbx)
	vmovdqu	1152(%r14), %ymm0
	vmovdqu	1184(%r14), %ymm1
	vmovdqu	1216(%r14), %ymm2
	vmovdqu	1248(%r14), %ymm3
	vmovdqu	%ymm0, 1582(%rbx)
	vmovdqu	%ymm1, 1614(%rbx)
	vmovdqu	%ymm2, 1646(%rbx)
	vmovdqu	%ymm3, 1678(%rbx)
	movl	$1280, %ebp             # imm = 0x500
.LBB0_9:
	movq	$-2, %rax
	.p2align	4, 0x90
.LBB0_10:                               # =>This Inner Loop Header: Depth=1
	movzbl	(%r14,%rbp), %ecx
	movb	%cl, 430(%rbx,%rbp)
	addq	$1, %rbp
	addq	$1, %rax
	jne	.LBB0_10
	.p2align	4, 0x90
.LBB0_11:                               # =>This Inner Loop Header: Depth=1
	movzbl	(%r14,%rbp), %eax
	movb	%al, 430(%rbx,%rbp)
	movzbl	1(%r14,%rbp), %eax
	movb	%al, 431(%rbx,%rbp)
	movzbl	2(%r14,%rbp), %eax
	movb	%al, 432(%rbx,%rbp)
	movzbl	3(%r14,%rbp), %eax
	movb	%al, 433(%rbx,%rbp)
	addq	$4, %rbp
	cmpq	$1322, %rbp             # imm = 0x52A
	jne	.LBB0_11
# %bb.12:
	leaq	429(%rbx), %rsi
	movb	$4, 429(%rbx)
	leaq	16(%rsp), %rdi
	movl	$1323, %edx             # imm = 0x52B
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	16(%rsp), %ymm0
	vmovups	%ymm0, 1967(%rbx)
	leaq	4400(%rsp), %rsi
	movq	%rbx, %rdi
	vzeroupper
	callq	crypto_encode_857x3_ref@PLT
	addq	$215, %rbx
	leaq	5264(%rsp), %rsi
	movq	%rbx, %rdi
	callq	crypto_encode_857x3_ref@PLT
	movl	$215, %esi
	movq	%r15, %rdi
	callq	randombytes@PLT
	xorl	%eax, %eax
	addq	$11304, %rsp            # imm = 0x2C28
	.cfi_def_cfa_offset 56
	popq	%rbx
	.cfi_def_cfa_offset 48
	popq	%r12
	.cfi_def_cfa_offset 40
	popq	%r13
	.cfi_def_cfa_offset 32
	popq	%r14
	.cfi_def_cfa_offset 24
	popq	%r15
	.cfi_def_cfa_offset 16
	popq	%rbp
	.cfi_def_cfa_offset 8
	retq
.Lfunc_end0:
	.size	crypto_kem_keypair, .Lfunc_end0-crypto_kem_keypair
	.cfi_endproc
                                        # -- End function
	.section	.rodata.cst4,"aM",@progbits,4
	.p2align	2               # -- Begin function crypto_kem_enc
.LCPI1_0:
	.long	4294967294              # 0xfffffffe
.LCPI1_1:
	.long	4294967292              # 0xfffffffc
.LCPI1_2:
	.long	1                       # 0x1
	.section	.rodata.cst32,"aM",@progbits,32
	.p2align	5
.LCPI1_3:
	.byte	0                       # 0x0
	.byte	1                       # 0x1
	.byte	4                       # 0x4
	.byte	5                       # 0x5
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	14                      # 0xe
	.byte	15                      # 0xf
	.byte	16                      # 0x10
	.byte	17                      # 0x11
	.byte	20                      # 0x14
	.byte	21                      # 0x15
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	30                      # 0x1e
	.byte	31                      # 0x1f
	.section	.rodata.cst16,"aM",@progbits,16
	.p2align	4
.LCPI1_4:
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
.LCPI1_5:
	.byte	0                       # 0x0
	.byte	2                       # 0x2
	.byte	4                       # 0x4
	.byte	6                       # 0x6
	.byte	8                       # 0x8
	.byte	10                      # 0xa
	.byte	12                      # 0xc
	.byte	14                      # 0xe
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.text
	.globl	crypto_kem_enc
	.p2align	4, 0x90
	.type	crypto_kem_enc,@function
crypto_kem_enc:                         # @crypto_kem_enc
	.cfi_startproc
# %bb.0:
	pushq	%rbp
	.cfi_def_cfa_offset 16
	pushq	%r15
	.cfi_def_cfa_offset 24
	pushq	%r14
	.cfi_def_cfa_offset 32
	pushq	%r13
	.cfi_def_cfa_offset 40
	pushq	%r12
	.cfi_def_cfa_offset 48
	pushq	%rbx
	.cfi_def_cfa_offset 56
	subq	$11064, %rsp            # imm = 0x2B38
	.cfi_def_cfa_offset 11120
	.cfi_offset %rbx, -56
	.cfi_offset %r12, -48
	.cfi_offset %r13, -40
	.cfi_offset %r14, -32
	.cfi_offset %r15, -24
	.cfi_offset %rbp, -16
	movq	%rdx, %r15
	movq	%rsi, %r14
	movq	%rdi, %r12
	leaq	6289(%rsp), %rdi
	movl	$1322, %edx             # imm = 0x52A
	movq	%r15, %rsi
	callq	memcpy@PLT
	movb	$4, 6288(%rsp)
	leaq	4560(%rsp), %rdi
	leaq	6288(%rsp), %rsi
	movl	$1323, %edx             # imm = 0x52B
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	4560(%rsp), %ymm0
	vmovups	%ymm0, 3440(%rsp)
	movq	%rsp, %rbx
	movl	$3428, %esi             # imm = 0xD64
	movq	%rbx, %rdi
	vzeroupper
	callq	randombytes@PLT
	movq	%rbx, %rdi
	movq	%rbx, %rsi
	callq	crypto_decode_857xint32_little@PLT
	vbroadcastss	.LCPI1_0(%rip), %ymm0 # ymm0 = [4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294]
	vandps	(%rsp), %ymm0, %ymm1
	vandps	32(%rsp), %ymm0, %ymm2
	vandps	64(%rsp), %ymm0, %ymm3
	vandps	96(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, (%rsp)
	vmovups	%ymm2, 32(%rsp)
	vmovups	%ymm3, 64(%rsp)
	vmovups	%ymm4, 96(%rsp)
	vandps	128(%rsp), %ymm0, %ymm1
	vandps	160(%rsp), %ymm0, %ymm2
	vandps	192(%rsp), %ymm0, %ymm3
	vandps	224(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 128(%rsp)
	vmovups	%ymm2, 160(%rsp)
	vmovups	%ymm3, 192(%rsp)
	vmovups	%ymm4, 224(%rsp)
	vandps	256(%rsp), %ymm0, %ymm1
	vandps	288(%rsp), %ymm0, %ymm2
	vandps	320(%rsp), %ymm0, %ymm3
	vandps	352(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 256(%rsp)
	vmovups	%ymm2, 288(%rsp)
	vmovups	%ymm3, 320(%rsp)
	vmovups	%ymm4, 352(%rsp)
	vandps	384(%rsp), %ymm0, %ymm1
	vandps	416(%rsp), %ymm0, %ymm2
	vandps	448(%rsp), %ymm0, %ymm3
	vandps	480(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 384(%rsp)
	vmovups	%ymm2, 416(%rsp)
	vmovups	%ymm3, 448(%rsp)
	vmovups	%ymm4, 480(%rsp)
	vandps	512(%rsp), %ymm0, %ymm1
	vandps	544(%rsp), %ymm0, %ymm2
	vandps	576(%rsp), %ymm0, %ymm3
	vandps	608(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 512(%rsp)
	vmovups	%ymm2, 544(%rsp)
	vmovups	%ymm3, 576(%rsp)
	vmovups	%ymm4, 608(%rsp)
	vandps	640(%rsp), %ymm0, %ymm1
	vandps	672(%rsp), %ymm0, %ymm2
	vandps	704(%rsp), %ymm0, %ymm3
	vandps	736(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 640(%rsp)
	vmovups	%ymm2, 672(%rsp)
	vmovups	%ymm3, 704(%rsp)
	vmovups	%ymm4, 736(%rsp)
	vandps	768(%rsp), %ymm0, %ymm1
	vandps	800(%rsp), %ymm0, %ymm2
	vandps	832(%rsp), %ymm0, %ymm3
	vandps	864(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 768(%rsp)
	vmovups	%ymm2, 800(%rsp)
	vmovups	%ymm3, 832(%rsp)
	vmovups	%ymm4, 864(%rsp)
	vandps	896(%rsp), %ymm0, %ymm1
	vandps	928(%rsp), %ymm0, %ymm2
	vandps	960(%rsp), %ymm0, %ymm3
	vandps	992(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 896(%rsp)
	vmovups	%ymm2, 928(%rsp)
	vmovups	%ymm3, 960(%rsp)
	vmovups	%ymm4, 992(%rsp)
	vandps	1024(%rsp), %ymm0, %ymm1
	vandps	1056(%rsp), %ymm0, %ymm2
	vandps	1088(%rsp), %ymm0, %ymm3
	vandps	1120(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 1024(%rsp)
	vmovups	%ymm2, 1056(%rsp)
	vmovups	%ymm3, 1088(%rsp)
	vmovups	%ymm4, 1120(%rsp)
	vandps	1152(%rsp), %ymm0, %ymm1
	vandps	1184(%rsp), %ymm0, %ymm2
	vandps	1216(%rsp), %ymm0, %ymm3
	vandps	1248(%rsp), %ymm0, %ymm0
	vmovups	%ymm1, 1152(%rsp)
	vmovups	%ymm2, 1184(%rsp)
	vmovups	%ymm3, 1216(%rsp)
	vmovups	%ymm0, 1248(%rsp)
	andb	$-2, 1280(%rsp)
	andb	$-2, 1284(%rsp)
	vpbroadcastd	.LCPI1_1(%rip), %ymm0 # ymm0 = [4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292]
	vpand	1288(%rsp), %ymm0, %ymm2
	vpand	1320(%rsp), %ymm0, %ymm3
	vpand	1352(%rsp), %ymm0, %ymm4
	vpand	1384(%rsp), %ymm0, %ymm5
	vpbroadcastd	.LCPI1_2(%rip), %ymm1 # ymm1 = [1,1,1,1,1,1,1,1]
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1288(%rsp)
	vmovdqu	%ymm3, 1320(%rsp)
	vmovdqu	%ymm4, 1352(%rsp)
	vmovdqu	%ymm5, 1384(%rsp)
	vpand	1416(%rsp), %ymm0, %ymm2
	vpand	1448(%rsp), %ymm0, %ymm3
	vpand	1480(%rsp), %ymm0, %ymm4
	vpand	1512(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1416(%rsp)
	vmovdqu	%ymm3, 1448(%rsp)
	vmovdqu	%ymm4, 1480(%rsp)
	vmovdqu	%ymm5, 1512(%rsp)
	vpand	1544(%rsp), %ymm0, %ymm2
	vpand	1576(%rsp), %ymm0, %ymm3
	vpand	1608(%rsp), %ymm0, %ymm4
	vpand	1640(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1544(%rsp)
	vmovdqu	%ymm3, 1576(%rsp)
	vmovdqu	%ymm4, 1608(%rsp)
	vmovdqu	%ymm5, 1640(%rsp)
	vpand	1672(%rsp), %ymm0, %ymm2
	vpand	1704(%rsp), %ymm0, %ymm3
	vpand	1736(%rsp), %ymm0, %ymm4
	vpand	1768(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1672(%rsp)
	vmovdqu	%ymm3, 1704(%rsp)
	vmovdqu	%ymm4, 1736(%rsp)
	vmovdqu	%ymm5, 1768(%rsp)
	vpand	1800(%rsp), %ymm0, %ymm2
	vpand	1832(%rsp), %ymm0, %ymm3
	vpand	1864(%rsp), %ymm0, %ymm4
	vpand	1896(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1800(%rsp)
	vmovdqu	%ymm3, 1832(%rsp)
	vmovdqu	%ymm4, 1864(%rsp)
	vmovdqu	%ymm5, 1896(%rsp)
	vpand	1928(%rsp), %ymm0, %ymm2
	vpand	1960(%rsp), %ymm0, %ymm3
	vpand	1992(%rsp), %ymm0, %ymm4
	vpand	2024(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1928(%rsp)
	vmovdqu	%ymm3, 1960(%rsp)
	vmovdqu	%ymm4, 1992(%rsp)
	vmovdqu	%ymm5, 2024(%rsp)
	vpand	2056(%rsp), %ymm0, %ymm2
	vpand	2088(%rsp), %ymm0, %ymm3
	vpand	2120(%rsp), %ymm0, %ymm4
	vpand	2152(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2056(%rsp)
	vmovdqu	%ymm3, 2088(%rsp)
	vmovdqu	%ymm4, 2120(%rsp)
	vmovdqu	%ymm5, 2152(%rsp)
	vpand	2184(%rsp), %ymm0, %ymm2
	vpand	2216(%rsp), %ymm0, %ymm3
	vpand	2248(%rsp), %ymm0, %ymm4
	vpand	2280(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2184(%rsp)
	vmovdqu	%ymm3, 2216(%rsp)
	vmovdqu	%ymm4, 2248(%rsp)
	vmovdqu	%ymm5, 2280(%rsp)
	vpand	2312(%rsp), %ymm0, %ymm2
	vpand	2344(%rsp), %ymm0, %ymm3
	vpand	2376(%rsp), %ymm0, %ymm4
	vpand	2408(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2312(%rsp)
	vmovdqu	%ymm3, 2344(%rsp)
	vmovdqu	%ymm4, 2376(%rsp)
	vmovdqu	%ymm5, 2408(%rsp)
	vpand	2440(%rsp), %ymm0, %ymm2
	vpand	2472(%rsp), %ymm0, %ymm3
	vpand	2504(%rsp), %ymm0, %ymm4
	vpand	2536(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2440(%rsp)
	vmovdqu	%ymm3, 2472(%rsp)
	vmovdqu	%ymm4, 2504(%rsp)
	vmovdqu	%ymm5, 2536(%rsp)
	vpand	2568(%rsp), %ymm0, %ymm2
	vpand	2600(%rsp), %ymm0, %ymm3
	vpand	2632(%rsp), %ymm0, %ymm4
	vpand	2664(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2568(%rsp)
	vmovdqu	%ymm3, 2600(%rsp)
	vmovdqu	%ymm4, 2632(%rsp)
	vmovdqu	%ymm5, 2664(%rsp)
	vpand	2696(%rsp), %ymm0, %ymm2
	vpand	2728(%rsp), %ymm0, %ymm3
	vpand	2760(%rsp), %ymm0, %ymm4
	vpand	2792(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2696(%rsp)
	vmovdqu	%ymm3, 2728(%rsp)
	vmovdqu	%ymm4, 2760(%rsp)
	vmovdqu	%ymm5, 2792(%rsp)
	vpand	2824(%rsp), %ymm0, %ymm2
	vpand	2856(%rsp), %ymm0, %ymm3
	vpand	2888(%rsp), %ymm0, %ymm4
	vpand	2920(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2824(%rsp)
	vmovdqu	%ymm3, 2856(%rsp)
	vmovdqu	%ymm4, 2888(%rsp)
	vmovdqu	%ymm5, 2920(%rsp)
	vpand	2952(%rsp), %ymm0, %ymm2
	vpand	2984(%rsp), %ymm0, %ymm3
	vpand	3016(%rsp), %ymm0, %ymm4
	vpand	3048(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2952(%rsp)
	vmovdqu	%ymm3, 2984(%rsp)
	vmovdqu	%ymm4, 3016(%rsp)
	vmovdqu	%ymm5, 3048(%rsp)
	vpand	3080(%rsp), %ymm0, %ymm2
	vpand	3112(%rsp), %ymm0, %ymm3
	vpand	3144(%rsp), %ymm0, %ymm4
	vpand	3176(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 3080(%rsp)
	vmovdqu	%ymm3, 3112(%rsp)
	vmovdqu	%ymm4, 3144(%rsp)
	vmovdqu	%ymm5, 3176(%rsp)
	vpand	3208(%rsp), %ymm0, %ymm2
	vpand	3240(%rsp), %ymm0, %ymm3
	vpand	3272(%rsp), %ymm0, %ymm4
	vpand	3304(%rsp), %ymm0, %ymm0
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm0, %ymm0
	vmovdqu	%ymm2, 3208(%rsp)
	vmovdqu	%ymm3, 3240(%rsp)
	vmovdqu	%ymm4, 3272(%rsp)
	vmovdqu	%ymm0, 3304(%rsp)
	movl	3336(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3336(%rsp)
	movl	3340(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3340(%rsp)
	movl	3344(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3344(%rsp)
	movl	3348(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3348(%rsp)
	movl	3352(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3352(%rsp)
	movl	3356(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3356(%rsp)
	movl	3360(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3360(%rsp)
	movl	3364(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3364(%rsp)
	movl	3368(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3368(%rsp)
	movl	3372(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3372(%rsp)
	movl	3376(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3376(%rsp)
	movl	3380(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3380(%rsp)
	movl	3384(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3384(%rsp)
	movl	3388(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3388(%rsp)
	movl	3392(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3392(%rsp)
	movl	3396(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3396(%rsp)
	movl	3400(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3400(%rsp)
	movl	3404(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3404(%rsp)
	movl	3408(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3408(%rsp)
	movl	3412(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3412(%rsp)
	movl	3416(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3416(%rsp)
	movl	3420(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3420(%rsp)
	movl	3424(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3424(%rsp)
	movl	$857, %esi              # imm = 0x359
	movq	%rbx, %rdi
	vzeroupper
	callq	crypto_sort_uint32_useint32@PLT
	movl	$24, %eax
	vmovdqa	.LCPI1_3(%rip), %ymm0   # ymm0 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	vmovdqa	.LCPI1_4(%rip), %xmm1   # xmm1 = [3,3,3,3,3,3,3,3]
	vpcmpeqd	%xmm2, %xmm2, %xmm2
	vmovdqa	.LCPI1_5(%rip), %xmm3   # xmm3 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	.p2align	4, 0x90
.LBB1_1:                                # =>This Inner Loop Header: Depth=1
	vmovdqu	-96(%rsp,%rax,4), %ymm4
	vmovdqu	-64(%rsp,%rax,4), %ymm5
	vmovdqu	-32(%rsp,%rax,4), %ymm6
	vmovdqu	(%rsp,%rax,4), %ymm7
	vpshufb	%ymm0, %ymm4, %ymm4
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vpshufb	%ymm0, %ymm5, %ymm5
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpshufb	%ymm0, %ymm6, %ymm6
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpshufb	%ymm0, %ymm7, %ymm7
	vpermq	$232, %ymm7, %ymm7      # ymm7 = ymm7[0,2,2,3]
	vpand	%xmm1, %xmm4, %xmm4
	vpand	%xmm1, %xmm5, %xmm5
	vpand	%xmm1, %xmm6, %xmm6
	vpand	%xmm1, %xmm7, %xmm7
	vpaddb	%xmm2, %xmm4, %xmm4
	vpshufb	%xmm3, %xmm4, %xmm4
	vpaddb	%xmm2, %xmm5, %xmm5
	vpshufb	%xmm3, %xmm5, %xmm5
	vpunpcklqdq	%xmm5, %xmm4, %xmm4 # xmm4 = xmm4[0],xmm5[0]
	vmovdqa	%xmm4, 3448(%rsp,%rax)
	vpaddb	%xmm2, %xmm6, %xmm4
	vpshufb	%xmm3, %xmm4, %xmm4
	vpaddb	%xmm2, %xmm7, %xmm5
	vpshufb	%xmm3, %xmm5, %xmm5
	vpunpcklqdq	%xmm5, %xmm4, %xmm4 # xmm4 = xmm4[0],xmm5[0]
	vmovdqa	%xmm4, 3464(%rsp,%rax)
	addq	$32, %rax
	cmpq	$856, %rax              # imm = 0x358
	jne	.LBB1_1
# %bb.2:
	movb	3328(%rsp), %al
	movb	3332(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4304(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 4305(%rsp)
	movb	3336(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4306(%rsp)
	movb	3340(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4307(%rsp)
	movb	3344(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4308(%rsp)
	movb	3348(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4309(%rsp)
	movb	3352(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4310(%rsp)
	movb	3356(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4311(%rsp)
	movb	3360(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4312(%rsp)
	movb	3364(%rsp), %al
	movb	3368(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4313(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 4314(%rsp)
	movb	3372(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4315(%rsp)
	movb	3376(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4316(%rsp)
	movb	3380(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4317(%rsp)
	movb	3384(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4318(%rsp)
	movb	3388(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4319(%rsp)
	movb	3392(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4320(%rsp)
	movb	3396(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4321(%rsp)
	movb	3400(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4322(%rsp)
	movb	3404(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4323(%rsp)
	movb	3408(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4324(%rsp)
	movb	3412(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4325(%rsp)
	movb	3416(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4326(%rsp)
	movb	3420(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4327(%rsp)
	movb	3424(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4328(%rsp)
	leaq	4337(%rsp), %rdi
	leaq	3472(%rsp), %r13
	movq	%r13, %rsi
	vzeroupper
	callq	crypto_encode_857x3_ref@PLT
	leaq	9344(%rsp), %rbx
	movq	%rbx, %rdi
	movq	%r15, %rsi
	callq	crypto_decode_857x5167_avx@PLT
	leaq	4560(%rsp), %r15
	movq	%r15, %rdi
	movq	%rbx, %rsi
	callq	crypto_encode_857xint16_little@PLT
	movq	%rsp, %rbp
	xorl	%ecx, %ecx
	movq	%rbp, %rdi
	movq	%r15, %rsi
	movq	%r13, %rdx
	callq	crypto_core_multsntrup857_avx@PLT
	leaq	7616(%rsp), %rbx
	movq	%rbx, %rdi
	movq	%rbp, %rsi
	callq	crypto_decode_857xint16_little@PLT
	movq	%r12, %rdi
	movq	%rbx, %rsi
	callq	crypto_encode_857x1723round_ref@PLT
	movb	$3, 4336(%rsp)
	leaq	4560(%rsp), %rbx
	leaq	4336(%rsp), %rbp
	movl	$216, %edx
	movq	%rbx, %rdi
	movq	%rbp, %rsi
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	4560(%rsp), %ymm0
	vmovups	%ymm0, 1(%rsp)
	vmovups	3440(%rsp), %ymm0
	vmovups	%ymm0, 33(%rsp)
	movb	$2, (%rsp)
	movq	%rsp, %rsi
	movl	$65, %edx
	movq	%rbx, %rdi
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	4560(%rsp), %ymm0
	vmovups	%ymm0, 1152(%r12)
	movb	$3, 4336(%rsp)
	movl	$216, %edx
	movq	%rbx, %rdi
	movq	%rbp, %rsi
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	4560(%rsp), %ymm0
	vmovups	%ymm0, 1(%rsp)
	leaq	33(%rsp), %rdi
	movl	$1184, %edx             # imm = 0x4A0
	movq	%r12, %rsi
	vzeroupper
	callq	memcpy@PLT
	movb	$1, (%rsp)
	movq	%rsp, %rsi
	movl	$1217, %edx             # imm = 0x4C1
	movq	%rbx, %rdi
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	4560(%rsp), %ymm0
	vmovups	%ymm0, (%r14)
	xorl	%eax, %eax
	addq	$11064, %rsp            # imm = 0x2B38
	.cfi_def_cfa_offset 56
	popq	%rbx
	.cfi_def_cfa_offset 48
	popq	%r12
	.cfi_def_cfa_offset 40
	popq	%r13
	.cfi_def_cfa_offset 32
	popq	%r14
	.cfi_def_cfa_offset 24
	popq	%r15
	.cfi_def_cfa_offset 16
	popq	%rbp
	.cfi_def_cfa_offset 8
	vzeroupper
	retq
.Lfunc_end1:
	.size	crypto_kem_enc, .Lfunc_end1-crypto_kem_enc
	.cfi_endproc
                                        # -- End function
	.section	.rodata.cst4,"aM",@progbits,4
	.p2align	2               # -- Begin function crypto_kem_dec
.LCPI2_0:
	.long	3                       # 0x3
.LCPI2_1:
	.long	153                     # 0x99
.LCPI2_2:
	.long	4294962129              # 0xffffebd1
.LCPI2_3:
	.long	25976                   # 0x6578
.LCPI2_4:
	.long	67108864                # 0x4000000
.LCPI2_6:
	.long	10923                   # 0x2aab
.LCPI2_7:
	.long	16384                   # 0x4000
.LCPI2_8:
	.long	4294967293              # 0xfffffffd
	.section	.rodata.cst32,"aM",@progbits,32
	.p2align	5
.LCPI2_5:
	.byte	0                       # 0x0
	.byte	1                       # 0x1
	.byte	4                       # 0x4
	.byte	5                       # 0x5
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	14                      # 0xe
	.byte	15                      # 0xf
	.byte	16                      # 0x10
	.byte	17                      # 0x11
	.byte	20                      # 0x14
	.byte	21                      # 0x15
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	30                      # 0x1e
	.byte	31                      # 0x1f
.LCPI2_11:
	.zero	32,1
	.section	.rodata.cst16,"aM",@progbits,16
	.p2align	4
.LCPI2_9:
	.byte	0                       # 0x0
	.byte	2                       # 0x2
	.byte	4                       # 0x4
	.byte	6                       # 0x6
	.byte	8                       # 0x8
	.byte	10                      # 0xa
	.byte	12                      # 0xc
	.byte	14                      # 0xe
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
.LCPI2_10:
	.short	1                       # 0x1
	.short	1                       # 0x1
	.short	1                       # 0x1
	.short	1                       # 0x1
	.short	1                       # 0x1
	.short	1                       # 0x1
	.short	1                       # 0x1
	.short	1                       # 0x1
	.text
	.globl	crypto_kem_dec
	.p2align	4, 0x90
	.type	crypto_kem_dec,@function
crypto_kem_dec:                         # @crypto_kem_dec
	.cfi_startproc
# %bb.0:
	pushq	%rbp
	.cfi_def_cfa_offset 16
	pushq	%r15
	.cfi_def_cfa_offset 24
	pushq	%r14
	.cfi_def_cfa_offset 32
	pushq	%r13
	.cfi_def_cfa_offset 40
	pushq	%r12
	.cfi_def_cfa_offset 48
	pushq	%rbx
	.cfi_def_cfa_offset 56
	subq	$16712, %rsp            # imm = 0x4148
	.cfi_def_cfa_offset 16768
	.cfi_offset %rbx, -56
	.cfi_offset %r12, -48
	.cfi_offset %r13, -40
	.cfi_offset %r14, -32
	.cfi_offset %r15, -24
	.cfi_offset %rbp, -16
	movq	%rdx, %r15
	movq	%rsi, %r14
	movq	%rdi, 8(%rsp)           # 8-byte Spill
	leaq	12400(%rsp), %r12
	movq	%r12, %rdi
	movq	%rdx, %rsi
	callq	crypto_decode_857x3_ref@PLT
	leaq	215(%r15), %rsi
	leaq	9808(%rsp), %rdi
	callq	crypto_decode_857x3_ref@PLT
	leaq	13264(%rsp), %r13
	movq	%r13, %rdi
	movq	%r14, %rsi
	callq	crypto_decode_857x1723_avx@PLT
	leaq	6352(%rsp), %rbx
	movq	%rbx, %rdi
	movq	%r13, %rsi
	callq	crypto_encode_857xint16_little@PLT
	xorl	%ebp, %ebp
	leaq	4624(%rsp), %r13
	xorl	%ecx, %ecx
	movq	%r13, %rdi
	movq	%rbx, %rsi
	movq	%r12, %rdx
	callq	crypto_core_multsntrup857_avx@PLT
	leaq	10672(%rsp), %rdi
	movq	%r13, %rsi
	callq	crypto_decode_857xint16_little@PLT
	vpbroadcastd	.LCPI2_0(%rip), %ymm1 # ymm1 = [3,3,3,3,3,3,3,3]
	vpbroadcastd	.LCPI2_1(%rip), %ymm2 # ymm2 = [153,153,153,153,153,153,153,153]
	vpbroadcastd	.LCPI2_2(%rip), %ymm3 # ymm3 = [4294962129,4294962129,4294962129,4294962129,4294962129,4294962129,4294962129,4294962129]
	vpbroadcastd	.LCPI2_3(%rip), %ymm4 # ymm4 = [25976,25976,25976,25976,25976,25976,25976,25976]
	vpbroadcastd	.LCPI2_4(%rip), %ymm5 # ymm5 = [67108864,67108864,67108864,67108864,67108864,67108864,67108864,67108864]
	vmovdqa	.LCPI2_5(%rip), %ymm0   # ymm0 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	.p2align	4, 0x90
.LBB2_1:                                # =>This Inner Loop Header: Depth=1
	vpmovsxwd	10672(%rsp,%rbp,2), %ymm6
	vpmulld	%ymm1, %ymm6, %ymm7
	vpmulld	%ymm2, %ymm6, %ymm6
	vpsrad	$18, %ymm6, %ymm6
	vpmulld	%ymm3, %ymm6, %ymm6
	vpaddd	%ymm7, %ymm6, %ymm6
	vpmulld	%ymm4, %ymm6, %ymm7
	vpaddd	%ymm5, %ymm7, %ymm7
	vpsrad	$27, %ymm7, %ymm7
	vpmulld	%ymm3, %ymm7, %ymm7
	vpaddd	%ymm6, %ymm7, %ymm6
	vpshufb	%ymm0, %ymm6, %ymm6
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vmovdqa	%xmm6, 2896(%rsp,%rbp,2)
	addq	$8, %rbp
	cmpq	$856, %rbp              # imm = 0x358
	jne	.LBB2_1
# %bb.2:
	movswl	12384(%rsp), %eax
	leal	(%rax,%rax,2), %ecx
	imull	$153, %eax, %eax
	sarl	$18, %eax
	imull	$-5167, %eax, %eax      # imm = 0xEBD1
	addl	%ecx, %eax
	imull	$25976, %eax, %ecx      # imm = 0x6578
	addl	$67108864, %ecx         # imm = 0x4000000
	sarl	$27, %ecx
	imull	$-5167, %ecx, %ecx      # imm = 0xEBD1
	addl	%eax, %ecx
	movw	%cx, 4608(%rsp)
	leaq	430(%r15), %r12
	leaq	1967(%r15), %rax
	movq	%rax, (%rsp)            # 8-byte Spill
	vpbroadcastd	.LCPI2_6(%rip), %ymm1 # ymm1 = [10923,10923,10923,10923,10923,10923,10923,10923]
	vpbroadcastd	.LCPI2_7(%rip), %ymm2 # ymm2 = [16384,16384,16384,16384,16384,16384,16384,16384]
	movl	$24, %eax
	vpbroadcastd	.LCPI2_8(%rip), %ymm3 # ymm3 = [4294967293,4294967293,4294967293,4294967293,4294967293,4294967293,4294967293,4294967293]
	vmovdqa	.LCPI2_9(%rip), %xmm4   # xmm4 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	.p2align	4, 0x90
.LBB2_3:                                # =>This Inner Loop Header: Depth=1
	vpmovsxwd	2848(%rsp,%rax,2), %ymm5
	vpmovsxwd	2864(%rsp,%rax,2), %ymm6
	vpmovsxwd	2880(%rsp,%rax,2), %ymm7
	vpmovsxwd	2896(%rsp,%rax,2), %ymm8
	vpmulld	%ymm1, %ymm5, %ymm9
	vpmulld	%ymm1, %ymm6, %ymm10
	vpmulld	%ymm1, %ymm7, %ymm11
	vpmulld	%ymm1, %ymm8, %ymm12
	vpaddd	%ymm2, %ymm9, %ymm9
	vpaddd	%ymm2, %ymm10, %ymm10
	vpaddd	%ymm2, %ymm11, %ymm11
	vpaddd	%ymm2, %ymm12, %ymm12
	vpsrld	$15, %ymm9, %ymm9
	vpsrld	$15, %ymm10, %ymm10
	vpsrld	$15, %ymm11, %ymm11
	vpsrld	$15, %ymm12, %ymm12
	vpmulld	%ymm3, %ymm9, %ymm9
	vpmulld	%ymm3, %ymm10, %ymm10
	vpmulld	%ymm3, %ymm11, %ymm11
	vpmulld	%ymm3, %ymm12, %ymm12
	vpaddd	%ymm5, %ymm9, %ymm5
	vpaddd	%ymm6, %ymm10, %ymm6
	vpaddd	%ymm7, %ymm11, %ymm7
	vpaddd	%ymm8, %ymm12, %ymm8
	vpshufb	%ymm0, %ymm5, %ymm5
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpshufb	%ymm0, %ymm6, %ymm6
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpshufb	%ymm0, %ymm7, %ymm7
	vpermq	$232, %ymm7, %ymm7      # ymm7 = ymm7[0,2,2,3]
	vpshufb	%ymm0, %ymm8, %ymm8
	vpermq	$232, %ymm8, %ymm8      # ymm8 = ymm8[0,2,2,3]
	vpshufb	%xmm4, %xmm5, %xmm5
	vpshufb	%xmm4, %xmm6, %xmm6
	vpunpcklqdq	%xmm6, %xmm5, %xmm5 # xmm5 = xmm5[0],xmm6[0]
	vmovdqa	%xmm5, 2008(%rsp,%rax)
	vpshufb	%xmm4, %xmm7, %xmm5
	vpshufb	%xmm4, %xmm8, %xmm6
	vpunpcklqdq	%xmm6, %xmm5, %xmm5 # xmm5 = xmm5[0],xmm6[0]
	vmovdqa	%xmm5, 2024(%rsp,%rax)
	addq	$32, %rax
	cmpq	$856, %rax              # imm = 0x358
	jne	.LBB2_3
# %bb.4:
	movswl	4560(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2864(%rsp)
	movswl	4562(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2865(%rsp)
	movswl	4564(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2866(%rsp)
	movswl	4566(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2867(%rsp)
	movswl	4568(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2868(%rsp)
	movswl	4570(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2869(%rsp)
	movswl	4572(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2870(%rsp)
	movswl	4574(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2871(%rsp)
	movswl	4576(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2872(%rsp)
	movswl	4578(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2873(%rsp)
	movswl	4580(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2874(%rsp)
	movswl	4582(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2875(%rsp)
	movswl	4584(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2876(%rsp)
	movswl	4586(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2877(%rsp)
	movswl	4588(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2878(%rsp)
	movswl	4590(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2879(%rsp)
	movswl	4592(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2880(%rsp)
	movswl	4594(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2881(%rsp)
	movswl	4596(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2882(%rsp)
	movswl	4598(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2883(%rsp)
	movswl	4600(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2884(%rsp)
	movswl	4602(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2885(%rsp)
	movswl	4604(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2886(%rsp)
	movswl	4606(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2887(%rsp)
	movswl	4608(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2888(%rsp)
	leaq	80(%rsp), %rdi
	leaq	2032(%rsp), %rsi
	leaq	9808(%rsp), %rdx
	xorl	%ecx, %ecx
	vzeroupper
	callq	crypto_core_mult3sntrup857_avx@PLT
	vpxor	%xmm0, %xmm0, %xmm0
	movl	$24, %eax
	vmovdqa	.LCPI2_10(%rip), %xmm8  # xmm8 = [1,1,1,1,1,1,1,1]
	vpxor	%xmm2, %xmm2, %xmm2
	vpxor	%xmm3, %xmm3, %xmm3
	vpxor	%xmm4, %xmm4, %xmm4
	.p2align	4, 0x90
.LBB2_5:                                # =>This Inner Loop Header: Depth=1
	vpmovzxbw	56(%rsp,%rax), %xmm5 # xmm5 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	64(%rsp,%rax), %xmm6 # xmm6 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	72(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	80(%rsp,%rax), %xmm1 # xmm1 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpand	%xmm8, %xmm5, %xmm5
	vpackuswb	%xmm0, %xmm5, %xmm5
	vpand	%xmm8, %xmm6, %xmm6
	vpackuswb	%xmm0, %xmm6, %xmm6
	vpand	%xmm8, %xmm7, %xmm7
	vpackuswb	%xmm0, %xmm7, %xmm7
	vpand	%xmm8, %xmm1, %xmm1
	vpackuswb	%xmm0, %xmm1, %xmm1
	vpmovzxbd	%xmm5, %ymm5    # ymm5 = xmm5[0],zero,zero,zero,xmm5[1],zero,zero,zero,xmm5[2],zero,zero,zero,xmm5[3],zero,zero,zero,xmm5[4],zero,zero,zero,xmm5[5],zero,zero,zero,xmm5[6],zero,zero,zero,xmm5[7],zero,zero,zero
	vpaddd	%ymm5, %ymm0, %ymm0
	vpmovzxbd	%xmm6, %ymm5    # ymm5 = xmm6[0],zero,zero,zero,xmm6[1],zero,zero,zero,xmm6[2],zero,zero,zero,xmm6[3],zero,zero,zero,xmm6[4],zero,zero,zero,xmm6[5],zero,zero,zero,xmm6[6],zero,zero,zero,xmm6[7],zero,zero,zero
	vpaddd	%ymm5, %ymm2, %ymm2
	vpmovzxbd	%xmm7, %ymm5    # ymm5 = xmm7[0],zero,zero,zero,xmm7[1],zero,zero,zero,xmm7[2],zero,zero,zero,xmm7[3],zero,zero,zero,xmm7[4],zero,zero,zero,xmm7[5],zero,zero,zero,xmm7[6],zero,zero,zero,xmm7[7],zero,zero,zero
	vpaddd	%ymm5, %ymm3, %ymm3
	vpmovzxbd	%xmm1, %ymm1    # ymm1 = xmm1[0],zero,zero,zero,xmm1[1],zero,zero,zero,xmm1[2],zero,zero,zero,xmm1[3],zero,zero,zero,xmm1[4],zero,zero,zero,xmm1[5],zero,zero,zero,xmm1[6],zero,zero,zero,xmm1[7],zero,zero,zero
	vpaddd	%ymm1, %ymm4, %ymm4
	addq	$32, %rax
	cmpq	$856, %rax              # imm = 0x358
	jne	.LBB2_5
# %bb.6:
	vpaddd	%ymm0, %ymm2, %ymm0
	vpaddd	%ymm0, %ymm3, %ymm0
	vpaddd	%ymm0, %ymm4, %ymm0
	vextracti128	$1, %ymm0, %xmm1
	vpaddd	%ymm1, %ymm0, %ymm0
	vpshufd	$78, %xmm0, %xmm1       # xmm1 = xmm0[2,3,0,1]
	vpaddd	%ymm1, %ymm0, %ymm0
	vphaddd	%ymm0, %ymm0, %ymm0
	vmovd	%xmm0, %eax
	movzbl	912(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	913(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	914(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	915(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	916(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	917(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	918(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	919(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	920(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	921(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	922(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	923(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	924(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	925(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	926(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	927(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	928(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	929(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	930(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	931(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	932(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	933(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	934(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	935(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	936(%rsp), %ecx
	andl	$1, %ecx
	leal	(%rcx,%rax), %eax
	addl	$65214, %eax            # imm = 0xFEBE
	movzwl	%ax, %esi
	negl	%esi
	sarl	$31, %esi
	vmovd	%esi, %xmm0
	vpbroadcastb	%xmm0, %ymm0
	vmovdqu	80(%rsp), %ymm1
	vmovdqu	112(%rsp), %ymm2
	vmovdqu	144(%rsp), %ymm3
	vmovdqa	.LCPI2_11(%rip), %ymm4  # ymm4 = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]
	vpblendvb	%ymm0, %ymm4, %ymm1, %ymm1
	vpblendvb	%ymm0, %ymm4, %ymm2, %ymm2
	vpblendvb	%ymm0, %ymm4, %ymm3, %ymm3
	vmovdqu	176(%rsp), %ymm5
	vpblendvb	%ymm0, %ymm4, %ymm5, %ymm5
	vmovdqu	%ymm1, 1168(%rsp)
	vmovdqu	%ymm2, 1200(%rsp)
	vmovdqu	%ymm3, 1232(%rsp)
	vmovdqu	%ymm5, 1264(%rsp)
	vmovdqu	208(%rsp), %ymm1
	vmovdqu	240(%rsp), %ymm2
	vmovdqu	272(%rsp), %ymm3
	vpblendvb	%ymm0, %ymm4, %ymm1, %ymm1
	vpblendvb	%ymm0, %ymm4, %ymm2, %ymm2
	vpblendvb	%ymm0, %ymm4, %ymm3, %ymm3
	vmovdqu	304(%rsp), %ymm5
	vpblendvb	%ymm0, %ymm4, %ymm5, %ymm0
	vmovdqu	%ymm1, 1296(%rsp)
	vmovdqu	%ymm2, 1328(%rsp)
	vmovdqu	%ymm3, 1360(%rsp)
	vmovdqu	%ymm0, 1392(%rsp)
	xorl	%ecx, %ecx
	.p2align	4, 0x90
.LBB2_7:                                # =>This Inner Loop Header: Depth=1
	movzbl	336(%rsp,%rcx), %eax
	movzbl	337(%rsp,%rcx), %ebx
	movl	%eax, %edx
	xorb	$1, %dl
	andb	%sil, %dl
	xorb	%al, %dl
	movb	%dl, 1424(%rsp,%rcx)
	movl	%ebx, %eax
	xorb	$1, %al
	andb	%sil, %al
	xorb	%bl, %al
	movb	%al, 1425(%rsp,%rcx)
	movzbl	338(%rsp,%rcx), %eax
	movl	%eax, %edx
	xorb	$1, %dl
	andb	%sil, %dl
	xorb	%al, %dl
	movb	%dl, 1426(%rsp,%rcx)
	addq	$3, %rcx
	cmpq	$66, %rcx
	jne	.LBB2_7
# %bb.8:
	notb	%sil
	vmovd	%esi, %xmm0
	vpbroadcastb	%xmm0, %ymm0
	vpand	402(%rsp), %ymm0, %ymm1
	vpand	434(%rsp), %ymm0, %ymm2
	vpand	466(%rsp), %ymm0, %ymm3
	vpand	498(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 1490(%rsp)
	vmovdqu	%ymm2, 1522(%rsp)
	vmovdqu	%ymm3, 1554(%rsp)
	vmovdqu	%ymm4, 1586(%rsp)
	vpand	530(%rsp), %ymm0, %ymm1
	vpand	562(%rsp), %ymm0, %ymm2
	vpand	594(%rsp), %ymm0, %ymm3
	vpand	626(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 1618(%rsp)
	vmovdqu	%ymm2, 1650(%rsp)
	vmovdqu	%ymm3, 1682(%rsp)
	vmovdqu	%ymm4, 1714(%rsp)
	vpand	658(%rsp), %ymm0, %ymm1
	vpand	690(%rsp), %ymm0, %ymm2
	vpand	722(%rsp), %ymm0, %ymm3
	vpand	754(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 1746(%rsp)
	vmovdqu	%ymm2, 1778(%rsp)
	vmovdqu	%ymm3, 1810(%rsp)
	vmovdqu	%ymm4, 1842(%rsp)
	vpand	786(%rsp), %ymm0, %ymm1
	vpand	818(%rsp), %ymm0, %ymm2
	vpand	850(%rsp), %ymm0, %ymm3
	vpand	882(%rsp), %ymm0, %ymm0
	vmovdqu	%ymm1, 1874(%rsp)
	vmovdqu	%ymm2, 1906(%rsp)
	vmovdqu	%ymm3, 1938(%rsp)
	vmovdqu	%ymm0, 1970(%rsp)
	movb	914(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2002(%rsp)
	movb	915(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2003(%rsp)
	movb	916(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2004(%rsp)
	movb	917(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2005(%rsp)
	movb	918(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2006(%rsp)
	movb	919(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2007(%rsp)
	movb	920(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2008(%rsp)
	movb	921(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2009(%rsp)
	movb	922(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2010(%rsp)
	movb	923(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2011(%rsp)
	movb	924(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2012(%rsp)
	movb	925(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2013(%rsp)
	movb	926(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2014(%rsp)
	movb	927(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2015(%rsp)
	movb	928(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2016(%rsp)
	movb	929(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2017(%rsp)
	movb	930(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2018(%rsp)
	movb	931(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2019(%rsp)
	movb	932(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2020(%rsp)
	movb	933(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2021(%rsp)
	movb	934(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2022(%rsp)
	movb	935(%rsp), %cl
	andb	%sil, %cl
	movb	%cl, 2023(%rsp)
	andb	936(%rsp), %sil
	movb	%sil, 2024(%rsp)
	leaq	945(%rsp), %rdi
	leaq	1168(%rsp), %rbx
	movq	%rbx, %rsi
	vzeroupper
	callq	crypto_encode_857x3_ref@PLT
	leaq	8080(%rsp), %rbp
	movq	%rbp, %rdi
	movq	%r12, %rsi
	callq	crypto_decode_857x5167_avx@PLT
	leaq	6352(%rsp), %r12
	movq	%r12, %rdi
	movq	%rbp, %rsi
	callq	crypto_encode_857xint16_little@PLT
	leaq	4624(%rsp), %r13
	xorl	%ecx, %ecx
	movq	%r13, %rdi
	movq	%r12, %rsi
	movq	%rbx, %rdx
	callq	crypto_core_multsntrup857_avx@PLT
	leaq	14992(%rsp), %rbp
	movq	%rbp, %rdi
	movq	%r13, %rsi
	callq	crypto_decode_857xint16_little@PLT
	leaq	4624(%rsp), %rdi
	movq	%rbp, %rsi
	callq	crypto_encode_857x1723round_ref@PLT
	movb	$3, 944(%rsp)
	leaq	16(%rsp), %rbp
	leaq	944(%rsp), %rsi
	movl	$216, %edx
	movq	%rbp, %rdi
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	16(%rsp), %ymm0
	vmovups	%ymm0, 6353(%rsp)
	movq	(%rsp), %rax            # 8-byte Reload
	vmovups	(%rax), %ymm0
	vmovups	%ymm0, 6385(%rsp)
	movb	$2, 6352(%rsp)
	leaq	6352(%rsp), %rsi
	movl	$65, %edx
	movq	%rbp, %rdi
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovdqu	16(%rsp), %ymm0
	vmovdqu	%ymm0, 5776(%rsp)
	vpxor	%xmm0, %xmm0, %xmm0
	movl	$24, %eax
	vpxor	%xmm1, %xmm1, %xmm1
	vpxor	%xmm2, %xmm2, %xmm2
	vpxor	%xmm3, %xmm3, %xmm3
	.p2align	4, 0x90
.LBB2_9:                                # =>This Inner Loop Header: Depth=1
	vpmovzxbw	-24(%r14,%rax), %xmm4 # xmm4 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	-16(%r14,%rax), %xmm5 # xmm5 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	-8(%r14,%rax), %xmm6 # xmm6 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	(%r14,%rax), %xmm8 # xmm8 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	4600(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm4, %xmm7, %xmm4
	vpackuswb	%xmm0, %xmm4, %xmm4
	vpmovzxbw	4608(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm5, %xmm7, %xmm5
	vpackuswb	%xmm0, %xmm5, %xmm5
	vpmovzxbw	4616(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm6, %xmm7, %xmm6
	vpackuswb	%xmm0, %xmm6, %xmm6
	vpmovzxbw	4624(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm8, %xmm7, %xmm7
	vpackuswb	%xmm0, %xmm7, %xmm7
	vpmovzxbd	%xmm4, %ymm4    # ymm4 = xmm4[0],zero,zero,zero,xmm4[1],zero,zero,zero,xmm4[2],zero,zero,zero,xmm4[3],zero,zero,zero,xmm4[4],zero,zero,zero,xmm4[5],zero,zero,zero,xmm4[6],zero,zero,zero,xmm4[7],zero,zero,zero
	vpor	%ymm4, %ymm0, %ymm0
	vpmovzxbd	%xmm5, %ymm4    # ymm4 = xmm5[0],zero,zero,zero,xmm5[1],zero,zero,zero,xmm5[2],zero,zero,zero,xmm5[3],zero,zero,zero,xmm5[4],zero,zero,zero,xmm5[5],zero,zero,zero,xmm5[6],zero,zero,zero,xmm5[7],zero,zero,zero
	vpor	%ymm4, %ymm1, %ymm1
	vpmovzxbd	%xmm6, %ymm4    # ymm4 = xmm6[0],zero,zero,zero,xmm6[1],zero,zero,zero,xmm6[2],zero,zero,zero,xmm6[3],zero,zero,zero,xmm6[4],zero,zero,zero,xmm6[5],zero,zero,zero,xmm6[6],zero,zero,zero,xmm6[7],zero,zero,zero
	vpor	%ymm4, %ymm2, %ymm2
	vpmovzxbd	%xmm7, %ymm4    # ymm4 = xmm7[0],zero,zero,zero,xmm7[1],zero,zero,zero,xmm7[2],zero,zero,zero,xmm7[3],zero,zero,zero,xmm7[4],zero,zero,zero,xmm7[5],zero,zero,zero,xmm7[6],zero,zero,zero,xmm7[7],zero,zero,zero
	vpor	%ymm4, %ymm3, %ymm3
	addq	$32, %rax
	cmpq	$1208, %rax             # imm = 0x4B8
	jne	.LBB2_9
# %bb.10:
	vpor	%ymm0, %ymm1, %ymm0
	vpor	%ymm0, %ymm2, %ymm0
	vpor	%ymm0, %ymm3, %ymm0
	vextracti128	$1, %ymm0, %xmm1
	vpor	%ymm1, %ymm0, %ymm0
	vpshufd	$78, %xmm0, %xmm1       # xmm1 = xmm0[2,3,0,1]
	vpor	%ymm1, %ymm0, %ymm0
	vpshufd	$229, %xmm0, %xmm1      # xmm1 = xmm0[1,1,2,3]
	vpor	%ymm1, %ymm0, %ymm0
	vmovd	%xmm0, %ebp
	addl	$-1, %ebp
	shrl	$8, %ebp
	andb	$1, %bpl
	movl	%ebp, %esi
	addb	$-1, %sil
	vmovd	%esi, %xmm0
	vpbroadcastb	%xmm0, %ymm0
	vmovdqu	945(%rsp), %ymm1
	vmovdqu	977(%rsp), %ymm2
	vpblendvb	%ymm0, 1752(%r15), %ymm1, %ymm1
	vmovdqu	1009(%rsp), %ymm3
	vpblendvb	%ymm0, 1784(%r15), %ymm2, %ymm2
	vmovdqu	1041(%rsp), %ymm4
	vpblendvb	%ymm0, 1816(%r15), %ymm3, %ymm3
	vpblendvb	%ymm0, 1848(%r15), %ymm4, %ymm0
	vmovdqu	%ymm1, 945(%rsp)
	vmovdqu	%ymm2, 977(%rsp)
	vmovdqu	%ymm3, 1009(%rsp)
	vmovdqu	%ymm0, 1041(%rsp)
	xorl	%ecx, %ecx
	.p2align	4, 0x90
.LBB2_11:                               # =>This Inner Loop Header: Depth=1
	movzbl	1073(%rsp,%rcx), %edx
	movzbl	1074(%rsp,%rcx), %ebx
	movzbl	1880(%r15,%rcx), %eax
	xorb	%dl, %al
	andb	%sil, %al
	xorb	%dl, %al
	movb	%al, 1073(%rsp,%rcx)
	movzbl	1881(%r15,%rcx), %eax
	xorb	%bl, %al
	andb	%sil, %al
	xorb	%bl, %al
	movb	%al, 1074(%rsp,%rcx)
	movzbl	1075(%rsp,%rcx), %eax
	movzbl	1882(%r15,%rcx), %edx
	xorb	%al, %dl
	andb	%sil, %dl
	xorb	%al, %dl
	movb	%dl, 1075(%rsp,%rcx)
	addq	$3, %rcx
	cmpq	$87, %rcx
	jne	.LBB2_11
# %bb.12:
	movb	$3, 944(%rsp)
	leaq	16(%rsp), %rbx
	leaq	944(%rsp), %rsi
	movl	$216, %edx
	movq	%rbx, %rdi
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	16(%rsp), %ymm0
	vmovups	%ymm0, 8081(%rsp)
	leaq	8113(%rsp), %rdi
	movl	$1184, %edx             # imm = 0x4A0
	movq	%r14, %rsi
	vzeroupper
	callq	memcpy@PLT
	movb	%bpl, 8080(%rsp)
	leaq	8080(%rsp), %rsi
	movl	$1217, %edx             # imm = 0x4C1
	movq	%rbx, %rdi
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	16(%rsp), %ymm0
	movq	8(%rsp), %rax           # 8-byte Reload
	vmovups	%ymm0, (%rax)
	xorl	%eax, %eax
	addq	$16712, %rsp            # imm = 0x4148
	.cfi_def_cfa_offset 56
	popq	%rbx
	.cfi_def_cfa_offset 48
	popq	%r12
	.cfi_def_cfa_offset 40
	popq	%r13
	.cfi_def_cfa_offset 32
	popq	%r14
	.cfi_def_cfa_offset 24
	popq	%r15
	.cfi_def_cfa_offset 16
	popq	%rbp
	.cfi_def_cfa_offset 8
	vzeroupper
	retq
.Lfunc_end2:
	.size	crypto_kem_dec, .Lfunc_end2-crypto_kem_dec
	.cfi_endproc
                                        # -- End function

	.ident	"clang version 7.0.1-8 (tags/RELEASE_701/final)"
	.section	".note.GNU-stack","",@progbits
