	.text
	.file	"kem.c"
	.section	.rodata.cst8,"aM",@progbits,8
	.p2align	3               # -- Begin function crypto_kem_keypair
.LCPI0_0:
	.quad	464722                  # 0x71752
	.section	.rodata.cst4,"aM",@progbits,4
	.p2align	2
.LCPI0_1:
	.long	4294962675              # 0xffffedf3
.LCPI0_2:
	.long	4621                    # 0x120d
.LCPI0_5:
	.long	4294967294              # 0xfffffffe
.LCPI0_6:
	.long	4294967292              # 0xfffffffc
.LCPI0_7:
	.long	1                       # 0x1
	.section	.rodata.cst32,"aM",@progbits,32
	.p2align	5
.LCPI0_3:
	.byte	0                       # 0x0
	.byte	1                       # 0x1
	.byte	4                       # 0x4
	.byte	5                       # 0x5
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	14                      # 0xe
	.byte	15                      # 0xf
	.byte	16                      # 0x10
	.byte	17                      # 0x11
	.byte	20                      # 0x14
	.byte	21                      # 0x15
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	30                      # 0x1e
	.byte	31                      # 0x1f
	.section	.rodata.cst16,"aM",@progbits,16
	.p2align	4
.LCPI0_4:
	.short	63226                   # 0xf6fa
	.short	63226                   # 0xf6fa
	.short	63226                   # 0xf6fa
	.short	63226                   # 0xf6fa
	.short	63226                   # 0xf6fa
	.short	63226                   # 0xf6fa
	.short	63226                   # 0xf6fa
	.short	63226                   # 0xf6fa
.LCPI0_8:
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
.LCPI0_9:
	.byte	0                       # 0x0
	.byte	2                       # 0x2
	.byte	4                       # 0x4
	.byte	6                       # 0x6
	.byte	8                       # 0x8
	.byte	10                      # 0xa
	.byte	12                      # 0xc
	.byte	14                      # 0xe
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.text
	.globl	crypto_kem_keypair
	.p2align	4, 0x90
	.type	crypto_kem_keypair,@function
crypto_kem_keypair:                     # @crypto_kem_keypair
	.cfi_startproc
# %bb.0:
	pushq	%r15
	.cfi_def_cfa_offset 16
	pushq	%r14
	.cfi_def_cfa_offset 24
	pushq	%r13
	.cfi_def_cfa_offset 32
	pushq	%r12
	.cfi_def_cfa_offset 40
	pushq	%rbx
	.cfi_def_cfa_offset 48
	subq	$8528, %rsp             # imm = 0x2150
	.cfi_def_cfa_offset 8576
	.cfi_offset %rbx, -48
	.cfi_offset %r12, -40
	.cfi_offset %r13, -32
	.cfi_offset %r14, -24
	.cfi_offset %r15, -16
	movq	%rsi, %r14
	movq	%rdi, %rbx
	movl	$32, %esi
	callq	randombytes@PLT
	leaq	aes_nonce(%rip), %rdx
	movq	%rsp, %r15
	movl	$2612, %esi             # imm = 0xA34
	movq	%r15, %rdi
	movq	%rbx, %rcx
	callq	crypto_stream_aes256ctr_openssl@PLT
	movq	%r15, %rdi
	movq	%r15, %rsi
	callq	crypto_decode_653xint32_little@PLT
	xorl	%eax, %eax
	vpbroadcastq	.LCPI0_0(%rip), %ymm0 # ymm0 = [464722,464722,464722,464722]
	vpbroadcastd	.LCPI0_1(%rip), %ymm1 # ymm1 = [4294962675,4294962675,4294962675,4294962675,4294962675,4294962675,4294962675,4294962675]
	vpbroadcastd	.LCPI0_2(%rip), %ymm2 # ymm2 = [4621,4621,4621,4621,4621,4621,4621,4621]
	vmovdqa	.LCPI0_4(%rip), %xmm3   # xmm3 = [63226,63226,63226,63226,63226,63226,63226,63226]
	.p2align	4, 0x90
.LBB0_1:                                # =>This Inner Loop Header: Depth=1
	vmovdqu	(%rsp,%rax,4), %ymm4
	vextracti128	$1, %ymm4, %xmm5
	vpmovzxdq	%xmm5, %ymm5    # ymm5 = xmm5[0],zero,xmm5[1],zero,xmm5[2],zero,xmm5[3],zero
	vpmovzxdq	%xmm4, %ymm6    # ymm6 = xmm4[0],zero,xmm4[1],zero,xmm4[2],zero,xmm4[3],zero
	vpmuludq	%ymm0, %ymm6, %ymm6
	vpmuludq	%ymm0, %ymm5, %ymm5
	vpsrlq	$31, %ymm5, %ymm5
	vpsrlq	$31, %ymm6, %ymm6
	vpshufd	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpshufd	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vinserti128	$1, %xmm5, %ymm6, %ymm5
	vpmulld	%ymm1, %ymm5, %ymm5
	vpaddd	%ymm4, %ymm5, %ymm4
	vextracti128	$1, %ymm4, %xmm5
	vpmovzxdq	%xmm5, %ymm5    # ymm5 = xmm5[0],zero,xmm5[1],zero,xmm5[2],zero,xmm5[3],zero
	vpmovzxdq	%xmm4, %ymm6    # ymm6 = xmm4[0],zero,xmm4[1],zero,xmm4[2],zero,xmm4[3],zero
	vpmuludq	%ymm0, %ymm6, %ymm6
	vpmuludq	%ymm0, %ymm5, %ymm5
	vpsrlq	$31, %ymm5, %ymm5
	vpsrlq	$31, %ymm6, %ymm6
	vpshufd	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpshufd	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vinserti128	$1, %xmm5, %ymm6, %ymm5
	vpmulld	%ymm1, %ymm5, %ymm5
	vpaddd	%ymm1, %ymm4, %ymm4
	vpaddd	%ymm4, %ymm5, %ymm4
	vpsrad	$31, %ymm4, %ymm5
	vpand	%ymm2, %ymm5, %ymm5
	vpaddd	%ymm4, %ymm5, %ymm4
	vpshufb	.LCPI0_3(%rip), %ymm4, %ymm4 # ymm4 = ymm4[0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vpaddw	%xmm3, %xmm4, %xmm4
	vmovdqa	%xmm4, 5904(%rsp,%rax,2)
	addq	$8, %rax
	cmpq	$648, %rax              # imm = 0x288
	jne	.LBB0_1
# %bb.2:
	movl	2592(%rsp), %ecx
	movl	2596(%rsp), %eax
	imulq	$464722, %rcx, %rdx     # imm = 0x71752
	shrq	$31, %rdx
	imull	$-4621, %edx, %edx      # imm = 0xEDF3
	addl	%ecx, %edx
	imulq	$464722, %rdx, %rcx     # imm = 0x71752
	shrq	$31, %rcx
	imull	$-4621, %ecx, %ecx      # imm = 0xEDF3
	leal	(%rcx,%rdx), %esi
	addl	$-4621, %esi            # imm = 0xEDF3
                                        # kill: def $edx killed $edx killed $rdx def $rdx
	addl	%ecx, %edx
	sarl	$31, %esi
	andl	$4621, %esi             # imm = 0x120D
	leal	(%rsi,%rdx), %ecx
	addl	$-6931, %ecx            # imm = 0xE4ED
	movw	%cx, 7200(%rsp)
	imulq	$464722, %rax, %rcx     # imm = 0x71752
	shrq	$31, %rcx
	imull	$-4621, %ecx, %ecx      # imm = 0xEDF3
	addl	%eax, %ecx
	imulq	$464722, %rcx, %rax     # imm = 0x71752
	shrq	$31, %rax
	imull	$-4621, %eax, %eax      # imm = 0xEDF3
	leal	(%rax,%rcx), %edx
	addl	$-4621, %edx            # imm = 0xEDF3
                                        # kill: def $ecx killed $ecx killed $rcx def $rcx
	addl	%eax, %ecx
	sarl	$31, %edx
	andl	$4621, %edx             # imm = 0x120D
	leal	(%rdx,%rcx), %eax
	addl	$-6931, %eax            # imm = 0xE4ED
	movw	%ax, 7202(%rsp)
	movl	2600(%rsp), %eax
	imulq	$464722, %rax, %rcx     # imm = 0x71752
	shrq	$31, %rcx
	imull	$-4621, %ecx, %ecx      # imm = 0xEDF3
	addl	%eax, %ecx
	imulq	$464722, %rcx, %rax     # imm = 0x71752
	shrq	$31, %rax
	imull	$-4621, %eax, %eax      # imm = 0xEDF3
	leal	(%rax,%rcx), %edx
	addl	$-4621, %edx            # imm = 0xEDF3
                                        # kill: def $ecx killed $ecx killed $rcx def $rcx
	addl	%eax, %ecx
	sarl	$31, %edx
	andl	$4621, %edx             # imm = 0x120D
	leal	(%rdx,%rcx), %eax
	addl	$-6931, %eax            # imm = 0xE4ED
	movw	%ax, 7204(%rsp)
	movl	2604(%rsp), %eax
	imulq	$464722, %rax, %rcx     # imm = 0x71752
	shrq	$31, %rcx
	imull	$-4621, %ecx, %ecx      # imm = 0xEDF3
	addl	%eax, %ecx
	imulq	$464722, %rcx, %rax     # imm = 0x71752
	shrq	$31, %rax
	imull	$-4621, %eax, %eax      # imm = 0xEDF3
	leal	(%rax,%rcx), %edx
	addl	$-4621, %edx            # imm = 0xEDF3
                                        # kill: def $ecx killed $ecx killed $rcx def $rcx
	addl	%eax, %ecx
	sarl	$31, %edx
	andl	$4621, %edx             # imm = 0x120D
	leal	(%rdx,%rcx), %eax
	addl	$-6931, %eax            # imm = 0xE4ED
	movw	%ax, 7206(%rsp)
	movl	2608(%rsp), %eax
	imulq	$464722, %rax, %rcx     # imm = 0x71752
	shrq	$31, %rcx
	imull	$-4621, %ecx, %ecx      # imm = 0xEDF3
	addl	%eax, %ecx
	imulq	$464722, %rcx, %rax     # imm = 0x71752
	shrq	$31, %rax
	imull	$-4621, %eax, %eax      # imm = 0xEDF3
	leal	(%rax,%rcx), %edx
	addl	$-4621, %edx            # imm = 0xEDF3
                                        # kill: def $ecx killed $ecx killed $rcx def $rcx
	addl	%eax, %ecx
	sarl	$31, %edx
	andl	$4621, %edx             # imm = 0x120D
	leal	(%rdx,%rcx), %eax
	addl	$-6931, %eax            # imm = 0xE4ED
	movw	%ax, 7208(%rsp)
	leaq	2624(%rsp), %r15
	movl	$2612, %esi             # imm = 0xA34
	movq	%r15, %rdi
	vzeroupper
	callq	randombytes@PLT
	movq	%r15, %rdi
	movq	%r15, %rsi
	callq	crypto_decode_653xint32_little@PLT
	vbroadcastss	.LCPI0_5(%rip), %ymm0 # ymm0 = [4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294]
	vandps	2624(%rsp), %ymm0, %ymm1
	vandps	2656(%rsp), %ymm0, %ymm2
	vandps	2688(%rsp), %ymm0, %ymm3
	vandps	2720(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, (%rsp)
	vmovups	%ymm2, 32(%rsp)
	vmovups	%ymm3, 64(%rsp)
	vmovups	%ymm4, 96(%rsp)
	vandps	2752(%rsp), %ymm0, %ymm1
	vandps	2784(%rsp), %ymm0, %ymm2
	vandps	2816(%rsp), %ymm0, %ymm3
	vandps	2848(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 128(%rsp)
	vmovups	%ymm2, 160(%rsp)
	vmovups	%ymm3, 192(%rsp)
	vmovups	%ymm4, 224(%rsp)
	vandps	2880(%rsp), %ymm0, %ymm1
	vandps	2912(%rsp), %ymm0, %ymm2
	vandps	2944(%rsp), %ymm0, %ymm3
	vandps	2976(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 256(%rsp)
	vmovups	%ymm2, 288(%rsp)
	vmovups	%ymm3, 320(%rsp)
	vmovups	%ymm4, 352(%rsp)
	vandps	3008(%rsp), %ymm0, %ymm1
	vandps	3040(%rsp), %ymm0, %ymm2
	vandps	3072(%rsp), %ymm0, %ymm3
	vandps	3104(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 384(%rsp)
	vmovups	%ymm2, 416(%rsp)
	vmovups	%ymm3, 448(%rsp)
	vmovups	%ymm4, 480(%rsp)
	vandps	3136(%rsp), %ymm0, %ymm1
	vandps	3168(%rsp), %ymm0, %ymm2
	vandps	3200(%rsp), %ymm0, %ymm3
	vandps	3232(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 512(%rsp)
	vmovups	%ymm2, 544(%rsp)
	vmovups	%ymm3, 576(%rsp)
	vmovups	%ymm4, 608(%rsp)
	vandps	3264(%rsp), %ymm0, %ymm1
	vandps	3296(%rsp), %ymm0, %ymm2
	vandps	3328(%rsp), %ymm0, %ymm3
	vandps	3360(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 640(%rsp)
	vmovups	%ymm2, 672(%rsp)
	vmovups	%ymm3, 704(%rsp)
	vmovups	%ymm4, 736(%rsp)
	vandps	3392(%rsp), %ymm0, %ymm1
	vandps	3424(%rsp), %ymm0, %ymm2
	vandps	3456(%rsp), %ymm0, %ymm3
	vandps	3488(%rsp), %ymm0, %ymm0
	vmovups	%ymm1, 768(%rsp)
	vmovups	%ymm2, 800(%rsp)
	vmovups	%ymm3, 832(%rsp)
	vmovups	%ymm0, 864(%rsp)
	movl	3520(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 896(%rsp)
	movl	3524(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 900(%rsp)
	movl	3528(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 904(%rsp)
	movl	3532(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 908(%rsp)
	movl	3536(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 912(%rsp)
	movl	3540(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 916(%rsp)
	movl	3544(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 920(%rsp)
	movl	3548(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 924(%rsp)
	movl	3552(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 928(%rsp)
	movl	3556(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 932(%rsp)
	movl	3560(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 936(%rsp)
	movl	3564(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 940(%rsp)
	movl	3568(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 944(%rsp)
	movl	3572(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 948(%rsp)
	movl	3576(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 952(%rsp)
	movl	3580(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 956(%rsp)
	movl	3584(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 960(%rsp)
	movl	3588(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 964(%rsp)
	movl	3592(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 968(%rsp)
	movl	3596(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 972(%rsp)
	movl	3600(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 976(%rsp)
	movl	3604(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 980(%rsp)
	movl	3608(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 984(%rsp)
	movl	3612(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 988(%rsp)
	movl	3616(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 992(%rsp)
	movl	3620(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 996(%rsp)
	movl	3624(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1000(%rsp)
	movl	3628(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1004(%rsp)
	vpbroadcastd	.LCPI0_6(%rip), %ymm0 # ymm0 = [4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292]
	vpand	3632(%rsp), %ymm0, %ymm2
	vpand	3664(%rsp), %ymm0, %ymm3
	vpand	3696(%rsp), %ymm0, %ymm4
	vpand	3728(%rsp), %ymm0, %ymm5
	vpbroadcastd	.LCPI0_7(%rip), %ymm1 # ymm1 = [1,1,1,1,1,1,1,1]
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1008(%rsp)
	vmovdqu	%ymm3, 1040(%rsp)
	vmovdqu	%ymm4, 1072(%rsp)
	vmovdqu	%ymm5, 1104(%rsp)
	vpand	3760(%rsp), %ymm0, %ymm2
	vpand	3792(%rsp), %ymm0, %ymm3
	vpand	3824(%rsp), %ymm0, %ymm4
	vpand	3856(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1136(%rsp)
	vmovdqu	%ymm3, 1168(%rsp)
	vmovdqu	%ymm4, 1200(%rsp)
	vmovdqu	%ymm5, 1232(%rsp)
	vpand	3888(%rsp), %ymm0, %ymm2
	vpand	3920(%rsp), %ymm0, %ymm3
	vpand	3952(%rsp), %ymm0, %ymm4
	vpand	3984(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1264(%rsp)
	vmovdqu	%ymm3, 1296(%rsp)
	vmovdqu	%ymm4, 1328(%rsp)
	vmovdqu	%ymm5, 1360(%rsp)
	vpand	4016(%rsp), %ymm0, %ymm2
	vpand	4048(%rsp), %ymm0, %ymm3
	vpand	4080(%rsp), %ymm0, %ymm4
	vpand	4112(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1392(%rsp)
	vmovdqu	%ymm3, 1424(%rsp)
	vmovdqu	%ymm4, 1456(%rsp)
	vmovdqu	%ymm5, 1488(%rsp)
	vpand	4144(%rsp), %ymm0, %ymm2
	vpand	4176(%rsp), %ymm0, %ymm3
	vpand	4208(%rsp), %ymm0, %ymm4
	vpand	4240(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1520(%rsp)
	vmovdqu	%ymm3, 1552(%rsp)
	vmovdqu	%ymm4, 1584(%rsp)
	vmovdqu	%ymm5, 1616(%rsp)
	vpand	4272(%rsp), %ymm0, %ymm2
	vpand	4304(%rsp), %ymm0, %ymm3
	vpand	4336(%rsp), %ymm0, %ymm4
	vpand	4368(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1648(%rsp)
	vmovdqu	%ymm3, 1680(%rsp)
	vmovdqu	%ymm4, 1712(%rsp)
	vmovdqu	%ymm5, 1744(%rsp)
	vpand	4400(%rsp), %ymm0, %ymm2
	vpand	4432(%rsp), %ymm0, %ymm3
	vpand	4464(%rsp), %ymm0, %ymm4
	vpand	4496(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1776(%rsp)
	vmovdqu	%ymm3, 1808(%rsp)
	vmovdqu	%ymm4, 1840(%rsp)
	vmovdqu	%ymm5, 1872(%rsp)
	vpand	4528(%rsp), %ymm0, %ymm2
	vpand	4560(%rsp), %ymm0, %ymm3
	vpand	4592(%rsp), %ymm0, %ymm4
	vpand	4624(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1904(%rsp)
	vmovdqu	%ymm3, 1936(%rsp)
	vmovdqu	%ymm4, 1968(%rsp)
	vmovdqu	%ymm5, 2000(%rsp)
	vpand	4656(%rsp), %ymm0, %ymm2
	vpand	4688(%rsp), %ymm0, %ymm3
	vpand	4720(%rsp), %ymm0, %ymm4
	vpand	4752(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2032(%rsp)
	vmovdqu	%ymm3, 2064(%rsp)
	vmovdqu	%ymm4, 2096(%rsp)
	vmovdqu	%ymm5, 2128(%rsp)
	vpand	4784(%rsp), %ymm0, %ymm2
	vpand	4816(%rsp), %ymm0, %ymm3
	vpand	4848(%rsp), %ymm0, %ymm4
	vpand	4880(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2160(%rsp)
	vmovdqu	%ymm3, 2192(%rsp)
	vmovdqu	%ymm4, 2224(%rsp)
	vmovdqu	%ymm5, 2256(%rsp)
	vpand	4912(%rsp), %ymm0, %ymm2
	vpand	4944(%rsp), %ymm0, %ymm3
	vpand	4976(%rsp), %ymm0, %ymm4
	vpand	5008(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2288(%rsp)
	vmovdqu	%ymm3, 2320(%rsp)
	vmovdqu	%ymm4, 2352(%rsp)
	vmovdqu	%ymm5, 2384(%rsp)
	vpand	5040(%rsp), %ymm0, %ymm2
	vpand	5072(%rsp), %ymm0, %ymm3
	vpand	5104(%rsp), %ymm0, %ymm4
	vpand	5136(%rsp), %ymm0, %ymm0
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm0, %ymm0
	vmovdqu	%ymm2, 2416(%rsp)
	vmovdqu	%ymm3, 2448(%rsp)
	vmovdqu	%ymm4, 2480(%rsp)
	vmovdqu	%ymm0, 2512(%rsp)
	movl	5168(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2544(%rsp)
	movl	5172(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2548(%rsp)
	movl	5176(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2552(%rsp)
	movl	5180(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2556(%rsp)
	movl	5184(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2560(%rsp)
	movl	5188(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2564(%rsp)
	movl	5192(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2568(%rsp)
	movl	5196(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2572(%rsp)
	movl	5200(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2576(%rsp)
	movl	5204(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2580(%rsp)
	movl	5208(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2584(%rsp)
	movl	5212(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2588(%rsp)
	movl	5216(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2592(%rsp)
	movl	5220(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2596(%rsp)
	movl	5224(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2600(%rsp)
	movl	5228(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2604(%rsp)
	movl	5232(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2608(%rsp)
	movq	%rsp, %rdi
	movl	$653, %esi              # imm = 0x28D
	vzeroupper
	callq	crypto_sort_uint32_useint32@PLT
	vmovdqa	.LCPI0_3(%rip), %ymm7   # ymm7 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	movl	$24, %eax
	vmovdqa	.LCPI0_8(%rip), %xmm0   # xmm0 = [3,3,3,3,3,3,3,3]
	vpcmpeqd	%xmm1, %xmm1, %xmm1
	vmovdqa	.LCPI0_9(%rip), %xmm2   # xmm2 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	.p2align	4, 0x90
.LBB0_3:                                # =>This Inner Loop Header: Depth=1
	vmovdqu	-96(%rsp,%rax,4), %ymm3
	vmovdqu	-64(%rsp,%rax,4), %ymm4
	vmovdqu	-32(%rsp,%rax,4), %ymm5
	vmovdqu	(%rsp,%rax,4), %ymm6
	vpshufb	%ymm7, %ymm3, %ymm3
	vpermq	$232, %ymm3, %ymm3      # ymm3 = ymm3[0,2,2,3]
	vpshufb	%ymm7, %ymm4, %ymm4
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vpshufb	%ymm7, %ymm5, %ymm5
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpshufb	%ymm7, %ymm6, %ymm6
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpand	%xmm0, %xmm3, %xmm3
	vpand	%xmm0, %xmm4, %xmm4
	vpand	%xmm0, %xmm5, %xmm5
	vpand	%xmm0, %xmm6, %xmm6
	vpaddb	%xmm1, %xmm3, %xmm3
	vpshufb	%xmm2, %xmm3, %xmm3
	vpaddb	%xmm1, %xmm4, %xmm4
	vpshufb	%xmm2, %xmm4, %xmm4
	vpunpcklqdq	%xmm4, %xmm3, %xmm3 # xmm3 = xmm3[0],xmm4[0]
	vmovdqa	%xmm3, 5224(%rsp,%rax)
	vpaddb	%xmm1, %xmm5, %xmm3
	vpshufb	%xmm2, %xmm3, %xmm3
	vpaddb	%xmm1, %xmm6, %xmm4
	vpshufb	%xmm2, %xmm4, %xmm4
	vpunpcklqdq	%xmm4, %xmm3, %xmm3 # xmm3 = xmm3[0],xmm4[0]
	vmovdqa	%xmm3, 5240(%rsp,%rax)
	addq	$32, %rax
	cmpq	$664, %rax              # imm = 0x298
	jne	.LBB0_3
# %bb.4:
	movb	2560(%rsp), %al
	movb	2564(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5888(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 5889(%rsp)
	movb	2568(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5890(%rsp)
	movb	2572(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5891(%rsp)
	movb	2576(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5892(%rsp)
	movb	2580(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5893(%rsp)
	movb	2584(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5894(%rsp)
	movb	2588(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5895(%rsp)
	movb	2592(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5896(%rsp)
	movb	2596(%rsp), %al
	movb	2600(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5897(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 5898(%rsp)
	movb	2604(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5899(%rsp)
	movb	2608(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 5900(%rsp)
	movq	%rsp, %r15
	leaq	5904(%rsp), %rsi
	movq	%r15, %rdi
	vzeroupper
	callq	crypto_encode_653xint16_little@PLT
	xorl	%r13d, %r13d
	leaq	2624(%rsp), %r12
	leaq	5248(%rsp), %rdx
	xorl	%ecx, %ecx
	movq	%r12, %rdi
	movq	%r15, %rsi
	callq	crypto_core_multsntrup653_avx@PLT
	leaq	7216(%rsp), %r15
	movq	%r15, %rdi
	movq	%r12, %rsi
	callq	crypto_decode_653xint16_little@PLT
	leaq	32(%rbx), %rdi
	movq	%r15, %rsi
	callq	crypto_encode_653x1541round_ref@PLT
	leaq	164(%r14), %rax
	leaq	1061(%r14), %r15
	leaq	897(%rbx), %rcx
	cmpq	%rcx, %rax
	jae	.LBB0_6
# %bb.5:
	cmpq	%rbx, %r15
	ja	.LBB0_7
.LBB0_6:
	vmovups	(%rbx), %ymm0
	vmovups	32(%rbx), %ymm1
	vmovups	64(%rbx), %ymm2
	vmovups	96(%rbx), %ymm3
	vmovups	%ymm0, 164(%r14)
	vmovups	%ymm1, 196(%r14)
	vmovups	%ymm2, 228(%r14)
	vmovups	%ymm3, 260(%r14)
	vmovups	128(%rbx), %ymm0
	vmovups	160(%rbx), %ymm1
	vmovups	192(%rbx), %ymm2
	vmovups	224(%rbx), %ymm3
	vmovups	%ymm0, 292(%r14)
	vmovups	%ymm1, 324(%r14)
	vmovups	%ymm2, 356(%r14)
	vmovups	%ymm3, 388(%r14)
	vmovups	256(%rbx), %ymm0
	vmovups	288(%rbx), %ymm1
	vmovups	320(%rbx), %ymm2
	vmovups	352(%rbx), %ymm3
	vmovups	%ymm0, 420(%r14)
	vmovups	%ymm1, 452(%r14)
	vmovups	%ymm2, 484(%r14)
	vmovups	%ymm3, 516(%r14)
	vmovups	384(%rbx), %ymm0
	vmovups	416(%rbx), %ymm1
	vmovups	448(%rbx), %ymm2
	vmovups	480(%rbx), %ymm3
	vmovups	%ymm0, 548(%r14)
	vmovups	%ymm1, 580(%r14)
	vmovups	%ymm2, 612(%r14)
	vmovups	%ymm3, 644(%r14)
	vmovups	512(%rbx), %ymm0
	vmovups	544(%rbx), %ymm1
	vmovups	576(%rbx), %ymm2
	vmovups	608(%rbx), %ymm3
	vmovups	%ymm0, 676(%r14)
	vmovups	%ymm1, 708(%r14)
	vmovups	%ymm2, 740(%r14)
	vmovups	%ymm3, 772(%r14)
	vmovups	640(%rbx), %ymm0
	vmovups	672(%rbx), %ymm1
	vmovups	704(%rbx), %ymm2
	vmovups	736(%rbx), %ymm3
	vmovups	%ymm0, 804(%r14)
	vmovups	%ymm1, 836(%r14)
	vmovups	%ymm2, 868(%r14)
	vmovups	%ymm3, 900(%r14)
	vmovdqu	768(%rbx), %ymm0
	vmovdqu	800(%rbx), %ymm1
	vmovdqu	832(%rbx), %ymm2
	vmovdqu	864(%rbx), %ymm3
	vmovdqu	%ymm0, 932(%r14)
	vmovdqu	%ymm1, 964(%r14)
	vmovdqu	%ymm2, 996(%r14)
	vmovdqu	%ymm3, 1028(%r14)
	movl	$896, %r13d             # imm = 0x380
.LBB0_7:
	movq	$-1, %rcx
	movq	%r13, %rax
	.p2align	4, 0x90
.LBB0_8:                                # =>This Inner Loop Header: Depth=1
	movzbl	(%rbx,%rax), %edx
	movb	%dl, 164(%r14,%rax)
	addq	$1, %rax
	addq	$1, %rcx
	jne	.LBB0_8
# %bb.9:
	cmpq	$896, %r13              # imm = 0x380
	je	.LBB0_11
	.p2align	4, 0x90
.LBB0_10:                               # =>This Inner Loop Header: Depth=1
	movzbl	(%rbx,%rax), %ecx
	movb	%cl, 164(%r14,%rax)
	movzbl	1(%rbx,%rax), %ecx
	movb	%cl, 165(%r14,%rax)
	movzbl	2(%rbx,%rax), %ecx
	movb	%cl, 166(%r14,%rax)
	movzbl	3(%rbx,%rax), %ecx
	movb	%cl, 167(%r14,%rax)
	addq	$4, %rax
	cmpq	$897, %rax              # imm = 0x381
	jne	.LBB0_10
.LBB0_11:
	leaq	163(%r14), %rsi
	movb	$4, 163(%r14)
	leaq	2624(%rsp), %rdi
	movl	$898, %edx              # imm = 0x382
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	2624(%rsp), %ymm0
	vmovups	%ymm0, 1093(%r14)
	movl	$32, %esi
	movq	%r15, %rdi
	vzeroupper
	callq	randombytes@PLT
	leaq	5248(%rsp), %rsi
	movq	%r14, %rdi
	callq	crypto_encode_653x3_ref@PLT
	xorl	%eax, %eax
	addq	$8528, %rsp             # imm = 0x2150
	.cfi_def_cfa_offset 48
	popq	%rbx
	.cfi_def_cfa_offset 40
	popq	%r12
	.cfi_def_cfa_offset 32
	popq	%r13
	.cfi_def_cfa_offset 24
	popq	%r14
	.cfi_def_cfa_offset 16
	popq	%r15
	.cfi_def_cfa_offset 8
	retq
.Lfunc_end0:
	.size	crypto_kem_keypair, .Lfunc_end0-crypto_kem_keypair
	.cfi_endproc
                                        # -- End function
	.globl	crypto_kem_enc          # -- Begin function crypto_kem_enc
	.p2align	4, 0x90
	.type	crypto_kem_enc,@function
crypto_kem_enc:                         # @crypto_kem_enc
	.cfi_startproc
# %bb.0:
	pushq	%rbp
	.cfi_def_cfa_offset 16
	pushq	%r15
	.cfi_def_cfa_offset 24
	pushq	%r14
	.cfi_def_cfa_offset 32
	pushq	%r13
	.cfi_def_cfa_offset 40
	pushq	%r12
	.cfi_def_cfa_offset 48
	pushq	%rbx
	.cfi_def_cfa_offset 56
	subq	$2360, %rsp             # imm = 0x938
	.cfi_def_cfa_offset 2416
	.cfi_offset %rbx, -56
	.cfi_offset %r12, -48
	.cfi_offset %r13, -40
	.cfi_offset %r14, -32
	.cfi_offset %r15, -24
	.cfi_offset %rbp, -16
	movq	%rdx, %r13
	movq	%rsi, %r14
	movq	%rdi, %r12
	leaq	385(%rsp), %rdi
	movl	$897, %edx              # imm = 0x381
	movq	%r13, %rsi
	callq	memcpy@PLT
	movb	$4, 384(%rsp)
	leaq	32(%rsp), %r15
	leaq	384(%rsp), %rsi
	movl	$898, %edx              # imm = 0x382
	movq	%r15, %rdi
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	32(%rsp), %ymm0
	vmovups	%ymm0, (%rsp)
	leaq	96(%rsp), %rbx
	movl	$32, %esi
	movq	%rbx, %rdi
	vzeroupper
	callq	randombytes@PLT
	leaq	128(%rsp), %rbp
	movq	%rbp, %rdi
	movq	%rbx, %rsi
	callq	crypto_decode_256x2_avx@PLT
	leaq	1296(%rsp), %rbx
	movq	%rsp, %r8
	movq	%r12, %rdi
	movq	%rbx, %rsi
	movq	%rbp, %rdx
	movq	%r13, %rcx
	callq	Hide
	leaq	1329(%rsp), %rdi
	movl	$1025, %edx             # imm = 0x401
	movq	%r12, %rsi
	callq	memcpy@PLT
	movb	$1, 1296(%rsp)
	movl	$1058, %edx             # imm = 0x422
	movq	%r15, %rdi
	movq	%rbx, %rsi
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	32(%rsp), %ymm0
	vmovups	%ymm0, (%r14)
	xorl	%eax, %eax
	addq	$2360, %rsp             # imm = 0x938
	.cfi_def_cfa_offset 56
	popq	%rbx
	.cfi_def_cfa_offset 48
	popq	%r12
	.cfi_def_cfa_offset 40
	popq	%r13
	.cfi_def_cfa_offset 32
	popq	%r14
	.cfi_def_cfa_offset 24
	popq	%r15
	.cfi_def_cfa_offset 16
	popq	%rbp
	.cfi_def_cfa_offset 8
	vzeroupper
	retq
.Lfunc_end1:
	.size	crypto_kem_enc, .Lfunc_end1-crypto_kem_enc
	.cfi_endproc
                                        # -- End function
	.section	.rodata.cst8,"aM",@progbits,8
	.p2align	3               # -- Begin function Hide
.LCPI2_0:
	.quad	464722                  # 0x71752
	.section	.rodata.cst4,"aM",@progbits,4
	.p2align	2
.LCPI2_1:
	.long	4294962675              # 0xffffedf3
.LCPI2_2:
	.long	4621                    # 0x120d
.LCPI2_5:
	.long	4294967294              # 0xfffffffe
.LCPI2_6:
	.long	4294967292              # 0xfffffffc
.LCPI2_7:
	.long	1                       # 0x1
.LCPI2_10:
	.long	2310                    # 0x906
.LCPI2_11:
	.long	57                      # 0x39
.LCPI2_12:
	.long	29045                   # 0x7175
.LCPI2_13:
	.long	67108864                # 0x4000000
.LCPI2_14:
	.long	113                     # 0x71
.LCPI2_15:
	.long	262159                  # 0x4000f
	.section	.rodata.cst32,"aM",@progbits,32
	.p2align	5
.LCPI2_3:
	.byte	0                       # 0x0
	.byte	1                       # 0x1
	.byte	4                       # 0x4
	.byte	5                       # 0x5
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	14                      # 0xe
	.byte	15                      # 0xf
	.byte	16                      # 0x10
	.byte	17                      # 0x11
	.byte	20                      # 0x14
	.byte	21                      # 0x15
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	30                      # 0x1e
	.byte	31                      # 0x1f
	.section	.rodata.cst16,"aM",@progbits,16
	.p2align	4
.LCPI2_4:
	.short	63226                   # 0xf6fa
	.short	63226                   # 0xf6fa
	.short	63226                   # 0xf6fa
	.short	63226                   # 0xf6fa
	.short	63226                   # 0xf6fa
	.short	63226                   # 0xf6fa
	.short	63226                   # 0xf6fa
	.short	63226                   # 0xf6fa
.LCPI2_8:
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
.LCPI2_9:
	.byte	0                       # 0x0
	.byte	2                       # 0x2
	.byte	4                       # 0x4
	.byte	6                       # 0x6
	.byte	8                       # 0x8
	.byte	10                      # 0xa
	.byte	12                      # 0xc
	.byte	14                      # 0xe
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.text
	.p2align	4, 0x90
	.type	Hide,@function
Hide:                                   # @Hide
	.cfi_startproc
# %bb.0:
	pushq	%rbp
	.cfi_def_cfa_offset 16
	pushq	%r15
	.cfi_def_cfa_offset 24
	pushq	%r14
	.cfi_def_cfa_offset 32
	pushq	%r13
	.cfi_def_cfa_offset 40
	pushq	%r12
	.cfi_def_cfa_offset 48
	pushq	%rbx
	.cfi_def_cfa_offset 56
	subq	$12680, %rsp            # imm = 0x3188
	.cfi_def_cfa_offset 12736
	.cfi_offset %rbx, -56
	.cfi_offset %r12, -48
	.cfi_offset %r13, -40
	.cfi_offset %r14, -32
	.cfi_offset %r15, -24
	.cfi_offset %rbp, -16
	movq	%r8, (%rsp)             # 8-byte Spill
	movq	%rcx, %r13
	movq	%rdx, %rbx
	movq	%rsi, %r12
	movq	%rdi, 8(%rsp)           # 8-byte Spill
	addq	$1, %r12
	movq	%r12, %rdi
	movq	%rdx, %rsi
	callq	crypto_encode_256x2_avx@PLT
	leaq	32(%r13), %rsi
	leaq	11360(%rsp), %rdi
	callq	crypto_decode_653x1541_avx@PLT
	leaq	aes_nonce(%rip), %rdx
	leaq	208(%rsp), %rbp
	movl	$2612, %esi             # imm = 0xA34
	movq	%rbp, %rdi
	movq	%r13, %rcx
	callq	crypto_stream_aes256ctr_openssl@PLT
	movq	%rbp, %rdi
	movq	%rbp, %rsi
	callq	crypto_decode_653xint32_little@PLT
	xorl	%eax, %eax
	vpbroadcastq	.LCPI2_0(%rip), %ymm0 # ymm0 = [464722,464722,464722,464722]
	vpbroadcastd	.LCPI2_1(%rip), %ymm6 # ymm6 = [4294962675,4294962675,4294962675,4294962675,4294962675,4294962675,4294962675,4294962675]
	vpbroadcastd	.LCPI2_2(%rip), %ymm1 # ymm1 = [4621,4621,4621,4621,4621,4621,4621,4621]
	vmovdqa	.LCPI2_4(%rip), %xmm2   # xmm2 = [63226,63226,63226,63226,63226,63226,63226,63226]
	.p2align	4, 0x90
.LBB2_1:                                # =>This Inner Loop Header: Depth=1
	vmovdqu	208(%rsp,%rax,4), %ymm3
	vextracti128	$1, %ymm3, %xmm4
	vpmovzxdq	%xmm4, %ymm4    # ymm4 = xmm4[0],zero,xmm4[1],zero,xmm4[2],zero,xmm4[3],zero
	vpmovzxdq	%xmm3, %ymm5    # ymm5 = xmm3[0],zero,xmm3[1],zero,xmm3[2],zero,xmm3[3],zero
	vpmuludq	%ymm0, %ymm5, %ymm5
	vpmuludq	%ymm0, %ymm4, %ymm4
	vpsrlq	$31, %ymm4, %ymm4
	vpsrlq	$31, %ymm5, %ymm5
	vpshufd	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpshufd	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vinserti128	$1, %xmm4, %ymm5, %ymm4
	vpmulld	%ymm6, %ymm4, %ymm4
	vpaddd	%ymm3, %ymm4, %ymm3
	vextracti128	$1, %ymm3, %xmm4
	vpmovzxdq	%xmm4, %ymm4    # ymm4 = xmm4[0],zero,xmm4[1],zero,xmm4[2],zero,xmm4[3],zero
	vpmovzxdq	%xmm3, %ymm5    # ymm5 = xmm3[0],zero,xmm3[1],zero,xmm3[2],zero,xmm3[3],zero
	vpmuludq	%ymm0, %ymm5, %ymm5
	vpmuludq	%ymm0, %ymm4, %ymm4
	vpsrlq	$31, %ymm4, %ymm4
	vpsrlq	$31, %ymm5, %ymm5
	vpshufd	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpshufd	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3,4,6,6,7]
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vinserti128	$1, %xmm4, %ymm5, %ymm4
	vpmulld	%ymm6, %ymm4, %ymm4
	vpaddd	%ymm6, %ymm3, %ymm3
	vpaddd	%ymm3, %ymm4, %ymm3
	vpsrad	$31, %ymm3, %ymm4
	vpand	%ymm1, %ymm4, %ymm4
	vpaddd	%ymm3, %ymm4, %ymm3
	vpshufb	.LCPI2_3(%rip), %ymm3, %ymm3 # ymm3 = ymm3[0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	vpermq	$232, %ymm3, %ymm3      # ymm3 = ymm3[0,2,2,3]
	vpaddw	%xmm2, %xmm3, %xmm3
	vmovdqa	%xmm3, 6112(%rsp,%rax,2)
	addq	$8, %rax
	cmpq	$648, %rax              # imm = 0x288
	jne	.LBB2_1
# %bb.2:
	vmovdqu	%ymm6, 64(%rsp)         # 32-byte Spill
	movl	2800(%rsp), %ecx
	movl	2804(%rsp), %eax
	imulq	$464722, %rcx, %rdx     # imm = 0x71752
	shrq	$31, %rdx
	imull	$-4621, %edx, %edx      # imm = 0xEDF3
	addl	%ecx, %edx
	imulq	$464722, %rdx, %rcx     # imm = 0x71752
	shrq	$31, %rcx
	imull	$-4621, %ecx, %ecx      # imm = 0xEDF3
	leal	(%rcx,%rdx), %esi
	addl	$-4621, %esi            # imm = 0xEDF3
                                        # kill: def $edx killed $edx killed $rdx def $rdx
	addl	%ecx, %edx
	sarl	$31, %esi
	andl	$4621, %esi             # imm = 0x120D
	leal	(%rsi,%rdx), %ecx
	addl	$-6931, %ecx            # imm = 0xE4ED
	movw	%cx, 7408(%rsp)
	imulq	$464722, %rax, %rcx     # imm = 0x71752
	shrq	$31, %rcx
	imull	$-4621, %ecx, %ecx      # imm = 0xEDF3
	addl	%eax, %ecx
	imulq	$464722, %rcx, %rax     # imm = 0x71752
	shrq	$31, %rax
	imull	$-4621, %eax, %eax      # imm = 0xEDF3
	leal	(%rax,%rcx), %edx
	addl	$-4621, %edx            # imm = 0xEDF3
                                        # kill: def $ecx killed $ecx killed $rcx def $rcx
	addl	%eax, %ecx
	sarl	$31, %edx
	andl	$4621, %edx             # imm = 0x120D
	leal	(%rdx,%rcx), %eax
	addl	$-6931, %eax            # imm = 0xE4ED
	movw	%ax, 7410(%rsp)
	movl	2808(%rsp), %eax
	imulq	$464722, %rax, %rcx     # imm = 0x71752
	shrq	$31, %rcx
	imull	$-4621, %ecx, %ecx      # imm = 0xEDF3
	addl	%eax, %ecx
	imulq	$464722, %rcx, %rax     # imm = 0x71752
	shrq	$31, %rax
	imull	$-4621, %eax, %eax      # imm = 0xEDF3
	leal	(%rax,%rcx), %edx
	addl	$-4621, %edx            # imm = 0xEDF3
                                        # kill: def $ecx killed $ecx killed $rcx def $rcx
	addl	%eax, %ecx
	sarl	$31, %edx
	andl	$4621, %edx             # imm = 0x120D
	leal	(%rdx,%rcx), %eax
	addl	$-6931, %eax            # imm = 0xE4ED
	movw	%ax, 7412(%rsp)
	movl	2812(%rsp), %eax
	imulq	$464722, %rax, %rcx     # imm = 0x71752
	shrq	$31, %rcx
	imull	$-4621, %ecx, %ecx      # imm = 0xEDF3
	addl	%eax, %ecx
	imulq	$464722, %rcx, %rax     # imm = 0x71752
	shrq	$31, %rax
	imull	$-4621, %eax, %eax      # imm = 0xEDF3
	leal	(%rax,%rcx), %edx
	addl	$-4621, %edx            # imm = 0xEDF3
                                        # kill: def $ecx killed $ecx killed $rcx def $rcx
	addl	%eax, %ecx
	sarl	$31, %edx
	andl	$4621, %edx             # imm = 0x120D
	leal	(%rdx,%rcx), %eax
	addl	$-6931, %eax            # imm = 0xE4ED
	movw	%ax, 7414(%rsp)
	movl	2816(%rsp), %eax
	imulq	$464722, %rax, %rcx     # imm = 0x71752
	shrq	$31, %rcx
	imull	$-4621, %ecx, %ecx      # imm = 0xEDF3
	addl	%eax, %ecx
	imulq	$464722, %rcx, %rax     # imm = 0x71752
	shrq	$31, %rax
	imull	$-4621, %eax, %eax      # imm = 0xEDF3
	leal	(%rax,%rcx), %edx
	addl	$-4621, %edx            # imm = 0xEDF3
                                        # kill: def $ecx killed $ecx killed $rcx def $rcx
	addl	%eax, %ecx
	sarl	$31, %edx
	andl	$4621, %edx             # imm = 0x120D
	leal	(%rdx,%rcx), %eax
	addl	$-6931, %eax            # imm = 0xE4ED
	movw	%ax, 7416(%rsp)
	leaq	17(%rsp), %rdi
	movq	%rbx, %rsi
	vzeroupper
	callq	crypto_encode_256x2_avx@PLT
	movb	$5, 16(%rsp)
	leaq	144(%rsp), %rdi
	leaq	16(%rsp), %rsi
	movl	$33, %edx
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	144(%rsp), %ymm0
	vmovups	%ymm0, 112(%rsp)
	leaq	aes_nonce(%rip), %rdx
	leaq	2832(%rsp), %rbp
	leaq	112(%rsp), %rcx
	movl	$2612, %esi             # imm = 0xA34
	movq	%rbp, %rdi
	vzeroupper
	callq	crypto_stream_aes256ctr_openssl@PLT
	movq	%rbp, %rdi
	movq	%rbp, %rsi
	callq	crypto_decode_653xint32_little@PLT
	vbroadcastss	.LCPI2_5(%rip), %ymm0 # ymm0 = [4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294]
	vandps	2832(%rsp), %ymm0, %ymm1
	vandps	2864(%rsp), %ymm0, %ymm2
	vandps	2896(%rsp), %ymm0, %ymm3
	vandps	2928(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 208(%rsp)
	vmovups	%ymm2, 240(%rsp)
	vmovups	%ymm3, 272(%rsp)
	vmovups	%ymm4, 304(%rsp)
	vandps	2960(%rsp), %ymm0, %ymm1
	vandps	2992(%rsp), %ymm0, %ymm2
	vandps	3024(%rsp), %ymm0, %ymm3
	vandps	3056(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 336(%rsp)
	vmovups	%ymm2, 368(%rsp)
	vmovups	%ymm3, 400(%rsp)
	vmovups	%ymm4, 432(%rsp)
	vandps	3088(%rsp), %ymm0, %ymm1
	vandps	3120(%rsp), %ymm0, %ymm2
	vandps	3152(%rsp), %ymm0, %ymm3
	vandps	3184(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 464(%rsp)
	vmovups	%ymm2, 496(%rsp)
	vmovups	%ymm3, 528(%rsp)
	vmovups	%ymm4, 560(%rsp)
	vandps	3216(%rsp), %ymm0, %ymm1
	vandps	3248(%rsp), %ymm0, %ymm2
	vandps	3280(%rsp), %ymm0, %ymm3
	vandps	3312(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 592(%rsp)
	vmovups	%ymm2, 624(%rsp)
	vmovups	%ymm3, 656(%rsp)
	vmovups	%ymm4, 688(%rsp)
	vandps	3344(%rsp), %ymm0, %ymm1
	vandps	3376(%rsp), %ymm0, %ymm2
	vandps	3408(%rsp), %ymm0, %ymm3
	vandps	3440(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 720(%rsp)
	vmovups	%ymm2, 752(%rsp)
	vmovups	%ymm3, 784(%rsp)
	vmovups	%ymm4, 816(%rsp)
	vandps	3472(%rsp), %ymm0, %ymm1
	vandps	3504(%rsp), %ymm0, %ymm2
	vandps	3536(%rsp), %ymm0, %ymm3
	vandps	3568(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 848(%rsp)
	vmovups	%ymm2, 880(%rsp)
	vmovups	%ymm3, 912(%rsp)
	vmovups	%ymm4, 944(%rsp)
	vandps	3600(%rsp), %ymm0, %ymm1
	vandps	3632(%rsp), %ymm0, %ymm2
	vandps	3664(%rsp), %ymm0, %ymm3
	vandps	3696(%rsp), %ymm0, %ymm0
	vmovups	%ymm1, 976(%rsp)
	vmovups	%ymm2, 1008(%rsp)
	vmovups	%ymm3, 1040(%rsp)
	vmovups	%ymm0, 1072(%rsp)
	movl	3728(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1104(%rsp)
	movl	3732(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1108(%rsp)
	movl	3736(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1112(%rsp)
	movl	3740(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1116(%rsp)
	movl	3744(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1120(%rsp)
	movl	3748(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1124(%rsp)
	movl	3752(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1128(%rsp)
	movl	3756(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1132(%rsp)
	movl	3760(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1136(%rsp)
	movl	3764(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1140(%rsp)
	movl	3768(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1144(%rsp)
	movl	3772(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1148(%rsp)
	movl	3776(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1152(%rsp)
	movl	3780(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1156(%rsp)
	movl	3784(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1160(%rsp)
	movl	3788(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1164(%rsp)
	movl	3792(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1168(%rsp)
	movl	3796(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1172(%rsp)
	movl	3800(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1176(%rsp)
	movl	3804(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1180(%rsp)
	movl	3808(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1184(%rsp)
	movl	3812(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1188(%rsp)
	movl	3816(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1192(%rsp)
	movl	3820(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1196(%rsp)
	movl	3824(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1200(%rsp)
	movl	3828(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1204(%rsp)
	movl	3832(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1208(%rsp)
	movl	3836(%rsp), %eax
	andl	$-2, %eax
	movl	%eax, 1212(%rsp)
	vpbroadcastd	.LCPI2_6(%rip), %ymm0 # ymm0 = [4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292]
	vpand	3840(%rsp), %ymm0, %ymm2
	vpand	3872(%rsp), %ymm0, %ymm3
	vpand	3904(%rsp), %ymm0, %ymm4
	vpand	3936(%rsp), %ymm0, %ymm5
	vpbroadcastd	.LCPI2_7(%rip), %ymm1 # ymm1 = [1,1,1,1,1,1,1,1]
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1216(%rsp)
	vmovdqu	%ymm3, 1248(%rsp)
	vmovdqu	%ymm4, 1280(%rsp)
	vmovdqu	%ymm5, 1312(%rsp)
	vpand	3968(%rsp), %ymm0, %ymm2
	vpand	4000(%rsp), %ymm0, %ymm3
	vpand	4032(%rsp), %ymm0, %ymm4
	vpand	4064(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1344(%rsp)
	vmovdqu	%ymm3, 1376(%rsp)
	vmovdqu	%ymm4, 1408(%rsp)
	vmovdqu	%ymm5, 1440(%rsp)
	vpand	4096(%rsp), %ymm0, %ymm2
	vpand	4128(%rsp), %ymm0, %ymm3
	vpand	4160(%rsp), %ymm0, %ymm4
	vpand	4192(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1472(%rsp)
	vmovdqu	%ymm3, 1504(%rsp)
	vmovdqu	%ymm4, 1536(%rsp)
	vmovdqu	%ymm5, 1568(%rsp)
	vpand	4224(%rsp), %ymm0, %ymm2
	vpand	4256(%rsp), %ymm0, %ymm3
	vpand	4288(%rsp), %ymm0, %ymm4
	vpand	4320(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1600(%rsp)
	vmovdqu	%ymm3, 1632(%rsp)
	vmovdqu	%ymm4, 1664(%rsp)
	vmovdqu	%ymm5, 1696(%rsp)
	vpand	4352(%rsp), %ymm0, %ymm2
	vpand	4384(%rsp), %ymm0, %ymm3
	vpand	4416(%rsp), %ymm0, %ymm4
	vpand	4448(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1728(%rsp)
	vmovdqu	%ymm3, 1760(%rsp)
	vmovdqu	%ymm4, 1792(%rsp)
	vmovdqu	%ymm5, 1824(%rsp)
	vpand	4480(%rsp), %ymm0, %ymm2
	vpand	4512(%rsp), %ymm0, %ymm3
	vpand	4544(%rsp), %ymm0, %ymm4
	vpand	4576(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1856(%rsp)
	vmovdqu	%ymm3, 1888(%rsp)
	vmovdqu	%ymm4, 1920(%rsp)
	vmovdqu	%ymm5, 1952(%rsp)
	vpand	4608(%rsp), %ymm0, %ymm2
	vpand	4640(%rsp), %ymm0, %ymm3
	vpand	4672(%rsp), %ymm0, %ymm4
	vpand	4704(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1984(%rsp)
	vmovdqu	%ymm3, 2016(%rsp)
	vmovdqu	%ymm4, 2048(%rsp)
	vmovdqu	%ymm5, 2080(%rsp)
	vpand	4736(%rsp), %ymm0, %ymm2
	vpand	4768(%rsp), %ymm0, %ymm3
	vpand	4800(%rsp), %ymm0, %ymm4
	vpand	4832(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2112(%rsp)
	vmovdqu	%ymm3, 2144(%rsp)
	vmovdqu	%ymm4, 2176(%rsp)
	vmovdqu	%ymm5, 2208(%rsp)
	vpand	4864(%rsp), %ymm0, %ymm2
	vpand	4896(%rsp), %ymm0, %ymm3
	vpand	4928(%rsp), %ymm0, %ymm4
	vpand	4960(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2240(%rsp)
	vmovdqu	%ymm3, 2272(%rsp)
	vmovdqu	%ymm4, 2304(%rsp)
	vmovdqu	%ymm5, 2336(%rsp)
	vpand	4992(%rsp), %ymm0, %ymm2
	vpand	5024(%rsp), %ymm0, %ymm3
	vpand	5056(%rsp), %ymm0, %ymm4
	vpand	5088(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2368(%rsp)
	vmovdqu	%ymm3, 2400(%rsp)
	vmovdqu	%ymm4, 2432(%rsp)
	vmovdqu	%ymm5, 2464(%rsp)
	vpand	5120(%rsp), %ymm0, %ymm2
	vpand	5152(%rsp), %ymm0, %ymm3
	vpand	5184(%rsp), %ymm0, %ymm4
	vpand	5216(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2496(%rsp)
	vmovdqu	%ymm3, 2528(%rsp)
	vmovdqu	%ymm4, 2560(%rsp)
	vmovdqu	%ymm5, 2592(%rsp)
	vpand	5248(%rsp), %ymm0, %ymm2
	vpand	5280(%rsp), %ymm0, %ymm3
	vpand	5312(%rsp), %ymm0, %ymm4
	vpand	5344(%rsp), %ymm0, %ymm0
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm0, %ymm0
	vmovdqu	%ymm2, 2624(%rsp)
	vmovdqu	%ymm3, 2656(%rsp)
	vmovdqu	%ymm4, 2688(%rsp)
	vmovdqu	%ymm0, 2720(%rsp)
	movl	5376(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2752(%rsp)
	movl	5380(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2756(%rsp)
	movl	5384(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2760(%rsp)
	movl	5388(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2764(%rsp)
	movl	5392(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2768(%rsp)
	movl	5396(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2772(%rsp)
	movl	5400(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2776(%rsp)
	movl	5404(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2780(%rsp)
	movl	5408(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2784(%rsp)
	movl	5412(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2788(%rsp)
	movl	5416(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2792(%rsp)
	movl	5420(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2796(%rsp)
	movl	5424(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2800(%rsp)
	movl	5428(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2804(%rsp)
	movl	5432(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2808(%rsp)
	movl	5436(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2812(%rsp)
	movl	5440(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2816(%rsp)
	leaq	208(%rsp), %rdi
	movl	$653, %esi              # imm = 0x28D
	vzeroupper
	callq	crypto_sort_uint32_useint32@PLT
	vmovdqa	.LCPI2_3(%rip), %ymm6   # ymm6 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	movl	$24, %eax
	vmovdqa	.LCPI2_8(%rip), %xmm0   # xmm0 = [3,3,3,3,3,3,3,3]
	vpcmpeqd	%xmm1, %xmm1, %xmm1
	vmovdqa	.LCPI2_9(%rip), %xmm7   # xmm7 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	.p2align	4, 0x90
.LBB2_3:                                # =>This Inner Loop Header: Depth=1
	vmovdqu	112(%rsp,%rax,4), %ymm2
	vmovdqu	144(%rsp,%rax,4), %ymm3
	vmovdqu	176(%rsp,%rax,4), %ymm4
	vmovdqu	208(%rsp,%rax,4), %ymm5
	vpshufb	%ymm6, %ymm2, %ymm2
	vpermq	$232, %ymm2, %ymm2      # ymm2 = ymm2[0,2,2,3]
	vpshufb	%ymm6, %ymm3, %ymm3
	vpermq	$232, %ymm3, %ymm3      # ymm3 = ymm3[0,2,2,3]
	vpshufb	%ymm6, %ymm4, %ymm4
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vpshufb	%ymm6, %ymm5, %ymm5
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpand	%xmm0, %xmm2, %xmm2
	vpand	%xmm0, %xmm3, %xmm3
	vpand	%xmm0, %xmm4, %xmm4
	vpand	%xmm0, %xmm5, %xmm5
	vpaddb	%xmm1, %xmm2, %xmm2
	vpshufb	%xmm7, %xmm2, %xmm2
	vpaddb	%xmm1, %xmm3, %xmm3
	vpshufb	%xmm7, %xmm3, %xmm3
	vpunpcklqdq	%xmm3, %xmm2, %xmm2 # xmm2 = xmm2[0],xmm3[0]
	vmovdqa	%xmm2, 5432(%rsp,%rax)
	vpaddb	%xmm1, %xmm4, %xmm2
	vpshufb	%xmm7, %xmm2, %xmm2
	vpaddb	%xmm1, %xmm5, %xmm3
	vpshufb	%xmm7, %xmm3, %xmm3
	vpunpcklqdq	%xmm3, %xmm2, %xmm2 # xmm2 = xmm2[0],xmm3[0]
	vmovdqa	%xmm2, 5448(%rsp,%rax)
	addq	$32, %rax
	cmpq	$664, %rax              # imm = 0x298
	jne	.LBB2_3
# %bb.4:
	movb	2768(%rsp), %al
	movb	2772(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6096(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 6097(%rsp)
	movb	2776(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6098(%rsp)
	movb	2780(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6099(%rsp)
	movb	2784(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6100(%rsp)
	movb	2788(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6101(%rsp)
	movb	2792(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6102(%rsp)
	movb	2796(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6103(%rsp)
	movb	2800(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6104(%rsp)
	movb	2804(%rsp), %al
	movb	2808(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6105(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 6106(%rsp)
	movb	2812(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6107(%rsp)
	movb	2816(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 6108(%rsp)
	leaq	7424(%rsp), %r13
	leaq	6112(%rsp), %rsi
	movq	%r13, %rdi
	vzeroupper
	callq	crypto_encode_653xint16_little@PLT
	xorl	%r15d, %r15d
	leaq	208(%rsp), %rbp
	leaq	5456(%rsp), %r14
	xorl	%ecx, %ecx
	movq	%rbp, %rdi
	movq	%r13, %rsi
	movq	%r14, %rdx
	callq	crypto_core_multsntrup653_avx@PLT
	leaq	10048(%rsp), %rdi
	movq	%rbp, %rsi
	callq	crypto_decode_653xint16_little@PLT
	leaq	11360(%rsp), %rsi
	movq	%r13, %rdi
	callq	crypto_encode_653xint16_little@PLT
	xorl	%ecx, %ecx
	movq	%rbp, %rdi
	movq	%r13, %rsi
	movq	%r14, %rdx
	callq	crypto_core_multsntrup653_avx@PLT
	leaq	8736(%rsp), %rdi
	movq	%rbp, %rsi
	callq	crypto_decode_653xint16_little@PLT
	vmovdqa	.LCPI2_9(%rip), %xmm12  # xmm12 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	vmovdqa	.LCPI2_3(%rip), %ymm11  # ymm11 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	vpbroadcastd	.LCPI2_10(%rip), %ymm0 # ymm0 = [2310,2310,2310,2310,2310,2310,2310,2310]
	vpbroadcastd	.LCPI2_11(%rip), %ymm1 # ymm1 = [57,57,57,57,57,57,57,57]
	vpbroadcastd	.LCPI2_12(%rip), %ymm2 # ymm2 = [29045,29045,29045,29045,29045,29045,29045,29045]
	vpbroadcastd	.LCPI2_13(%rip), %ymm3 # ymm3 = [67108864,67108864,67108864,67108864,67108864,67108864,67108864,67108864]
	vpbroadcastd	.LCPI2_14(%rip), %ymm4 # ymm4 = [113,113,113,113,113,113,113,113]
	vpbroadcastd	.LCPI2_15(%rip), %ymm5 # ymm5 = [262159,262159,262159,262159,262159,262159,262159,262159]
	vmovdqu	64(%rsp), %ymm10        # 32-byte Reload
	.p2align	4, 0x90
.LBB2_5:                                # =>This Inner Loop Header: Depth=1
	vpmovsxwd	8736(%rsp,%r15,2), %ymm6
	vpmovsxwd	8752(%rsp,%r15,2), %ymm7
	vpmovsxbd	8(%rbx,%r15), %ymm8
	vpmovsxbd	(%rbx,%r15), %ymm9
	vpmulld	%ymm0, %ymm9, %ymm9
	vpaddd	%ymm6, %ymm9, %ymm6
	vpmulld	%ymm0, %ymm8, %ymm8
	vpaddd	%ymm7, %ymm8, %ymm7
	vpmulld	%ymm1, %ymm6, %ymm8
	vpmulld	%ymm1, %ymm7, %ymm9
	vpsrad	$18, %ymm9, %ymm9
	vpsrad	$18, %ymm8, %ymm8
	vpmulld	%ymm10, %ymm8, %ymm8
	vpmulld	%ymm10, %ymm9, %ymm9
	vpaddd	%ymm7, %ymm9, %ymm7
	vpaddd	%ymm6, %ymm8, %ymm6
	vpmulld	%ymm2, %ymm6, %ymm8
	vpmulld	%ymm2, %ymm7, %ymm9
	vpaddd	%ymm3, %ymm9, %ymm9
	vpaddd	%ymm3, %ymm8, %ymm8
	vpsrad	$27, %ymm8, %ymm8
	vpsrad	$27, %ymm9, %ymm9
	vpmulld	%ymm10, %ymm9, %ymm9
	vpmulld	%ymm10, %ymm8, %ymm8
	vpaddd	%ymm6, %ymm8, %ymm6
	vpaddd	%ymm7, %ymm9, %ymm7
	vpslld	$16, %ymm7, %ymm7
	vpsrad	$16, %ymm7, %ymm7
	vpslld	$16, %ymm6, %ymm6
	vpsrad	$16, %ymm6, %ymm6
	vpmulld	%ymm4, %ymm6, %ymm6
	vpmulld	%ymm4, %ymm7, %ymm7
	vpaddd	%ymm5, %ymm7, %ymm7
	vpaddd	%ymm5, %ymm6, %ymm6
	vpsrld	$15, %ymm6, %ymm6
	vpsrld	$15, %ymm7, %ymm7
	vpshufb	%ymm11, %ymm7, %ymm7
	vpermq	$232, %ymm7, %ymm7      # ymm7 = ymm7[0,2,2,3]
	vpshufb	%xmm12, %xmm7, %xmm7
	vpshufb	%ymm11, %ymm6, %ymm6
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpshufb	%xmm12, %xmm6, %xmm6
	vpunpcklqdq	%xmm7, %xmm6, %xmm6 # xmm6 = xmm6[0],xmm7[0]
	vmovdqa	%xmm6, 208(%rsp,%r15)
	addq	$16, %r15
	cmpq	$256, %r15              # imm = 0x100
	jne	.LBB2_5
# %bb.6:
	leaq	10048(%rsp), %rsi
	movq	8(%rsp), %rbx           # 8-byte Reload
	movq	%rbx, %rdi
	vzeroupper
	callq	crypto_encode_653x1541round_ref@PLT
	leaq	865(%rbx), %rdi
	leaq	208(%rsp), %rsi
	callq	crypto_encode_256x16_ref@PLT
	vmovups	(%r12), %ymm0
	vmovups	%ymm0, 7425(%rsp)
	movq	(%rsp), %rax            # 8-byte Reload
	vmovups	(%rax), %ymm0
	vmovups	%ymm0, 7457(%rsp)
	movb	$2, 7424(%rsp)
	leaq	144(%rsp), %rdi
	leaq	7424(%rsp), %rsi
	movl	$65, %edx
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	144(%rsp), %ymm0
	vmovups	%ymm0, 993(%rbx)
	addq	$12680, %rsp            # imm = 0x3188
	.cfi_def_cfa_offset 56
	popq	%rbx
	.cfi_def_cfa_offset 48
	popq	%r12
	.cfi_def_cfa_offset 40
	popq	%r13
	.cfi_def_cfa_offset 32
	popq	%r14
	.cfi_def_cfa_offset 24
	popq	%r15
	.cfi_def_cfa_offset 16
	popq	%rbp
	.cfi_def_cfa_offset 8
	vzeroupper
	retq
.Lfunc_end2:
	.size	Hide, .Lfunc_end2-Hide
	.cfi_endproc
                                        # -- End function
	.section	.rodata.cst4,"aM",@progbits,4
	.p2align	2               # -- Begin function crypto_kem_dec
.LCPI3_0:
	.long	290                     # 0x122
.LCPI3_1:
	.long	4294965265              # 0xfffff811
.LCPI3_2:
	.long	57                      # 0x39
.LCPI3_3:
	.long	4294962675              # 0xffffedf3
.LCPI3_4:
	.long	29045                   # 0x7175
.LCPI3_5:
	.long	67108864                # 0x4000000
.LCPI3_6:
	.long	1009                    # 0x3f1
	.section	.rodata.cst32,"aM",@progbits,32
	.p2align	5
.LCPI3_7:
	.byte	0                       # 0x0
	.byte	1                       # 0x1
	.byte	4                       # 0x4
	.byte	5                       # 0x5
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	14                      # 0xe
	.byte	15                      # 0xf
	.byte	16                      # 0x10
	.byte	17                      # 0x11
	.byte	20                      # 0x14
	.byte	21                      # 0x15
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	30                      # 0x1e
	.byte	31                      # 0x1f
	.text
	.globl	crypto_kem_dec
	.p2align	4, 0x90
	.type	crypto_kem_dec,@function
crypto_kem_dec:                         # @crypto_kem_dec
	.cfi_startproc
# %bb.0:
	pushq	%rbp
	.cfi_def_cfa_offset 16
	pushq	%r15
	.cfi_def_cfa_offset 24
	pushq	%r14
	.cfi_def_cfa_offset 32
	pushq	%r13
	.cfi_def_cfa_offset 40
	pushq	%r12
	.cfi_def_cfa_offset 48
	pushq	%rbx
	.cfi_def_cfa_offset 56
	subq	$6504, %rsp             # imm = 0x1968
	.cfi_def_cfa_offset 6560
	.cfi_offset %rbx, -56
	.cfi_offset %r12, -48
	.cfi_offset %r13, -40
	.cfi_offset %r14, -32
	.cfi_offset %r15, -24
	.cfi_offset %rbp, -16
	movq	%rdx, %r15
	movq	%rsi, %rbx
	movq	%rdi, 8(%rsp)           # 8-byte Spill
	leaq	4528(%rsp), %r12
	movq	%r12, %rdi
	movq	%rdx, %rsi
	callq	crypto_decode_653x3_ref@PLT
	leaq	5184(%rsp), %r13
	movq	%r13, %rdi
	movq	%rbx, %rsi
	callq	crypto_decode_653x1541_avx@PLT
	leaq	865(%rbx), %rsi
	leaq	80(%rsp), %rdi
	callq	crypto_decode_256x16_ref@PLT
	leaq	1904(%rsp), %r14
	movq	%r14, %rdi
	movq	%r13, %rsi
	callq	crypto_encode_653xint16_little@PLT
	xorl	%ebp, %ebp
	leaq	592(%rsp), %r13
	xorl	%ecx, %ecx
	movq	%r13, %rdi
	movq	%r14, %rsi
	movq	%r12, %rdx
	callq	crypto_core_multsntrup653_avx@PLT
	leaq	3216(%rsp), %rdi
	movq	%r13, %rsi
	callq	crypto_decode_653xint16_little@PLT
	vpbroadcastd	.LCPI3_0(%rip), %ymm0 # ymm0 = [290,290,290,290,290,290,290,290]
	vpbroadcastd	.LCPI3_1(%rip), %ymm1 # ymm1 = [4294965265,4294965265,4294965265,4294965265,4294965265,4294965265,4294965265,4294965265]
	vpbroadcastd	.LCPI3_2(%rip), %ymm2 # ymm2 = [57,57,57,57,57,57,57,57]
	vpbroadcastd	.LCPI3_3(%rip), %ymm3 # ymm3 = [4294962675,4294962675,4294962675,4294962675,4294962675,4294962675,4294962675,4294962675]
	vpbroadcastd	.LCPI3_4(%rip), %ymm4 # ymm4 = [29045,29045,29045,29045,29045,29045,29045,29045]
	vpbroadcastd	.LCPI3_5(%rip), %ymm5 # ymm5 = [67108864,67108864,67108864,67108864,67108864,67108864,67108864,67108864]
	vpbroadcastd	.LCPI3_6(%rip), %ymm6 # ymm6 = [1009,1009,1009,1009,1009,1009,1009,1009]
	vmovdqa	.LCPI3_7(%rip), %ymm12  # ymm12 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	.p2align	4, 0x90
.LBB3_1:                                # =>This Inner Loop Header: Depth=1
	vpmovsxbd	80(%rsp,%rbp), %ymm8
	vpmovsxbd	88(%rsp,%rbp), %ymm9
	vpmulld	%ymm0, %ymm9, %ymm9
	vpmulld	%ymm0, %ymm8, %ymm8
	vpaddd	%ymm1, %ymm8, %ymm8
	vpaddd	%ymm1, %ymm9, %ymm9
	vpmulld	%ymm2, %ymm9, %ymm10
	vpmulld	%ymm2, %ymm8, %ymm11
	vpsrad	$18, %ymm11, %ymm11
	vpsrad	$18, %ymm10, %ymm10
	vpmulld	%ymm3, %ymm10, %ymm10
	vpmulld	%ymm3, %ymm11, %ymm11
	vpaddd	%ymm8, %ymm11, %ymm8
	vpaddd	%ymm9, %ymm10, %ymm9
	vpmulld	%ymm4, %ymm9, %ymm10
	vpmulld	%ymm4, %ymm8, %ymm11
	vpaddd	%ymm5, %ymm11, %ymm11
	vpaddd	%ymm5, %ymm10, %ymm10
	vpsrad	$27, %ymm10, %ymm10
	vpsrad	$27, %ymm11, %ymm11
	vpmulld	%ymm3, %ymm11, %ymm11
	vpmulld	%ymm3, %ymm10, %ymm10
	vpaddd	%ymm9, %ymm10, %ymm9
	vpaddd	%ymm8, %ymm11, %ymm8
	vpslld	$16, %ymm8, %ymm8
	vpsrad	$16, %ymm8, %ymm8
	vpslld	$16, %ymm9, %ymm9
	vpmovsxwd	3216(%rsp,%rbp,2), %ymm10
	vpsrad	$16, %ymm9, %ymm9
	vpsubd	%ymm10, %ymm8, %ymm8
	vpmovsxwd	3232(%rsp,%rbp,2), %ymm10
	vpsubd	%ymm10, %ymm9, %ymm9
	vpaddd	%ymm6, %ymm8, %ymm8
	vpaddd	%ymm6, %ymm9, %ymm9
	vpmulld	%ymm2, %ymm9, %ymm10
	vpmulld	%ymm2, %ymm8, %ymm11
	vpsrad	$18, %ymm11, %ymm11
	vpsrad	$18, %ymm10, %ymm10
	vpmulld	%ymm3, %ymm10, %ymm10
	vpmulld	%ymm3, %ymm11, %ymm11
	vpaddd	%ymm8, %ymm11, %ymm8
	vpaddd	%ymm9, %ymm10, %ymm9
	vpmulld	%ymm4, %ymm9, %ymm10
	vpmulld	%ymm4, %ymm8, %ymm11
	vpaddd	%ymm5, %ymm11, %ymm11
	vpaddd	%ymm5, %ymm10, %ymm10
	vpsrad	$27, %ymm10, %ymm10
	vpsrad	$27, %ymm11, %ymm11
	vpmulld	%ymm3, %ymm11, %ymm11
	vpmulld	%ymm3, %ymm10, %ymm10
	vpaddd	%ymm9, %ymm10, %ymm9
	vpaddd	%ymm8, %ymm11, %ymm8
	vpshufb	%ymm12, %ymm8, %ymm8
	vpermq	$232, %ymm8, %ymm8      # ymm8 = ymm8[0,2,2,3]
	vpshufb	%ymm12, %ymm9, %ymm9
	vpermq	$232, %ymm9, %ymm9      # ymm9 = ymm9[0,2,2,3]
	vinserti128	$1, %xmm9, %ymm8, %ymm8
	vpsrlw	$15, %ymm8, %ymm8
	vextracti128	$1, %ymm8, %xmm7
	vpackuswb	%xmm7, %xmm8, %xmm7
	vmovdqa	%xmm7, 336(%rsp,%rbp)
	addq	$16, %rbp
	cmpq	$256, %rbp              # imm = 0x100
	jne	.LBB3_1
# %bb.2:
	leaq	164(%r15), %rcx
	leaq	1093(%r15), %r8
	leaq	1904(%rsp), %rdi
	leaq	592(%rsp), %rsi
	leaq	336(%rsp), %rdx
	vzeroupper
	callq	Hide
	vpxor	%xmm0, %xmm0, %xmm0
	movl	$24, %eax
	vpxor	%xmm1, %xmm1, %xmm1
	vpxor	%xmm2, %xmm2, %xmm2
	vpxor	%xmm3, %xmm3, %xmm3
	.p2align	4, 0x90
.LBB3_3:                                # =>This Inner Loop Header: Depth=1
	vpmovzxbw	-24(%rbx,%rax), %xmm4 # xmm4 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	-16(%rbx,%rax), %xmm5 # xmm5 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	-8(%rbx,%rax), %xmm6 # xmm6 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	(%rbx,%rax), %xmm8 # xmm8 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	1880(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm4, %xmm7, %xmm4
	vpackuswb	%xmm0, %xmm4, %xmm4
	vpmovzxbw	1888(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm5, %xmm7, %xmm5
	vpackuswb	%xmm0, %xmm5, %xmm5
	vpmovzxbw	1896(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm6, %xmm7, %xmm6
	vpackuswb	%xmm0, %xmm6, %xmm6
	vpmovzxbw	1904(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm8, %xmm7, %xmm7
	vpackuswb	%xmm0, %xmm7, %xmm7
	vpmovzxbd	%xmm4, %ymm4    # ymm4 = xmm4[0],zero,zero,zero,xmm4[1],zero,zero,zero,xmm4[2],zero,zero,zero,xmm4[3],zero,zero,zero,xmm4[4],zero,zero,zero,xmm4[5],zero,zero,zero,xmm4[6],zero,zero,zero,xmm4[7],zero,zero,zero
	vpor	%ymm4, %ymm0, %ymm0
	vpmovzxbd	%xmm5, %ymm4    # ymm4 = xmm5[0],zero,zero,zero,xmm5[1],zero,zero,zero,xmm5[2],zero,zero,zero,xmm5[3],zero,zero,zero,xmm5[4],zero,zero,zero,xmm5[5],zero,zero,zero,xmm5[6],zero,zero,zero,xmm5[7],zero,zero,zero
	vpor	%ymm4, %ymm1, %ymm1
	vpmovzxbd	%xmm6, %ymm4    # ymm4 = xmm6[0],zero,zero,zero,xmm6[1],zero,zero,zero,xmm6[2],zero,zero,zero,xmm6[3],zero,zero,zero,xmm6[4],zero,zero,zero,xmm6[5],zero,zero,zero,xmm6[6],zero,zero,zero,xmm6[7],zero,zero,zero
	vpor	%ymm4, %ymm2, %ymm2
	vpmovzxbd	%xmm7, %ymm4    # ymm4 = xmm7[0],zero,zero,zero,xmm7[1],zero,zero,zero,xmm7[2],zero,zero,zero,xmm7[3],zero,zero,zero,xmm7[4],zero,zero,zero,xmm7[5],zero,zero,zero,xmm7[6],zero,zero,zero,xmm7[7],zero,zero,zero
	vpor	%ymm4, %ymm3, %ymm3
	addq	$32, %rax
	cmpq	$1048, %rax             # imm = 0x418
	jne	.LBB3_3
# %bb.4:
	vpor	%ymm0, %ymm1, %ymm0
	vpor	%ymm0, %ymm2, %ymm0
	vpor	%ymm0, %ymm3, %ymm0
	vextracti128	$1, %ymm0, %xmm1
	vpor	%ymm1, %ymm0, %ymm0
	vpshufd	$78, %xmm0, %xmm1       # xmm1 = xmm0[2,3,0,1]
	vpor	%ymm1, %ymm0, %ymm0
	vpshufd	$229, %xmm0, %xmm1      # xmm1 = xmm0[1,1,2,3]
	vpor	%ymm1, %ymm0, %ymm0
	vmovd	%xmm0, %eax
	movb	2928(%rsp), %cl
	xorb	1024(%rbx), %cl
	movzbl	%cl, %ebp
	orl	%eax, %ebp
	addl	$-1, %ebp
	shrl	$8, %ebp
	andb	$1, %bpl
	movl	%ebp, %eax
	addb	$-1, %al
	vmovd	%eax, %xmm0
	vpbroadcastb	%xmm0, %xmm0
	vmovdqu	593(%rsp), %xmm1
	vmovdqu	609(%rsp), %xmm2
	vpblendvb	%xmm0, 1061(%r15), %xmm1, %xmm1
	vmovdqu	%xmm1, 593(%rsp)
	vpblendvb	%xmm0, 1077(%r15), %xmm2, %xmm0
	vmovdqu	%xmm0, 609(%rsp)
	leaq	625(%rsp), %rdi
	movl	$1025, %edx             # imm = 0x401
	movq	%rbx, %rsi
	vzeroupper
	callq	memcpy@PLT
	movb	%bpl, 592(%rsp)
	leaq	16(%rsp), %rdi
	leaq	592(%rsp), %rsi
	movl	$1058, %edx             # imm = 0x422
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	16(%rsp), %ymm0
	movq	8(%rsp), %rax           # 8-byte Reload
	vmovups	%ymm0, (%rax)
	xorl	%eax, %eax
	addq	$6504, %rsp             # imm = 0x1968
	.cfi_def_cfa_offset 56
	popq	%rbx
	.cfi_def_cfa_offset 48
	popq	%r12
	.cfi_def_cfa_offset 40
	popq	%r13
	.cfi_def_cfa_offset 32
	popq	%r14
	.cfi_def_cfa_offset 24
	popq	%r15
	.cfi_def_cfa_offset 16
	popq	%rbp
	.cfi_def_cfa_offset 8
	vzeroupper
	retq
.Lfunc_end3:
	.size	crypto_kem_dec, .Lfunc_end3-crypto_kem_dec
	.cfi_endproc
                                        # -- End function
	.type	aes_nonce,@object       # @aes_nonce
	.section	.rodata,"a",@progbits
	.p2align	4
aes_nonce:
	.zero	16
	.size	aes_nonce, 16


	.ident	"clang version 7.0.1-8 (tags/RELEASE_701/final)"
	.section	".note.GNU-stack","",@progbits
