	.text
	.file	"kem.c"
	.section	.rodata.cst4,"aM",@progbits,4
	.p2align	2               # -- Begin function crypto_kem_keypair
.LCPI0_0:
	.long	1073741823              # 0x3fffffff
.LCPI0_1:
	.long	3                       # 0x3
.LCPI0_3:
	.long	4294967294              # 0xfffffffe
.LCPI0_4:
	.long	4294967292              # 0xfffffffc
.LCPI0_5:
	.long	1                       # 0x1
	.section	.rodata.cst16,"aM",@progbits,16
	.p2align	4
.LCPI0_2:
	.byte	0                       # 0x0
	.byte	2                       # 0x2
	.byte	4                       # 0x4
	.byte	6                       # 0x6
	.byte	8                       # 0x8
	.byte	10                      # 0xa
	.byte	12                      # 0xc
	.byte	14                      # 0xe
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
.LCPI0_7:
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.section	.rodata.cst32,"aM",@progbits,32
	.p2align	5
.LCPI0_6:
	.byte	0                       # 0x0
	.byte	1                       # 0x1
	.byte	4                       # 0x4
	.byte	5                       # 0x5
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	14                      # 0xe
	.byte	15                      # 0xf
	.byte	16                      # 0x10
	.byte	17                      # 0x11
	.byte	20                      # 0x14
	.byte	21                      # 0x15
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	30                      # 0x1e
	.byte	31                      # 0x1f
	.text
	.globl	crypto_kem_keypair
	.p2align	4, 0x90
	.type	crypto_kem_keypair,@function
crypto_kem_keypair:                     # @crypto_kem_keypair
	.cfi_startproc
# %bb.0:
	pushq	%rbp
	.cfi_def_cfa_offset 16
	pushq	%r15
	.cfi_def_cfa_offset 24
	pushq	%r14
	.cfi_def_cfa_offset 32
	pushq	%r13
	.cfi_def_cfa_offset 40
	pushq	%r12
	.cfi_def_cfa_offset 48
	pushq	%rbx
	.cfi_def_cfa_offset 56
	subq	$10056, %rsp            # imm = 0x2748
	.cfi_def_cfa_offset 10112
	.cfi_offset %rbx, -56
	.cfi_offset %r12, -48
	.cfi_offset %r13, -40
	.cfi_offset %r14, -32
	.cfi_offset %r15, -24
	.cfi_offset %rbp, -16
	movq	%rsi, %rbx
	movq	%rdi, %r14
	vbroadcastss	.LCPI0_0(%rip), %ymm0 # ymm0 = [1073741823,1073741823,1073741823,1073741823,1073741823,1073741823,1073741823,1073741823]
	vmovups	%ymm0, 3104(%rsp)       # 32-byte Spill
	leaq	16(%rsp), %r15
	vpbroadcastd	.LCPI0_1(%rip), %ymm0 # ymm0 = [3,3,3,3,3,3,3,3]
	vmovdqu	%ymm0, 3072(%rsp)       # 32-byte Spill
	movl	$1073741823, %ebp       # imm = 0x3FFFFFFF
	leaq	4688(%rsp), %r12
	leaq	3152(%rsp), %r13
	.p2align	4, 0x90
.LBB0_1:                                # =>This Loop Header: Depth=1
                                        #     Child Loop BB0_2 Depth 2
	movl	$3044, %esi             # imm = 0xBE4
	movq	%r15, %rdi
	vzeroupper
	callq	randombytes@PLT
	movq	%r15, %rdi
	movq	%r15, %rsi
	callq	crypto_decode_761xint32_little@PLT
	movl	$24, %eax
	vmovdqa	.LCPI0_2(%rip), %xmm5   # xmm5 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	vmovdqa	%xmm5, %xmm8
	vmovdqu	3104(%rsp), %ymm6       # 32-byte Reload
	vmovdqu	3072(%rsp), %ymm7       # 32-byte Reload
	vpcmpeqd	%xmm5, %xmm5, %xmm5
	.p2align	4, 0x90
.LBB0_2:                                #   Parent Loop BB0_1 Depth=1
                                        # =>  This Inner Loop Header: Depth=2
	vpand	-80(%rsp,%rax,4), %ymm6, %ymm0
	vpand	-48(%rsp,%rax,4), %ymm6, %ymm1
	vpand	-16(%rsp,%rax,4), %ymm6, %ymm2
	vpand	16(%rsp,%rax,4), %ymm6, %ymm3
	vpmulld	%ymm7, %ymm0, %ymm0
	vpmulld	%ymm7, %ymm1, %ymm1
	vpmulld	%ymm7, %ymm2, %ymm2
	vpmulld	%ymm7, %ymm3, %ymm3
	vpsrld	$30, %ymm0, %ymm0
	vpsrld	$30, %ymm1, %ymm1
	vpsrld	$30, %ymm2, %ymm2
	vpsrld	$30, %ymm3, %ymm3
	vextracti128	$1, %ymm0, %xmm4
	vpackusdw	%xmm4, %xmm0, %xmm0
	vextracti128	$1, %ymm1, %xmm4
	vpackusdw	%xmm4, %xmm1, %xmm1
	vextracti128	$1, %ymm2, %xmm4
	vpackusdw	%xmm4, %xmm2, %xmm2
	vextracti128	$1, %ymm3, %xmm4
	vpackusdw	%xmm4, %xmm3, %xmm3
	vpaddb	%xmm5, %xmm0, %xmm0
	vpshufb	%xmm8, %xmm0, %xmm0
	vpaddb	%xmm5, %xmm1, %xmm1
	vpshufb	%xmm8, %xmm1, %xmm1
	vpunpcklqdq	%xmm1, %xmm0, %xmm0 # xmm0 = xmm0[0],xmm1[0]
	vmovdqa	%xmm0, 3128(%rsp,%rax)
	vpaddb	%xmm5, %xmm2, %xmm0
	vpshufb	%xmm8, %xmm0, %xmm0
	vpaddb	%xmm5, %xmm3, %xmm1
	vpshufb	%xmm8, %xmm1, %xmm1
	vpunpcklqdq	%xmm1, %xmm0, %xmm0 # xmm0 = xmm0[0],xmm1[0]
	vmovdqa	%xmm0, 3144(%rsp,%rax)
	addq	$32, %rax
	cmpq	$760, %rax              # imm = 0x2F8
	jne	.LBB0_2
# %bb.3:                                #   in Loop: Header=BB0_1 Depth=1
	movl	2960(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3888(%rsp)
	movl	2964(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3889(%rsp)
	movl	2968(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3890(%rsp)
	movl	2972(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3891(%rsp)
	movl	2976(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3892(%rsp)
	movl	2980(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3893(%rsp)
	movl	2984(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3894(%rsp)
	movl	2988(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3895(%rsp)
	movl	2992(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3896(%rsp)
	movl	2996(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3897(%rsp)
	movl	3000(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3898(%rsp)
	movl	3004(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3899(%rsp)
	movl	3008(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3900(%rsp)
	movl	3012(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3901(%rsp)
	movl	3016(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3902(%rsp)
	movl	3020(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3903(%rsp)
	movl	3024(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3904(%rsp)
	movl	3028(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3905(%rsp)
	movl	3032(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3906(%rsp)
	movl	3036(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3907(%rsp)
	movl	3040(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3908(%rsp)
	movl	3044(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3909(%rsp)
	movl	3048(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3910(%rsp)
	movl	3052(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3911(%rsp)
	movl	3056(%rsp), %eax
	andl	%ebp, %eax
	leal	(%rax,%rax,2), %eax
	shrl	$30, %eax
	addb	$-1, %al
	movb	%al, 3912(%rsp)
	xorl	%edx, %edx
	xorl	%ecx, %ecx
	movq	%r12, %rdi
	movq	%r13, %rsi
	vzeroupper
	callq	crypto_core_inv3sntrup761_avx@PLT
	cmpb	$0, 5449(%rsp)
	jne	.LBB0_1
# %bb.4:
	leaq	16(%rsp), %r15
	movl	$3044, %esi             # imm = 0xBE4
	movq	%r15, %rdi
	callq	randombytes@PLT
	movq	%r15, %rdi
	movq	%r15, %rsi
	callq	crypto_decode_761xint32_little@PLT
	vbroadcastss	.LCPI0_3(%rip), %ymm0 # ymm0 = [4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294]
	vandps	16(%rsp), %ymm0, %ymm1
	vandps	48(%rsp), %ymm0, %ymm2
	vandps	80(%rsp), %ymm0, %ymm3
	vandps	112(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 16(%rsp)
	vmovups	%ymm2, 48(%rsp)
	vmovups	%ymm3, 80(%rsp)
	vmovups	%ymm4, 112(%rsp)
	vandps	144(%rsp), %ymm0, %ymm1
	vandps	176(%rsp), %ymm0, %ymm2
	vandps	208(%rsp), %ymm0, %ymm3
	vandps	240(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 144(%rsp)
	vmovups	%ymm2, 176(%rsp)
	vmovups	%ymm3, 208(%rsp)
	vmovups	%ymm4, 240(%rsp)
	vandps	272(%rsp), %ymm0, %ymm1
	vandps	304(%rsp), %ymm0, %ymm2
	vandps	336(%rsp), %ymm0, %ymm3
	vandps	368(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 272(%rsp)
	vmovups	%ymm2, 304(%rsp)
	vmovups	%ymm3, 336(%rsp)
	vmovups	%ymm4, 368(%rsp)
	vandps	400(%rsp), %ymm0, %ymm1
	vandps	432(%rsp), %ymm0, %ymm2
	vandps	464(%rsp), %ymm0, %ymm3
	vandps	496(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 400(%rsp)
	vmovups	%ymm2, 432(%rsp)
	vmovups	%ymm3, 464(%rsp)
	vmovups	%ymm4, 496(%rsp)
	vandps	528(%rsp), %ymm0, %ymm1
	vandps	560(%rsp), %ymm0, %ymm2
	vandps	592(%rsp), %ymm0, %ymm3
	vandps	624(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 528(%rsp)
	vmovups	%ymm2, 560(%rsp)
	vmovups	%ymm3, 592(%rsp)
	vmovups	%ymm4, 624(%rsp)
	vandps	656(%rsp), %ymm0, %ymm1
	vandps	688(%rsp), %ymm0, %ymm2
	vandps	720(%rsp), %ymm0, %ymm3
	vandps	752(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 656(%rsp)
	vmovups	%ymm2, 688(%rsp)
	vmovups	%ymm3, 720(%rsp)
	vmovups	%ymm4, 752(%rsp)
	vandps	784(%rsp), %ymm0, %ymm1
	vandps	816(%rsp), %ymm0, %ymm2
	vandps	848(%rsp), %ymm0, %ymm3
	vandps	880(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 784(%rsp)
	vmovups	%ymm2, 816(%rsp)
	vmovups	%ymm3, 848(%rsp)
	vmovups	%ymm4, 880(%rsp)
	vandps	912(%rsp), %ymm0, %ymm1
	vandps	944(%rsp), %ymm0, %ymm2
	vandps	976(%rsp), %ymm0, %ymm3
	vandps	1008(%rsp), %ymm0, %ymm0
	vmovups	%ymm1, 912(%rsp)
	vmovups	%ymm2, 944(%rsp)
	vmovups	%ymm3, 976(%rsp)
	vmovups	%ymm0, 1008(%rsp)
	andb	$-2, 1040(%rsp)
	andb	$-2, 1044(%rsp)
	andb	$-2, 1048(%rsp)
	andb	$-2, 1052(%rsp)
	andb	$-2, 1056(%rsp)
	andb	$-2, 1060(%rsp)
	andb	$-2, 1064(%rsp)
	andb	$-2, 1068(%rsp)
	andb	$-2, 1072(%rsp)
	andb	$-2, 1076(%rsp)
	andb	$-2, 1080(%rsp)
	andb	$-2, 1084(%rsp)
	andb	$-2, 1088(%rsp)
	andb	$-2, 1092(%rsp)
	andb	$-2, 1096(%rsp)
	andb	$-2, 1100(%rsp)
	andb	$-2, 1104(%rsp)
	andb	$-2, 1108(%rsp)
	andb	$-2, 1112(%rsp)
	andb	$-2, 1116(%rsp)
	andb	$-2, 1120(%rsp)
	andb	$-2, 1124(%rsp)
	andb	$-2, 1128(%rsp)
	andb	$-2, 1132(%rsp)
	andb	$-2, 1136(%rsp)
	andb	$-2, 1140(%rsp)
	andb	$-2, 1144(%rsp)
	andb	$-2, 1148(%rsp)
	andb	$-2, 1152(%rsp)
	andb	$-2, 1156(%rsp)
	vpbroadcastd	.LCPI0_4(%rip), %ymm0 # ymm0 = [4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292]
	vpand	1160(%rsp), %ymm0, %ymm2
	vpand	1192(%rsp), %ymm0, %ymm3
	vpand	1224(%rsp), %ymm0, %ymm4
	vpand	1256(%rsp), %ymm0, %ymm5
	vpbroadcastd	.LCPI0_5(%rip), %ymm1 # ymm1 = [1,1,1,1,1,1,1,1]
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1160(%rsp)
	vmovdqu	%ymm3, 1192(%rsp)
	vmovdqu	%ymm4, 1224(%rsp)
	vmovdqu	%ymm5, 1256(%rsp)
	vpand	1288(%rsp), %ymm0, %ymm2
	vpand	1320(%rsp), %ymm0, %ymm3
	vpand	1352(%rsp), %ymm0, %ymm4
	vpand	1384(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1288(%rsp)
	vmovdqu	%ymm3, 1320(%rsp)
	vmovdqu	%ymm4, 1352(%rsp)
	vmovdqu	%ymm5, 1384(%rsp)
	vpand	1416(%rsp), %ymm0, %ymm2
	vpand	1448(%rsp), %ymm0, %ymm3
	vpand	1480(%rsp), %ymm0, %ymm4
	vpand	1512(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1416(%rsp)
	vmovdqu	%ymm3, 1448(%rsp)
	vmovdqu	%ymm4, 1480(%rsp)
	vmovdqu	%ymm5, 1512(%rsp)
	vpand	1544(%rsp), %ymm0, %ymm2
	vpand	1576(%rsp), %ymm0, %ymm3
	vpand	1608(%rsp), %ymm0, %ymm4
	vpand	1640(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1544(%rsp)
	vmovdqu	%ymm3, 1576(%rsp)
	vmovdqu	%ymm4, 1608(%rsp)
	vmovdqu	%ymm5, 1640(%rsp)
	vpand	1672(%rsp), %ymm0, %ymm2
	vpand	1704(%rsp), %ymm0, %ymm3
	vpand	1736(%rsp), %ymm0, %ymm4
	vpand	1768(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1672(%rsp)
	vmovdqu	%ymm3, 1704(%rsp)
	vmovdqu	%ymm4, 1736(%rsp)
	vmovdqu	%ymm5, 1768(%rsp)
	vpand	1800(%rsp), %ymm0, %ymm2
	vpand	1832(%rsp), %ymm0, %ymm3
	vpand	1864(%rsp), %ymm0, %ymm4
	vpand	1896(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1800(%rsp)
	vmovdqu	%ymm3, 1832(%rsp)
	vmovdqu	%ymm4, 1864(%rsp)
	vmovdqu	%ymm5, 1896(%rsp)
	vpand	1928(%rsp), %ymm0, %ymm2
	vpand	1960(%rsp), %ymm0, %ymm3
	vpand	1992(%rsp), %ymm0, %ymm4
	vpand	2024(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1928(%rsp)
	vmovdqu	%ymm3, 1960(%rsp)
	vmovdqu	%ymm4, 1992(%rsp)
	vmovdqu	%ymm5, 2024(%rsp)
	vpand	2056(%rsp), %ymm0, %ymm2
	vpand	2088(%rsp), %ymm0, %ymm3
	vpand	2120(%rsp), %ymm0, %ymm4
	vpand	2152(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2056(%rsp)
	vmovdqu	%ymm3, 2088(%rsp)
	vmovdqu	%ymm4, 2120(%rsp)
	vmovdqu	%ymm5, 2152(%rsp)
	vpand	2184(%rsp), %ymm0, %ymm2
	vpand	2216(%rsp), %ymm0, %ymm3
	vpand	2248(%rsp), %ymm0, %ymm4
	vpand	2280(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2184(%rsp)
	vmovdqu	%ymm3, 2216(%rsp)
	vmovdqu	%ymm4, 2248(%rsp)
	vmovdqu	%ymm5, 2280(%rsp)
	vpand	2312(%rsp), %ymm0, %ymm2
	vpand	2344(%rsp), %ymm0, %ymm3
	vpand	2376(%rsp), %ymm0, %ymm4
	vpand	2408(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2312(%rsp)
	vmovdqu	%ymm3, 2344(%rsp)
	vmovdqu	%ymm4, 2376(%rsp)
	vmovdqu	%ymm5, 2408(%rsp)
	vpand	2440(%rsp), %ymm0, %ymm2
	vpand	2472(%rsp), %ymm0, %ymm3
	vpand	2504(%rsp), %ymm0, %ymm4
	vpand	2536(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2440(%rsp)
	vmovdqu	%ymm3, 2472(%rsp)
	vmovdqu	%ymm4, 2504(%rsp)
	vmovdqu	%ymm5, 2536(%rsp)
	vpand	2568(%rsp), %ymm0, %ymm2
	vpand	2600(%rsp), %ymm0, %ymm3
	vpand	2632(%rsp), %ymm0, %ymm4
	vpand	2664(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2568(%rsp)
	vmovdqu	%ymm3, 2600(%rsp)
	vmovdqu	%ymm4, 2632(%rsp)
	vmovdqu	%ymm5, 2664(%rsp)
	vpand	2696(%rsp), %ymm0, %ymm2
	vpand	2728(%rsp), %ymm0, %ymm3
	vpand	2760(%rsp), %ymm0, %ymm4
	vpand	2792(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2696(%rsp)
	vmovdqu	%ymm3, 2728(%rsp)
	vmovdqu	%ymm4, 2760(%rsp)
	vmovdqu	%ymm5, 2792(%rsp)
	vpand	2824(%rsp), %ymm0, %ymm2
	vpand	2856(%rsp), %ymm0, %ymm3
	vpand	2888(%rsp), %ymm0, %ymm4
	vpand	2920(%rsp), %ymm0, %ymm0
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm0, %ymm0
	vmovdqu	%ymm2, 2824(%rsp)
	vmovdqu	%ymm3, 2856(%rsp)
	vmovdqu	%ymm4, 2888(%rsp)
	vmovdqu	%ymm0, 2920(%rsp)
	movl	2952(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2952(%rsp)
	movl	2956(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2956(%rsp)
	movl	2960(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2960(%rsp)
	movl	2964(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2964(%rsp)
	movl	2968(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2968(%rsp)
	movl	2972(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2972(%rsp)
	movl	2976(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2976(%rsp)
	movl	2980(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2980(%rsp)
	movl	2984(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2984(%rsp)
	movl	2988(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2988(%rsp)
	movl	2992(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2992(%rsp)
	movl	2996(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2996(%rsp)
	movl	3000(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3000(%rsp)
	movl	3004(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3004(%rsp)
	movl	3008(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3008(%rsp)
	movl	3012(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3012(%rsp)
	movl	3016(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3016(%rsp)
	movl	3020(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3020(%rsp)
	movl	3024(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3024(%rsp)
	movl	3028(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3028(%rsp)
	movl	3032(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3032(%rsp)
	movl	3036(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3036(%rsp)
	movl	3040(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3040(%rsp)
	movl	3044(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3044(%rsp)
	movl	3048(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3048(%rsp)
	movl	3052(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3052(%rsp)
	movl	3056(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3056(%rsp)
	movl	$761, %esi              # imm = 0x2F9
	movq	%r15, %rdi
	vzeroupper
	callq	crypto_sort_uint32_useint32@PLT
	movl	$24, %eax
	vmovdqa	.LCPI0_6(%rip), %ymm0   # ymm0 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	vmovdqa	.LCPI0_7(%rip), %xmm1   # xmm1 = [3,3,3,3,3,3,3,3]
	vpcmpeqd	%xmm2, %xmm2, %xmm2
	vmovdqa	.LCPI0_2(%rip), %xmm7   # xmm7 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	.p2align	4, 0x90
.LBB0_5:                                # =>This Inner Loop Header: Depth=1
	vmovdqu	-80(%rsp,%rax,4), %ymm3
	vmovdqu	-48(%rsp,%rax,4), %ymm4
	vmovdqu	-16(%rsp,%rax,4), %ymm5
	vmovdqu	16(%rsp,%rax,4), %ymm6
	vpshufb	%ymm0, %ymm3, %ymm3
	vpermq	$232, %ymm3, %ymm3      # ymm3 = ymm3[0,2,2,3]
	vpshufb	%ymm0, %ymm4, %ymm4
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vpshufb	%ymm0, %ymm5, %ymm5
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpshufb	%ymm0, %ymm6, %ymm6
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpand	%xmm1, %xmm3, %xmm3
	vpand	%xmm1, %xmm4, %xmm4
	vpand	%xmm1, %xmm5, %xmm5
	vpand	%xmm1, %xmm6, %xmm6
	vpaddb	%xmm2, %xmm3, %xmm3
	vpshufb	%xmm7, %xmm3, %xmm3
	vpaddb	%xmm2, %xmm4, %xmm4
	vpshufb	%xmm7, %xmm4, %xmm4
	vpunpcklqdq	%xmm4, %xmm3, %xmm3 # xmm3 = xmm3[0],xmm4[0]
	vmovdqa	%xmm3, 3896(%rsp,%rax)
	vpaddb	%xmm2, %xmm5, %xmm3
	vpshufb	%xmm7, %xmm3, %xmm3
	vpaddb	%xmm2, %xmm6, %xmm4
	vpshufb	%xmm7, %xmm4, %xmm4
	vpunpcklqdq	%xmm4, %xmm3, %xmm3 # xmm3 = xmm3[0],xmm4[0]
	vmovdqa	%xmm3, 3912(%rsp,%rax)
	addq	$32, %rax
	cmpq	$760, %rax              # imm = 0x2F8
	jne	.LBB0_5
# %bb.6:
	movb	2960(%rsp), %al
	movb	2964(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4656(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 4657(%rsp)
	movb	2968(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4658(%rsp)
	movb	2972(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4659(%rsp)
	movb	2976(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4660(%rsp)
	movb	2980(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4661(%rsp)
	movb	2984(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4662(%rsp)
	movb	2988(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4663(%rsp)
	movb	2992(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4664(%rsp)
	movb	2996(%rsp), %al
	movb	3000(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4665(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 4666(%rsp)
	movb	3004(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4667(%rsp)
	movb	3008(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4668(%rsp)
	movb	3012(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4669(%rsp)
	movb	3016(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4670(%rsp)
	movb	3020(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4671(%rsp)
	movb	3024(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4672(%rsp)
	movb	3028(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4673(%rsp)
	movb	3032(%rsp), %al
	movb	3036(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4674(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 4675(%rsp)
	movb	3040(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4676(%rsp)
	movb	3044(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4677(%rsp)
	movb	3048(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4678(%rsp)
	movb	3052(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4679(%rsp)
	movb	3056(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 4680(%rsp)
	xorl	%ebp, %ebp
	leaq	16(%rsp), %r15
	leaq	3920(%rsp), %rsi
	xorl	%edx, %edx
	xorl	%ecx, %ecx
	movq	%r15, %rdi
	vzeroupper
	callq	crypto_core_invsntrup761_avx@PLT
	leaq	6992(%rsp), %r12
	movq	%r12, %rdi
	movq	%r15, %rsi
	callq	crypto_decode_761xint16_little@PLT
	leaq	8528(%rsp), %r15
	movq	%r15, %rdi
	movq	%r12, %rsi
	callq	crypto_encode_761xint16_little@PLT
	leaq	16(%rsp), %r12
	leaq	3152(%rsp), %rdx
	xorl	%ecx, %ecx
	movq	%r12, %rdi
	movq	%r15, %rsi
	callq	crypto_core_multsntrup761_avx@PLT
	leaq	5456(%rsp), %r15
	movq	%r15, %rdi
	movq	%r12, %rsi
	callq	crypto_decode_761xint16_little@PLT
	movq	%r14, %rdi
	movq	%r15, %rsi
	callq	crypto_encode_761x4591_avx@PLT
	leaq	382(%rbx), %rax
	leaq	1540(%rbx), %r15
	leaq	1158(%r14), %rcx
	cmpq	%rcx, %rax
	jae	.LBB0_8
# %bb.7:
	cmpq	%r14, %r15
	ja	.LBB0_9
.LBB0_8:
	vmovups	(%r14), %ymm0
	vmovups	32(%r14), %ymm1
	vmovups	64(%r14), %ymm2
	vmovups	96(%r14), %ymm3
	vmovups	%ymm0, 382(%rbx)
	vmovups	%ymm1, 414(%rbx)
	vmovups	%ymm2, 446(%rbx)
	vmovups	%ymm3, 478(%rbx)
	vmovups	128(%r14), %ymm0
	vmovups	160(%r14), %ymm1
	vmovups	192(%r14), %ymm2
	vmovups	224(%r14), %ymm3
	vmovups	%ymm0, 510(%rbx)
	vmovups	%ymm1, 542(%rbx)
	vmovups	%ymm2, 574(%rbx)
	vmovups	%ymm3, 606(%rbx)
	vmovups	256(%r14), %ymm0
	vmovups	288(%r14), %ymm1
	vmovups	320(%r14), %ymm2
	vmovups	352(%r14), %ymm3
	vmovups	%ymm0, 638(%rbx)
	vmovups	%ymm1, 670(%rbx)
	vmovups	%ymm2, 702(%rbx)
	vmovups	%ymm3, 734(%rbx)
	vmovups	384(%r14), %ymm0
	vmovups	416(%r14), %ymm1
	vmovups	448(%r14), %ymm2
	vmovups	480(%r14), %ymm3
	vmovups	%ymm0, 766(%rbx)
	vmovups	%ymm1, 798(%rbx)
	vmovups	%ymm2, 830(%rbx)
	vmovups	%ymm3, 862(%rbx)
	vmovups	512(%r14), %ymm0
	vmovups	544(%r14), %ymm1
	vmovups	576(%r14), %ymm2
	vmovups	608(%r14), %ymm3
	vmovups	%ymm0, 894(%rbx)
	vmovups	%ymm1, 926(%rbx)
	vmovups	%ymm2, 958(%rbx)
	vmovups	%ymm3, 990(%rbx)
	vmovups	640(%r14), %ymm0
	vmovups	672(%r14), %ymm1
	vmovups	704(%r14), %ymm2
	vmovups	736(%r14), %ymm3
	vmovups	%ymm0, 1022(%rbx)
	vmovups	%ymm1, 1054(%rbx)
	vmovups	%ymm2, 1086(%rbx)
	vmovups	%ymm3, 1118(%rbx)
	vmovups	768(%r14), %ymm0
	vmovups	800(%r14), %ymm1
	vmovups	832(%r14), %ymm2
	vmovups	864(%r14), %ymm3
	vmovups	%ymm0, 1150(%rbx)
	vmovups	%ymm1, 1182(%rbx)
	vmovups	%ymm2, 1214(%rbx)
	vmovups	%ymm3, 1246(%rbx)
	vmovups	896(%r14), %ymm0
	vmovups	928(%r14), %ymm1
	vmovups	960(%r14), %ymm2
	vmovups	992(%r14), %ymm3
	vmovups	%ymm0, 1278(%rbx)
	vmovups	%ymm1, 1310(%rbx)
	vmovups	%ymm2, 1342(%rbx)
	vmovups	%ymm3, 1374(%rbx)
	vmovdqu	1024(%r14), %ymm0
	vmovdqu	1056(%r14), %ymm1
	vmovdqu	1088(%r14), %ymm2
	vmovdqu	1120(%r14), %ymm3
	vmovdqu	%ymm0, 1406(%rbx)
	vmovdqu	%ymm1, 1438(%rbx)
	vmovdqu	%ymm2, 1470(%rbx)
	vmovdqu	%ymm3, 1502(%rbx)
	movl	$1152, %ebp             # imm = 0x480
.LBB0_9:
	movq	$-2, %rax
	.p2align	4, 0x90
.LBB0_10:                               # =>This Inner Loop Header: Depth=1
	movzbl	(%r14,%rbp), %ecx
	movb	%cl, 382(%rbx,%rbp)
	addq	$1, %rbp
	addq	$1, %rax
	jne	.LBB0_10
	.p2align	4, 0x90
.LBB0_11:                               # =>This Inner Loop Header: Depth=1
	movzbl	(%r14,%rbp), %eax
	movb	%al, 382(%rbx,%rbp)
	movzbl	1(%r14,%rbp), %eax
	movb	%al, 383(%rbx,%rbp)
	movzbl	2(%r14,%rbp), %eax
	movb	%al, 384(%rbx,%rbp)
	movzbl	3(%r14,%rbp), %eax
	movb	%al, 385(%rbx,%rbp)
	addq	$4, %rbp
	cmpq	$1158, %rbp             # imm = 0x486
	jne	.LBB0_11
# %bb.12:
	leaq	381(%rbx), %rsi
	movb	$4, 381(%rbx)
	leaq	16(%rsp), %rdi
	movl	$1159, %edx             # imm = 0x487
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	16(%rsp), %ymm0
	vmovups	%ymm0, 1731(%rbx)
	leaq	3920(%rsp), %rsi
	movq	%rbx, %rdi
	vzeroupper
	callq	crypto_encode_761x3_ref@PLT
	addq	$191, %rbx
	leaq	4688(%rsp), %rsi
	movq	%rbx, %rdi
	callq	crypto_encode_761x3_ref@PLT
	movl	$191, %esi
	movq	%r15, %rdi
	callq	randombytes@PLT
	xorl	%eax, %eax
	addq	$10056, %rsp            # imm = 0x2748
	.cfi_def_cfa_offset 56
	popq	%rbx
	.cfi_def_cfa_offset 48
	popq	%r12
	.cfi_def_cfa_offset 40
	popq	%r13
	.cfi_def_cfa_offset 32
	popq	%r14
	.cfi_def_cfa_offset 24
	popq	%r15
	.cfi_def_cfa_offset 16
	popq	%rbp
	.cfi_def_cfa_offset 8
	retq
.Lfunc_end0:
	.size	crypto_kem_keypair, .Lfunc_end0-crypto_kem_keypair
	.cfi_endproc
                                        # -- End function
	.section	.rodata.cst4,"aM",@progbits,4
	.p2align	2               # -- Begin function crypto_kem_enc
.LCPI1_0:
	.long	4294967294              # 0xfffffffe
.LCPI1_1:
	.long	4294967292              # 0xfffffffc
.LCPI1_2:
	.long	1                       # 0x1
	.section	.rodata.cst32,"aM",@progbits,32
	.p2align	5
.LCPI1_3:
	.byte	0                       # 0x0
	.byte	1                       # 0x1
	.byte	4                       # 0x4
	.byte	5                       # 0x5
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	14                      # 0xe
	.byte	15                      # 0xf
	.byte	16                      # 0x10
	.byte	17                      # 0x11
	.byte	20                      # 0x14
	.byte	21                      # 0x15
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	30                      # 0x1e
	.byte	31                      # 0x1f
	.section	.rodata.cst16,"aM",@progbits,16
	.p2align	4
.LCPI1_4:
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
	.short	3                       # 0x3
.LCPI1_5:
	.byte	0                       # 0x0
	.byte	2                       # 0x2
	.byte	4                       # 0x4
	.byte	6                       # 0x6
	.byte	8                       # 0x8
	.byte	10                      # 0xa
	.byte	12                      # 0xc
	.byte	14                      # 0xe
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.text
	.globl	crypto_kem_enc
	.p2align	4, 0x90
	.type	crypto_kem_enc,@function
crypto_kem_enc:                         # @crypto_kem_enc
	.cfi_startproc
# %bb.0:
	pushq	%rbp
	.cfi_def_cfa_offset 16
	pushq	%r15
	.cfi_def_cfa_offset 24
	pushq	%r14
	.cfi_def_cfa_offset 32
	pushq	%r13
	.cfi_def_cfa_offset 40
	pushq	%r12
	.cfi_def_cfa_offset 48
	pushq	%rbx
	.cfi_def_cfa_offset 56
	subq	$9816, %rsp             # imm = 0x2658
	.cfi_def_cfa_offset 9872
	.cfi_offset %rbx, -56
	.cfi_offset %r12, -48
	.cfi_offset %r13, -40
	.cfi_offset %r14, -32
	.cfi_offset %r15, -24
	.cfi_offset %rbp, -16
	movq	%rdx, %r15
	movq	%rsi, %r14
	movq	%rdi, %r12
	leaq	5585(%rsp), %rdi
	movl	$1158, %edx             # imm = 0x486
	movq	%r15, %rsi
	callq	memcpy@PLT
	movb	$4, 5584(%rsp)
	leaq	4048(%rsp), %rdi
	leaq	5584(%rsp), %rsi
	movl	$1159, %edx             # imm = 0x487
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	4048(%rsp), %ymm0
	vmovups	%ymm0, 3056(%rsp)
	movq	%rsp, %rbx
	movl	$3044, %esi             # imm = 0xBE4
	movq	%rbx, %rdi
	vzeroupper
	callq	randombytes@PLT
	movq	%rbx, %rdi
	movq	%rbx, %rsi
	callq	crypto_decode_761xint32_little@PLT
	vbroadcastss	.LCPI1_0(%rip), %ymm0 # ymm0 = [4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294,4294967294]
	vandps	(%rsp), %ymm0, %ymm1
	vandps	32(%rsp), %ymm0, %ymm2
	vandps	64(%rsp), %ymm0, %ymm3
	vandps	96(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, (%rsp)
	vmovups	%ymm2, 32(%rsp)
	vmovups	%ymm3, 64(%rsp)
	vmovups	%ymm4, 96(%rsp)
	vandps	128(%rsp), %ymm0, %ymm1
	vandps	160(%rsp), %ymm0, %ymm2
	vandps	192(%rsp), %ymm0, %ymm3
	vandps	224(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 128(%rsp)
	vmovups	%ymm2, 160(%rsp)
	vmovups	%ymm3, 192(%rsp)
	vmovups	%ymm4, 224(%rsp)
	vandps	256(%rsp), %ymm0, %ymm1
	vandps	288(%rsp), %ymm0, %ymm2
	vandps	320(%rsp), %ymm0, %ymm3
	vandps	352(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 256(%rsp)
	vmovups	%ymm2, 288(%rsp)
	vmovups	%ymm3, 320(%rsp)
	vmovups	%ymm4, 352(%rsp)
	vandps	384(%rsp), %ymm0, %ymm1
	vandps	416(%rsp), %ymm0, %ymm2
	vandps	448(%rsp), %ymm0, %ymm3
	vandps	480(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 384(%rsp)
	vmovups	%ymm2, 416(%rsp)
	vmovups	%ymm3, 448(%rsp)
	vmovups	%ymm4, 480(%rsp)
	vandps	512(%rsp), %ymm0, %ymm1
	vandps	544(%rsp), %ymm0, %ymm2
	vandps	576(%rsp), %ymm0, %ymm3
	vandps	608(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 512(%rsp)
	vmovups	%ymm2, 544(%rsp)
	vmovups	%ymm3, 576(%rsp)
	vmovups	%ymm4, 608(%rsp)
	vandps	640(%rsp), %ymm0, %ymm1
	vandps	672(%rsp), %ymm0, %ymm2
	vandps	704(%rsp), %ymm0, %ymm3
	vandps	736(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 640(%rsp)
	vmovups	%ymm2, 672(%rsp)
	vmovups	%ymm3, 704(%rsp)
	vmovups	%ymm4, 736(%rsp)
	vandps	768(%rsp), %ymm0, %ymm1
	vandps	800(%rsp), %ymm0, %ymm2
	vandps	832(%rsp), %ymm0, %ymm3
	vandps	864(%rsp), %ymm0, %ymm4
	vmovups	%ymm1, 768(%rsp)
	vmovups	%ymm2, 800(%rsp)
	vmovups	%ymm3, 832(%rsp)
	vmovups	%ymm4, 864(%rsp)
	vandps	896(%rsp), %ymm0, %ymm1
	vandps	928(%rsp), %ymm0, %ymm2
	vandps	960(%rsp), %ymm0, %ymm3
	vandps	992(%rsp), %ymm0, %ymm0
	vmovups	%ymm1, 896(%rsp)
	vmovups	%ymm2, 928(%rsp)
	vmovups	%ymm3, 960(%rsp)
	vmovups	%ymm0, 992(%rsp)
	andb	$-2, 1024(%rsp)
	andb	$-2, 1028(%rsp)
	andb	$-2, 1032(%rsp)
	andb	$-2, 1036(%rsp)
	andb	$-2, 1040(%rsp)
	andb	$-2, 1044(%rsp)
	andb	$-2, 1048(%rsp)
	andb	$-2, 1052(%rsp)
	andb	$-2, 1056(%rsp)
	andb	$-2, 1060(%rsp)
	andb	$-2, 1064(%rsp)
	andb	$-2, 1068(%rsp)
	andb	$-2, 1072(%rsp)
	andb	$-2, 1076(%rsp)
	andb	$-2, 1080(%rsp)
	andb	$-2, 1084(%rsp)
	andb	$-2, 1088(%rsp)
	andb	$-2, 1092(%rsp)
	andb	$-2, 1096(%rsp)
	andb	$-2, 1100(%rsp)
	andb	$-2, 1104(%rsp)
	andb	$-2, 1108(%rsp)
	andb	$-2, 1112(%rsp)
	andb	$-2, 1116(%rsp)
	andb	$-2, 1120(%rsp)
	andb	$-2, 1124(%rsp)
	andb	$-2, 1128(%rsp)
	andb	$-2, 1132(%rsp)
	andb	$-2, 1136(%rsp)
	andb	$-2, 1140(%rsp)
	vpbroadcastd	.LCPI1_1(%rip), %ymm0 # ymm0 = [4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292,4294967292]
	vpand	1144(%rsp), %ymm0, %ymm2
	vpand	1176(%rsp), %ymm0, %ymm3
	vpand	1208(%rsp), %ymm0, %ymm4
	vpand	1240(%rsp), %ymm0, %ymm5
	vpbroadcastd	.LCPI1_2(%rip), %ymm1 # ymm1 = [1,1,1,1,1,1,1,1]
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1144(%rsp)
	vmovdqu	%ymm3, 1176(%rsp)
	vmovdqu	%ymm4, 1208(%rsp)
	vmovdqu	%ymm5, 1240(%rsp)
	vpand	1272(%rsp), %ymm0, %ymm2
	vpand	1304(%rsp), %ymm0, %ymm3
	vpand	1336(%rsp), %ymm0, %ymm4
	vpand	1368(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1272(%rsp)
	vmovdqu	%ymm3, 1304(%rsp)
	vmovdqu	%ymm4, 1336(%rsp)
	vmovdqu	%ymm5, 1368(%rsp)
	vpand	1400(%rsp), %ymm0, %ymm2
	vpand	1432(%rsp), %ymm0, %ymm3
	vpand	1464(%rsp), %ymm0, %ymm4
	vpand	1496(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1400(%rsp)
	vmovdqu	%ymm3, 1432(%rsp)
	vmovdqu	%ymm4, 1464(%rsp)
	vmovdqu	%ymm5, 1496(%rsp)
	vpand	1528(%rsp), %ymm0, %ymm2
	vpand	1560(%rsp), %ymm0, %ymm3
	vpand	1592(%rsp), %ymm0, %ymm4
	vpand	1624(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1528(%rsp)
	vmovdqu	%ymm3, 1560(%rsp)
	vmovdqu	%ymm4, 1592(%rsp)
	vmovdqu	%ymm5, 1624(%rsp)
	vpand	1656(%rsp), %ymm0, %ymm2
	vpand	1688(%rsp), %ymm0, %ymm3
	vpand	1720(%rsp), %ymm0, %ymm4
	vpand	1752(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1656(%rsp)
	vmovdqu	%ymm3, 1688(%rsp)
	vmovdqu	%ymm4, 1720(%rsp)
	vmovdqu	%ymm5, 1752(%rsp)
	vpand	1784(%rsp), %ymm0, %ymm2
	vpand	1816(%rsp), %ymm0, %ymm3
	vpand	1848(%rsp), %ymm0, %ymm4
	vpand	1880(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1784(%rsp)
	vmovdqu	%ymm3, 1816(%rsp)
	vmovdqu	%ymm4, 1848(%rsp)
	vmovdqu	%ymm5, 1880(%rsp)
	vpand	1912(%rsp), %ymm0, %ymm2
	vpand	1944(%rsp), %ymm0, %ymm3
	vpand	1976(%rsp), %ymm0, %ymm4
	vpand	2008(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 1912(%rsp)
	vmovdqu	%ymm3, 1944(%rsp)
	vmovdqu	%ymm4, 1976(%rsp)
	vmovdqu	%ymm5, 2008(%rsp)
	vpand	2040(%rsp), %ymm0, %ymm2
	vpand	2072(%rsp), %ymm0, %ymm3
	vpand	2104(%rsp), %ymm0, %ymm4
	vpand	2136(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2040(%rsp)
	vmovdqu	%ymm3, 2072(%rsp)
	vmovdqu	%ymm4, 2104(%rsp)
	vmovdqu	%ymm5, 2136(%rsp)
	vpand	2168(%rsp), %ymm0, %ymm2
	vpand	2200(%rsp), %ymm0, %ymm3
	vpand	2232(%rsp), %ymm0, %ymm4
	vpand	2264(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2168(%rsp)
	vmovdqu	%ymm3, 2200(%rsp)
	vmovdqu	%ymm4, 2232(%rsp)
	vmovdqu	%ymm5, 2264(%rsp)
	vpand	2296(%rsp), %ymm0, %ymm2
	vpand	2328(%rsp), %ymm0, %ymm3
	vpand	2360(%rsp), %ymm0, %ymm4
	vpand	2392(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2296(%rsp)
	vmovdqu	%ymm3, 2328(%rsp)
	vmovdqu	%ymm4, 2360(%rsp)
	vmovdqu	%ymm5, 2392(%rsp)
	vpand	2424(%rsp), %ymm0, %ymm2
	vpand	2456(%rsp), %ymm0, %ymm3
	vpand	2488(%rsp), %ymm0, %ymm4
	vpand	2520(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2424(%rsp)
	vmovdqu	%ymm3, 2456(%rsp)
	vmovdqu	%ymm4, 2488(%rsp)
	vmovdqu	%ymm5, 2520(%rsp)
	vpand	2552(%rsp), %ymm0, %ymm2
	vpand	2584(%rsp), %ymm0, %ymm3
	vpand	2616(%rsp), %ymm0, %ymm4
	vpand	2648(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2552(%rsp)
	vmovdqu	%ymm3, 2584(%rsp)
	vmovdqu	%ymm4, 2616(%rsp)
	vmovdqu	%ymm5, 2648(%rsp)
	vpand	2680(%rsp), %ymm0, %ymm2
	vpand	2712(%rsp), %ymm0, %ymm3
	vpand	2744(%rsp), %ymm0, %ymm4
	vpand	2776(%rsp), %ymm0, %ymm5
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm5, %ymm5
	vmovdqu	%ymm2, 2680(%rsp)
	vmovdqu	%ymm3, 2712(%rsp)
	vmovdqu	%ymm4, 2744(%rsp)
	vmovdqu	%ymm5, 2776(%rsp)
	vpand	2808(%rsp), %ymm0, %ymm2
	vpand	2840(%rsp), %ymm0, %ymm3
	vpand	2872(%rsp), %ymm0, %ymm4
	vpand	2904(%rsp), %ymm0, %ymm0
	vpor	%ymm1, %ymm2, %ymm2
	vpor	%ymm1, %ymm3, %ymm3
	vpor	%ymm1, %ymm4, %ymm4
	vpor	%ymm1, %ymm0, %ymm0
	vmovdqu	%ymm2, 2808(%rsp)
	vmovdqu	%ymm3, 2840(%rsp)
	vmovdqu	%ymm4, 2872(%rsp)
	vmovdqu	%ymm0, 2904(%rsp)
	movl	2936(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2936(%rsp)
	movl	2940(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2940(%rsp)
	movl	2944(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2944(%rsp)
	movl	2948(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2948(%rsp)
	movl	2952(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2952(%rsp)
	movl	2956(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2956(%rsp)
	movl	2960(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2960(%rsp)
	movl	2964(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2964(%rsp)
	movl	2968(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2968(%rsp)
	movl	2972(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2972(%rsp)
	movl	2976(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2976(%rsp)
	movl	2980(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2980(%rsp)
	movl	2984(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2984(%rsp)
	movl	2988(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2988(%rsp)
	movl	2992(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2992(%rsp)
	movl	2996(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 2996(%rsp)
	movl	3000(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3000(%rsp)
	movl	3004(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3004(%rsp)
	movl	3008(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3008(%rsp)
	movl	3012(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3012(%rsp)
	movl	3016(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3016(%rsp)
	movl	3020(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3020(%rsp)
	movl	3024(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3024(%rsp)
	movl	3028(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3028(%rsp)
	movl	3032(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3032(%rsp)
	movl	3036(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3036(%rsp)
	movl	3040(%rsp), %eax
	andl	$-4, %eax
	orl	$1, %eax
	movl	%eax, 3040(%rsp)
	movl	$761, %esi              # imm = 0x2F9
	movq	%rbx, %rdi
	vzeroupper
	callq	crypto_sort_uint32_useint32@PLT
	movl	$24, %eax
	vmovdqa	.LCPI1_3(%rip), %ymm0   # ymm0 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	vmovdqa	.LCPI1_4(%rip), %xmm1   # xmm1 = [3,3,3,3,3,3,3,3]
	vpcmpeqd	%xmm2, %xmm2, %xmm2
	vmovdqa	.LCPI1_5(%rip), %xmm3   # xmm3 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	.p2align	4, 0x90
.LBB1_1:                                # =>This Inner Loop Header: Depth=1
	vmovdqu	-96(%rsp,%rax,4), %ymm4
	vmovdqu	-64(%rsp,%rax,4), %ymm5
	vmovdqu	-32(%rsp,%rax,4), %ymm6
	vmovdqu	(%rsp,%rax,4), %ymm7
	vpshufb	%ymm0, %ymm4, %ymm4
	vpermq	$232, %ymm4, %ymm4      # ymm4 = ymm4[0,2,2,3]
	vpshufb	%ymm0, %ymm5, %ymm5
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpshufb	%ymm0, %ymm6, %ymm6
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpshufb	%ymm0, %ymm7, %ymm7
	vpermq	$232, %ymm7, %ymm7      # ymm7 = ymm7[0,2,2,3]
	vpand	%xmm1, %xmm4, %xmm4
	vpand	%xmm1, %xmm5, %xmm5
	vpand	%xmm1, %xmm6, %xmm6
	vpand	%xmm1, %xmm7, %xmm7
	vpaddb	%xmm2, %xmm4, %xmm4
	vpshufb	%xmm3, %xmm4, %xmm4
	vpaddb	%xmm2, %xmm5, %xmm5
	vpshufb	%xmm3, %xmm5, %xmm5
	vpunpcklqdq	%xmm5, %xmm4, %xmm4 # xmm4 = xmm4[0],xmm5[0]
	vmovdqa	%xmm4, 3064(%rsp,%rax)
	vpaddb	%xmm2, %xmm6, %xmm4
	vpshufb	%xmm3, %xmm4, %xmm4
	vpaddb	%xmm2, %xmm7, %xmm5
	vpshufb	%xmm3, %xmm5, %xmm5
	vpunpcklqdq	%xmm5, %xmm4, %xmm4 # xmm4 = xmm4[0],xmm5[0]
	vmovdqa	%xmm4, 3080(%rsp,%rax)
	addq	$32, %rax
	cmpq	$760, %rax              # imm = 0x2F8
	jne	.LBB1_1
# %bb.2:
	movb	2944(%rsp), %al
	movb	2948(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3824(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 3825(%rsp)
	movb	2952(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3826(%rsp)
	movb	2956(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3827(%rsp)
	movb	2960(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3828(%rsp)
	movb	2964(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3829(%rsp)
	movb	2968(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3830(%rsp)
	movb	2972(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3831(%rsp)
	movb	2976(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3832(%rsp)
	movb	2980(%rsp), %al
	movb	2984(%rsp), %cl
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3833(%rsp)
	andb	$3, %cl
	addb	$-1, %cl
	movb	%cl, 3834(%rsp)
	movb	2988(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3835(%rsp)
	movb	2992(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3836(%rsp)
	movb	2996(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3837(%rsp)
	movb	3000(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3838(%rsp)
	movb	3004(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3839(%rsp)
	movb	3008(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3840(%rsp)
	movb	3012(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3841(%rsp)
	movb	3016(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3842(%rsp)
	movb	3020(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3843(%rsp)
	movb	3024(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3844(%rsp)
	movb	3028(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3845(%rsp)
	movb	3032(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3846(%rsp)
	movb	3036(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3847(%rsp)
	movb	3040(%rsp), %al
	andb	$3, %al
	addb	$-1, %al
	movb	%al, 3848(%rsp)
	leaq	3857(%rsp), %rdi
	leaq	3088(%rsp), %r13
	movq	%r13, %rsi
	vzeroupper
	callq	crypto_encode_761x3_ref@PLT
	leaq	8288(%rsp), %rbx
	movq	%rbx, %rdi
	movq	%r15, %rsi
	callq	crypto_decode_761x4591_avx@PLT
	leaq	4048(%rsp), %r15
	movq	%r15, %rdi
	movq	%rbx, %rsi
	callq	crypto_encode_761xint16_little@PLT
	movq	%rsp, %rbp
	xorl	%ecx, %ecx
	movq	%rbp, %rdi
	movq	%r15, %rsi
	movq	%r13, %rdx
	callq	crypto_core_multsntrup761_avx@PLT
	leaq	6752(%rsp), %rbx
	movq	%rbx, %rdi
	movq	%rbp, %rsi
	callq	crypto_decode_761xint16_little@PLT
	movq	%r12, %rdi
	movq	%rbx, %rsi
	callq	crypto_encode_761x1531round_ref@PLT
	movb	$3, 3856(%rsp)
	leaq	4048(%rsp), %rbx
	leaq	3856(%rsp), %rbp
	movl	$192, %edx
	movq	%rbx, %rdi
	movq	%rbp, %rsi
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	4048(%rsp), %ymm0
	vmovups	%ymm0, 1(%rsp)
	vmovups	3056(%rsp), %ymm0
	vmovups	%ymm0, 33(%rsp)
	movb	$2, (%rsp)
	movq	%rsp, %rsi
	movl	$65, %edx
	movq	%rbx, %rdi
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	4048(%rsp), %ymm0
	vmovups	%ymm0, 1007(%r12)
	movb	$3, 3856(%rsp)
	movl	$192, %edx
	movq	%rbx, %rdi
	movq	%rbp, %rsi
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	4048(%rsp), %ymm0
	vmovups	%ymm0, 1(%rsp)
	leaq	33(%rsp), %rdi
	movl	$1039, %edx             # imm = 0x40F
	movq	%r12, %rsi
	vzeroupper
	callq	memcpy@PLT
	movb	$1, (%rsp)
	movq	%rsp, %rsi
	movl	$1072, %edx             # imm = 0x430
	movq	%rbx, %rdi
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	4048(%rsp), %ymm0
	vmovups	%ymm0, (%r14)
	xorl	%eax, %eax
	addq	$9816, %rsp             # imm = 0x2658
	.cfi_def_cfa_offset 56
	popq	%rbx
	.cfi_def_cfa_offset 48
	popq	%r12
	.cfi_def_cfa_offset 40
	popq	%r13
	.cfi_def_cfa_offset 32
	popq	%r14
	.cfi_def_cfa_offset 24
	popq	%r15
	.cfi_def_cfa_offset 16
	popq	%rbp
	.cfi_def_cfa_offset 8
	vzeroupper
	retq
.Lfunc_end1:
	.size	crypto_kem_enc, .Lfunc_end1-crypto_kem_enc
	.cfi_endproc
                                        # -- End function
	.section	.rodata.cst4,"aM",@progbits,4
	.p2align	2               # -- Begin function crypto_kem_dec
.LCPI2_0:
	.long	3                       # 0x3
.LCPI2_1:
	.long	171                     # 0xab
.LCPI2_2:
	.long	4294962705              # 0xffffee11
.LCPI2_3:
	.long	29235                   # 0x7233
.LCPI2_4:
	.long	67108864                # 0x4000000
.LCPI2_6:
	.long	10923                   # 0x2aab
.LCPI2_7:
	.long	16384                   # 0x4000
.LCPI2_8:
	.long	4294967293              # 0xfffffffd
	.section	.rodata.cst32,"aM",@progbits,32
	.p2align	5
.LCPI2_5:
	.byte	0                       # 0x0
	.byte	1                       # 0x1
	.byte	4                       # 0x4
	.byte	5                       # 0x5
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	8                       # 0x8
	.byte	9                       # 0x9
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	12                      # 0xc
	.byte	13                      # 0xd
	.byte	14                      # 0xe
	.byte	15                      # 0xf
	.byte	16                      # 0x10
	.byte	17                      # 0x11
	.byte	20                      # 0x14
	.byte	21                      # 0x15
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	24                      # 0x18
	.byte	25                      # 0x19
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	28                      # 0x1c
	.byte	29                      # 0x1d
	.byte	30                      # 0x1e
	.byte	31                      # 0x1f
.LCPI2_11:
	.zero	32,1
	.section	.rodata.cst16,"aM",@progbits,16
	.p2align	4
.LCPI2_9:
	.byte	0                       # 0x0
	.byte	2                       # 0x2
	.byte	4                       # 0x4
	.byte	6                       # 0x6
	.byte	8                       # 0x8
	.byte	10                      # 0xa
	.byte	12                      # 0xc
	.byte	14                      # 0xe
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
	.zero	1
.LCPI2_10:
	.short	1                       # 0x1
	.short	1                       # 0x1
	.short	1                       # 0x1
	.short	1                       # 0x1
	.short	1                       # 0x1
	.short	1                       # 0x1
	.short	1                       # 0x1
	.short	1                       # 0x1
	.text
	.globl	crypto_kem_dec
	.p2align	4, 0x90
	.type	crypto_kem_dec,@function
crypto_kem_dec:                         # @crypto_kem_dec
	.cfi_startproc
# %bb.0:
	pushq	%rbp
	.cfi_def_cfa_offset 16
	pushq	%r15
	.cfi_def_cfa_offset 24
	pushq	%r14
	.cfi_def_cfa_offset 32
	pushq	%r13
	.cfi_def_cfa_offset 40
	pushq	%r12
	.cfi_def_cfa_offset 48
	pushq	%rbx
	.cfi_def_cfa_offset 56
	subq	$14856, %rsp            # imm = 0x3A08
	.cfi_def_cfa_offset 14912
	.cfi_offset %rbx, -56
	.cfi_offset %r12, -48
	.cfi_offset %r13, -40
	.cfi_offset %r14, -32
	.cfi_offset %r15, -24
	.cfi_offset %rbp, -16
	movq	%rdx, %r15
	movq	%rsi, %r14
	movq	%rdi, 8(%rsp)           # 8-byte Spill
	leaq	11024(%rsp), %r12
	movq	%r12, %rdi
	movq	%rdx, %rsi
	callq	crypto_decode_761x3_ref@PLT
	leaq	191(%r15), %rsi
	leaq	8720(%rsp), %rdi
	callq	crypto_decode_761x3_ref@PLT
	leaq	11792(%rsp), %r13
	movq	%r13, %rdi
	movq	%r14, %rsi
	callq	crypto_decode_761x1531_avx@PLT
	leaq	5648(%rsp), %rbx
	movq	%rbx, %rdi
	movq	%r13, %rsi
	callq	crypto_encode_761xint16_little@PLT
	xorl	%ebp, %ebp
	leaq	4112(%rsp), %r13
	xorl	%ecx, %ecx
	movq	%r13, %rdi
	movq	%rbx, %rsi
	movq	%r12, %rdx
	callq	crypto_core_multsntrup761_avx@PLT
	leaq	9488(%rsp), %rdi
	movq	%r13, %rsi
	callq	crypto_decode_761xint16_little@PLT
	vpbroadcastd	.LCPI2_0(%rip), %ymm1 # ymm1 = [3,3,3,3,3,3,3,3]
	vpbroadcastd	.LCPI2_1(%rip), %ymm2 # ymm2 = [171,171,171,171,171,171,171,171]
	vpbroadcastd	.LCPI2_2(%rip), %ymm3 # ymm3 = [4294962705,4294962705,4294962705,4294962705,4294962705,4294962705,4294962705,4294962705]
	vpbroadcastd	.LCPI2_3(%rip), %ymm4 # ymm4 = [29235,29235,29235,29235,29235,29235,29235,29235]
	vpbroadcastd	.LCPI2_4(%rip), %ymm5 # ymm5 = [67108864,67108864,67108864,67108864,67108864,67108864,67108864,67108864]
	vmovdqa	.LCPI2_5(%rip), %ymm0   # ymm0 = [0,1,4,5,8,9,12,13,8,9,12,13,12,13,14,15,16,17,20,21,24,25,28,29,24,25,28,29,28,29,30,31]
	.p2align	4, 0x90
.LBB2_1:                                # =>This Inner Loop Header: Depth=1
	vpmovsxwd	9488(%rsp,%rbp,2), %ymm6
	vpmulld	%ymm1, %ymm6, %ymm7
	vpmulld	%ymm2, %ymm6, %ymm6
	vpsrad	$18, %ymm6, %ymm6
	vpmulld	%ymm3, %ymm6, %ymm6
	vpaddd	%ymm7, %ymm6, %ymm6
	vpmulld	%ymm4, %ymm6, %ymm7
	vpaddd	%ymm5, %ymm7, %ymm7
	vpsrad	$27, %ymm7, %ymm7
	vpmulld	%ymm3, %ymm7, %ymm7
	vpaddd	%ymm6, %ymm7, %ymm6
	vpshufb	%ymm0, %ymm6, %ymm6
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vmovdqa	%xmm6, 2576(%rsp,%rbp,2)
	addq	$8, %rbp
	cmpq	$760, %rbp              # imm = 0x2F8
	jne	.LBB2_1
# %bb.2:
	movswl	11008(%rsp), %eax
	leal	(%rax,%rax,2), %ecx
	imull	$171, %eax, %eax
	sarl	$18, %eax
	imull	$-4591, %eax, %eax      # imm = 0xEE11
	addl	%ecx, %eax
	imull	$29235, %eax, %ecx      # imm = 0x7233
	addl	$67108864, %ecx         # imm = 0x4000000
	sarl	$27, %ecx
	imull	$-4591, %ecx, %ecx      # imm = 0xEE11
	addl	%eax, %ecx
	movw	%cx, 4096(%rsp)
	leaq	382(%r15), %r12
	leaq	1731(%r15), %rax
	movq	%rax, (%rsp)            # 8-byte Spill
	vpbroadcastd	.LCPI2_6(%rip), %ymm1 # ymm1 = [10923,10923,10923,10923,10923,10923,10923,10923]
	vpbroadcastd	.LCPI2_7(%rip), %ymm2 # ymm2 = [16384,16384,16384,16384,16384,16384,16384,16384]
	movl	$24, %eax
	vpbroadcastd	.LCPI2_8(%rip), %ymm3 # ymm3 = [4294967293,4294967293,4294967293,4294967293,4294967293,4294967293,4294967293,4294967293]
	vmovdqa	.LCPI2_9(%rip), %xmm4   # xmm4 = <0,2,4,6,8,10,12,14,u,u,u,u,u,u,u,u>
	.p2align	4, 0x90
.LBB2_3:                                # =>This Inner Loop Header: Depth=1
	vpmovsxwd	2528(%rsp,%rax,2), %ymm5
	vpmovsxwd	2544(%rsp,%rax,2), %ymm6
	vpmovsxwd	2560(%rsp,%rax,2), %ymm7
	vpmovsxwd	2576(%rsp,%rax,2), %ymm8
	vpmulld	%ymm1, %ymm5, %ymm9
	vpmulld	%ymm1, %ymm6, %ymm10
	vpmulld	%ymm1, %ymm7, %ymm11
	vpmulld	%ymm1, %ymm8, %ymm12
	vpaddd	%ymm2, %ymm9, %ymm9
	vpaddd	%ymm2, %ymm10, %ymm10
	vpaddd	%ymm2, %ymm11, %ymm11
	vpaddd	%ymm2, %ymm12, %ymm12
	vpsrld	$15, %ymm9, %ymm9
	vpsrld	$15, %ymm10, %ymm10
	vpsrld	$15, %ymm11, %ymm11
	vpsrld	$15, %ymm12, %ymm12
	vpmulld	%ymm3, %ymm9, %ymm9
	vpmulld	%ymm3, %ymm10, %ymm10
	vpmulld	%ymm3, %ymm11, %ymm11
	vpmulld	%ymm3, %ymm12, %ymm12
	vpaddd	%ymm5, %ymm9, %ymm5
	vpaddd	%ymm6, %ymm10, %ymm6
	vpaddd	%ymm7, %ymm11, %ymm7
	vpaddd	%ymm8, %ymm12, %ymm8
	vpshufb	%ymm0, %ymm5, %ymm5
	vpermq	$232, %ymm5, %ymm5      # ymm5 = ymm5[0,2,2,3]
	vpshufb	%ymm0, %ymm6, %ymm6
	vpermq	$232, %ymm6, %ymm6      # ymm6 = ymm6[0,2,2,3]
	vpshufb	%ymm0, %ymm7, %ymm7
	vpermq	$232, %ymm7, %ymm7      # ymm7 = ymm7[0,2,2,3]
	vpshufb	%ymm0, %ymm8, %ymm8
	vpermq	$232, %ymm8, %ymm8      # ymm8 = ymm8[0,2,2,3]
	vpshufb	%xmm4, %xmm5, %xmm5
	vpshufb	%xmm4, %xmm6, %xmm6
	vpunpcklqdq	%xmm6, %xmm5, %xmm5 # xmm5 = xmm5[0],xmm6[0]
	vmovdqa	%xmm5, 1784(%rsp,%rax)
	vpshufb	%xmm4, %xmm7, %xmm5
	vpshufb	%xmm4, %xmm8, %xmm6
	vpunpcklqdq	%xmm6, %xmm5, %xmm5 # xmm5 = xmm5[0],xmm6[0]
	vmovdqa	%xmm5, 1800(%rsp,%rax)
	addq	$32, %rax
	cmpq	$760, %rax              # imm = 0x2F8
	jne	.LBB2_3
# %bb.4:
	movswl	4048(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2544(%rsp)
	movswl	4050(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2545(%rsp)
	movswl	4052(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2546(%rsp)
	movswl	4054(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2547(%rsp)
	movswl	4056(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2548(%rsp)
	movswl	4058(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2549(%rsp)
	movswl	4060(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2550(%rsp)
	movswl	4062(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2551(%rsp)
	movswl	4064(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2552(%rsp)
	movswl	4066(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2553(%rsp)
	movswl	4068(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2554(%rsp)
	movswl	4070(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2555(%rsp)
	movswl	4072(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2556(%rsp)
	movswl	4074(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2557(%rsp)
	movswl	4076(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2558(%rsp)
	movswl	4078(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2559(%rsp)
	movswl	4080(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2560(%rsp)
	movswl	4082(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2561(%rsp)
	movswl	4084(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2562(%rsp)
	movswl	4086(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2563(%rsp)
	movswl	4088(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2564(%rsp)
	movswl	4090(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2565(%rsp)
	movswl	4092(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2566(%rsp)
	movswl	4094(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2567(%rsp)
	movswl	4096(%rsp), %eax
	imull	$10923, %eax, %ecx      # imm = 0x2AAB
	addl	$16384, %ecx            # imm = 0x4000
	shrl	$15, %ecx
	leal	(%rcx,%rcx,2), %ecx
	subl	%ecx, %eax
	movb	%al, 2568(%rsp)
	leaq	16(%rsp), %rdi
	leaq	1808(%rsp), %rsi
	leaq	8720(%rsp), %rdx
	xorl	%ecx, %ecx
	vzeroupper
	callq	crypto_core_mult3sntrup761_avx@PLT
	vpxor	%xmm0, %xmm0, %xmm0
	movl	$24, %eax
	vmovdqa	.LCPI2_10(%rip), %xmm8  # xmm8 = [1,1,1,1,1,1,1,1]
	vpxor	%xmm2, %xmm2, %xmm2
	vpxor	%xmm3, %xmm3, %xmm3
	vpxor	%xmm4, %xmm4, %xmm4
	.p2align	4, 0x90
.LBB2_5:                                # =>This Inner Loop Header: Depth=1
	vpmovzxbw	-8(%rsp,%rax), %xmm5 # xmm5 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	(%rsp,%rax), %xmm6 # xmm6 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	8(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	16(%rsp,%rax), %xmm1 # xmm1 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpand	%xmm8, %xmm5, %xmm5
	vpackuswb	%xmm0, %xmm5, %xmm5
	vpand	%xmm8, %xmm6, %xmm6
	vpackuswb	%xmm0, %xmm6, %xmm6
	vpand	%xmm8, %xmm7, %xmm7
	vpackuswb	%xmm0, %xmm7, %xmm7
	vpand	%xmm8, %xmm1, %xmm1
	vpackuswb	%xmm0, %xmm1, %xmm1
	vpmovzxbd	%xmm5, %ymm5    # ymm5 = xmm5[0],zero,zero,zero,xmm5[1],zero,zero,zero,xmm5[2],zero,zero,zero,xmm5[3],zero,zero,zero,xmm5[4],zero,zero,zero,xmm5[5],zero,zero,zero,xmm5[6],zero,zero,zero,xmm5[7],zero,zero,zero
	vpaddd	%ymm5, %ymm0, %ymm0
	vpmovzxbd	%xmm6, %ymm5    # ymm5 = xmm6[0],zero,zero,zero,xmm6[1],zero,zero,zero,xmm6[2],zero,zero,zero,xmm6[3],zero,zero,zero,xmm6[4],zero,zero,zero,xmm6[5],zero,zero,zero,xmm6[6],zero,zero,zero,xmm6[7],zero,zero,zero
	vpaddd	%ymm5, %ymm2, %ymm2
	vpmovzxbd	%xmm7, %ymm5    # ymm5 = xmm7[0],zero,zero,zero,xmm7[1],zero,zero,zero,xmm7[2],zero,zero,zero,xmm7[3],zero,zero,zero,xmm7[4],zero,zero,zero,xmm7[5],zero,zero,zero,xmm7[6],zero,zero,zero,xmm7[7],zero,zero,zero
	vpaddd	%ymm5, %ymm3, %ymm3
	vpmovzxbd	%xmm1, %ymm1    # ymm1 = xmm1[0],zero,zero,zero,xmm1[1],zero,zero,zero,xmm1[2],zero,zero,zero,xmm1[3],zero,zero,zero,xmm1[4],zero,zero,zero,xmm1[5],zero,zero,zero,xmm1[6],zero,zero,zero,xmm1[7],zero,zero,zero
	vpaddd	%ymm1, %ymm4, %ymm4
	addq	$32, %rax
	cmpq	$760, %rax              # imm = 0x2F8
	jne	.LBB2_5
# %bb.6:
	vpaddd	%ymm0, %ymm2, %ymm0
	vpaddd	%ymm0, %ymm3, %ymm0
	vpaddd	%ymm0, %ymm4, %ymm0
	vextracti128	$1, %ymm0, %xmm1
	vpaddd	%ymm1, %ymm0, %ymm0
	vpshufd	$78, %xmm0, %xmm1       # xmm1 = xmm0[2,3,0,1]
	vpaddd	%ymm1, %ymm0, %ymm0
	vphaddd	%ymm0, %ymm0, %ymm0
	vmovd	%xmm0, %eax
	movzbl	752(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	753(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	754(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	755(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	756(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	757(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	758(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	759(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	760(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	761(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	762(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	763(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	764(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	765(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	766(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	767(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	768(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	769(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	770(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	771(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	772(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	773(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	774(%rsp), %ecx
	andl	$1, %ecx
	addl	%eax, %ecx
	movzbl	775(%rsp), %eax
	andl	$1, %eax
	addl	%ecx, %eax
	movzbl	776(%rsp), %ecx
	andl	$1, %ecx
	leal	(%rcx,%rax), %eax
	addl	$65250, %eax            # imm = 0xFEE2
	movzwl	%ax, %eax
	negl	%eax
	sarl	$31, %eax
	vmovd	%eax, %xmm0
	vpbroadcastb	%xmm0, %ymm0
	vmovdqu	16(%rsp), %ymm1
	vmovdqu	48(%rsp), %ymm2
	vmovdqu	80(%rsp), %ymm3
	vmovdqa	.LCPI2_11(%rip), %ymm4  # ymm4 = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]
	vpblendvb	%ymm0, %ymm4, %ymm1, %ymm1
	vpblendvb	%ymm0, %ymm4, %ymm2, %ymm2
	vpblendvb	%ymm0, %ymm4, %ymm3, %ymm3
	vmovdqu	112(%rsp), %ymm5
	vpblendvb	%ymm0, %ymm4, %ymm5, %ymm5
	vmovdqu	%ymm1, 1040(%rsp)
	vmovdqu	%ymm2, 1072(%rsp)
	vmovdqu	%ymm3, 1104(%rsp)
	vmovdqu	%ymm5, 1136(%rsp)
	vmovdqu	144(%rsp), %ymm1
	vmovdqu	176(%rsp), %ymm2
	vmovdqu	208(%rsp), %ymm3
	vpblendvb	%ymm0, %ymm4, %ymm1, %ymm1
	vpblendvb	%ymm0, %ymm4, %ymm2, %ymm2
	vpblendvb	%ymm0, %ymm4, %ymm3, %ymm3
	vmovdqu	240(%rsp), %ymm5
	vpblendvb	%ymm0, %ymm4, %ymm5, %ymm0
	vmovdqu	%ymm1, 1168(%rsp)
	vmovdqu	%ymm2, 1200(%rsp)
	vmovdqu	%ymm3, 1232(%rsp)
	vmovdqu	%ymm0, 1264(%rsp)
	movb	272(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1296(%rsp)
	movb	273(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1297(%rsp)
	movb	274(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1298(%rsp)
	movb	275(%rsp), %dl
	movb	276(%rsp), %sil
	movl	%edx, %ecx
	xorb	$1, %cl
	andb	%al, %cl
	xorb	%dl, %cl
	movb	%cl, 1299(%rsp)
	movl	%esi, %ecx
	xorb	$1, %cl
	andb	%al, %cl
	xorb	%sil, %cl
	movb	%cl, 1300(%rsp)
	movb	277(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1301(%rsp)
	movb	278(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1302(%rsp)
	movb	279(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1303(%rsp)
	movb	280(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1304(%rsp)
	movb	281(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1305(%rsp)
	movb	282(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1306(%rsp)
	movb	283(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1307(%rsp)
	movb	284(%rsp), %dl
	movb	285(%rsp), %sil
	movl	%edx, %ecx
	xorb	$1, %cl
	andb	%al, %cl
	xorb	%dl, %cl
	movb	%cl, 1308(%rsp)
	movl	%esi, %ecx
	xorb	$1, %cl
	andb	%al, %cl
	xorb	%sil, %cl
	movb	%cl, 1309(%rsp)
	movb	286(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1310(%rsp)
	movb	287(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1311(%rsp)
	movb	288(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1312(%rsp)
	movb	289(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1313(%rsp)
	movb	290(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1314(%rsp)
	movb	291(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1315(%rsp)
	movb	292(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1316(%rsp)
	movb	293(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1317(%rsp)
	movb	294(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1318(%rsp)
	movb	295(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1319(%rsp)
	movb	296(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1320(%rsp)
	movb	297(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1321(%rsp)
	movb	298(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1322(%rsp)
	movb	299(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1323(%rsp)
	movb	300(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	movb	%dl, 1324(%rsp)
	movb	301(%rsp), %cl
	movl	%ecx, %edx
	xorb	$1, %dl
	andb	%al, %dl
	xorb	%cl, %dl
	notb	%al
	vmovd	%eax, %xmm0
	vpbroadcastb	%xmm0, %ymm0
	vpand	302(%rsp), %ymm0, %ymm1
	vpand	334(%rsp), %ymm0, %ymm2
	vpand	366(%rsp), %ymm0, %ymm3
	movb	%dl, 1325(%rsp)
	vpand	398(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 1326(%rsp)
	vmovdqu	%ymm2, 1358(%rsp)
	vmovdqu	%ymm3, 1390(%rsp)
	vpand	430(%rsp), %ymm0, %ymm1
	vpand	462(%rsp), %ymm0, %ymm2
	vpand	494(%rsp), %ymm0, %ymm3
	vmovdqu	%ymm4, 1422(%rsp)
	vpand	526(%rsp), %ymm0, %ymm4
	vmovdqu	%ymm1, 1454(%rsp)
	vmovdqu	%ymm2, 1486(%rsp)
	vmovdqu	%ymm3, 1518(%rsp)
	vpand	558(%rsp), %ymm0, %ymm1
	vpand	590(%rsp), %ymm0, %ymm2
	vpand	622(%rsp), %ymm0, %ymm3
	vmovdqu	%ymm4, 1550(%rsp)
	vpand	654(%rsp), %ymm0, %ymm0
	vmovdqu	%ymm1, 1582(%rsp)
	vmovdqu	%ymm2, 1614(%rsp)
	vmovdqu	%ymm3, 1646(%rsp)
	vmovdqu	%ymm0, 1678(%rsp)
	xorl	%ecx, %ecx
	jmp	.LBB2_7
	.p2align	4, 0x90
.LBB2_13:                               #   in Loop: Header=BB2_7 Depth=1
	movzbl	689(%rsp,%rcx), %edx
	andb	%al, %dl
	movb	%dl, 1713(%rsp,%rcx)
	addq	$4, %rcx
.LBB2_7:                                # =>This Inner Loop Header: Depth=1
	movzbl	686(%rsp,%rcx), %edx
	andb	%al, %dl
	movb	%dl, 1710(%rsp,%rcx)
	movzbl	687(%rsp,%rcx), %edx
	andb	%al, %dl
	movb	%dl, 1711(%rsp,%rcx)
	movzbl	688(%rsp,%rcx), %edx
	andb	%al, %dl
	movb	%dl, 1712(%rsp,%rcx)
	cmpq	$88, %rcx
	jne	.LBB2_13
# %bb.8:
	leaq	785(%rsp), %rdi
	leaq	1040(%rsp), %rbx
	movq	%rbx, %rsi
	vzeroupper
	callq	crypto_encode_761x3_ref@PLT
	leaq	7184(%rsp), %rbp
	movq	%rbp, %rdi
	movq	%r12, %rsi
	callq	crypto_decode_761x4591_avx@PLT
	leaq	5648(%rsp), %r12
	movq	%r12, %rdi
	movq	%rbp, %rsi
	callq	crypto_encode_761xint16_little@PLT
	leaq	4112(%rsp), %r13
	xorl	%ecx, %ecx
	movq	%r13, %rdi
	movq	%r12, %rsi
	movq	%rbx, %rdx
	callq	crypto_core_multsntrup761_avx@PLT
	leaq	13328(%rsp), %rbp
	movq	%rbp, %rdi
	movq	%r13, %rsi
	callq	crypto_decode_761xint16_little@PLT
	leaq	4112(%rsp), %rdi
	movq	%rbp, %rsi
	callq	crypto_encode_761x1531round_ref@PLT
	movb	$3, 784(%rsp)
	leaq	976(%rsp), %rbp
	leaq	784(%rsp), %rsi
	movl	$192, %edx
	movq	%rbp, %rdi
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	976(%rsp), %ymm0
	vmovups	%ymm0, 5649(%rsp)
	movq	(%rsp), %rax            # 8-byte Reload
	vmovups	(%rax), %ymm0
	vmovups	%ymm0, 5681(%rsp)
	movb	$2, 5648(%rsp)
	leaq	5648(%rsp), %rsi
	movl	$65, %edx
	movq	%rbp, %rdi
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovdqu	976(%rsp), %ymm0
	vmovdqu	%ymm0, 5119(%rsp)
	vpxor	%xmm0, %xmm0, %xmm0
	movl	$24, %eax
	vpxor	%xmm1, %xmm1, %xmm1
	vpxor	%xmm2, %xmm2, %xmm2
	vpxor	%xmm3, %xmm3, %xmm3
	.p2align	4, 0x90
.LBB2_9:                                # =>This Inner Loop Header: Depth=1
	vpmovzxbw	-24(%r14,%rax), %xmm4 # xmm4 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	-16(%r14,%rax), %xmm5 # xmm5 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	-8(%r14,%rax), %xmm6 # xmm6 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	(%r14,%rax), %xmm8 # xmm8 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpmovzxbw	4088(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm4, %xmm7, %xmm4
	vpackuswb	%xmm0, %xmm4, %xmm4
	vpmovzxbw	4096(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm5, %xmm7, %xmm5
	vpackuswb	%xmm0, %xmm5, %xmm5
	vpmovzxbw	4104(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm6, %xmm7, %xmm6
	vpackuswb	%xmm0, %xmm6, %xmm6
	vpmovzxbw	4112(%rsp,%rax), %xmm7 # xmm7 = mem[0],zero,mem[1],zero,mem[2],zero,mem[3],zero,mem[4],zero,mem[5],zero,mem[6],zero,mem[7],zero
	vpxor	%xmm8, %xmm7, %xmm7
	vpackuswb	%xmm0, %xmm7, %xmm7
	vpmovzxbd	%xmm4, %ymm4    # ymm4 = xmm4[0],zero,zero,zero,xmm4[1],zero,zero,zero,xmm4[2],zero,zero,zero,xmm4[3],zero,zero,zero,xmm4[4],zero,zero,zero,xmm4[5],zero,zero,zero,xmm4[6],zero,zero,zero,xmm4[7],zero,zero,zero
	vpor	%ymm4, %ymm0, %ymm0
	vpmovzxbd	%xmm5, %ymm4    # ymm4 = xmm5[0],zero,zero,zero,xmm5[1],zero,zero,zero,xmm5[2],zero,zero,zero,xmm5[3],zero,zero,zero,xmm5[4],zero,zero,zero,xmm5[5],zero,zero,zero,xmm5[6],zero,zero,zero,xmm5[7],zero,zero,zero
	vpor	%ymm4, %ymm1, %ymm1
	vpmovzxbd	%xmm6, %ymm4    # ymm4 = xmm6[0],zero,zero,zero,xmm6[1],zero,zero,zero,xmm6[2],zero,zero,zero,xmm6[3],zero,zero,zero,xmm6[4],zero,zero,zero,xmm6[5],zero,zero,zero,xmm6[6],zero,zero,zero,xmm6[7],zero,zero,zero
	vpor	%ymm4, %ymm2, %ymm2
	vpmovzxbd	%xmm7, %ymm4    # ymm4 = xmm7[0],zero,zero,zero,xmm7[1],zero,zero,zero,xmm7[2],zero,zero,zero,xmm7[3],zero,zero,zero,xmm7[4],zero,zero,zero,xmm7[5],zero,zero,zero,xmm7[6],zero,zero,zero,xmm7[7],zero,zero,zero
	vpor	%ymm4, %ymm3, %ymm3
	addq	$32, %rax
	cmpq	$1048, %rax             # imm = 0x418
	jne	.LBB2_9
# %bb.10:
	vpor	%ymm0, %ymm1, %ymm0
	vpor	%ymm0, %ymm2, %ymm0
	vpor	%ymm0, %ymm3, %ymm0
	vextracti128	$1, %ymm0, %xmm1
	vpor	%ymm1, %ymm0, %ymm0
	vpshufd	$78, %xmm0, %xmm1       # xmm1 = xmm0[2,3,0,1]
	vpor	%ymm1, %ymm0, %ymm0
	vpshufd	$229, %xmm0, %xmm1      # xmm1 = xmm0[1,1,2,3]
	vpor	%ymm1, %ymm0, %ymm0
	movb	5136(%rsp), %al
	movb	5137(%rsp), %cl
	xorb	1024(%r14), %al
	xorb	1025(%r14), %cl
	movzbl	%al, %eax
	movzbl	%cl, %ecx
	orl	%eax, %ecx
	movb	5138(%rsp), %al
	xorb	1026(%r14), %al
	movzbl	%al, %eax
	orl	%ecx, %eax
	movb	5139(%rsp), %cl
	xorb	1027(%r14), %cl
	movzbl	%cl, %ecx
	orl	%eax, %ecx
	movb	5140(%rsp), %al
	xorb	1028(%r14), %al
	movzbl	%al, %eax
	movb	5141(%rsp), %dl
	xorb	1029(%r14), %dl
	orl	%ecx, %eax
	movzbl	%dl, %ecx
	orl	%eax, %ecx
	movb	5142(%rsp), %al
	xorb	1030(%r14), %al
	movzbl	%al, %eax
	orl	%ecx, %eax
	movb	5143(%rsp), %cl
	xorb	1031(%r14), %cl
	movzbl	%cl, %ecx
	orl	%eax, %ecx
	movb	5144(%rsp), %al
	xorb	1032(%r14), %al
	movzbl	%al, %eax
	movb	5145(%rsp), %dl
	xorb	1033(%r14), %dl
	orl	%ecx, %eax
	movzbl	%dl, %ecx
	orl	%eax, %ecx
	movb	5146(%rsp), %al
	xorb	1034(%r14), %al
	movzbl	%al, %eax
	orl	%ecx, %eax
	movb	5147(%rsp), %cl
	xorb	1035(%r14), %cl
	movzbl	%cl, %ecx
	orl	%eax, %ecx
	movb	5148(%rsp), %al
	xorb	1036(%r14), %al
	vmovd	%xmm0, %edx
	movzbl	%al, %eax
	orl	%ecx, %eax
	movb	5149(%rsp), %cl
	xorb	1037(%r14), %cl
	movzbl	%cl, %ecx
	orl	%eax, %ecx
	movb	5150(%rsp), %al
	xorb	1038(%r14), %al
	movzbl	%al, %ebp
	orl	%ecx, %ebp
	orl	%edx, %ebp
	addl	$-1, %ebp
	shrl	$8, %ebp
	andb	$1, %bpl
	movl	%ebp, %esi
	addb	$-1, %sil
	vmovd	%esi, %xmm0
	vpbroadcastb	%xmm0, %ymm0
	vmovdqu	785(%rsp), %ymm1
	vmovdqu	817(%rsp), %ymm2
	vpblendvb	%ymm0, 1540(%r15), %ymm1, %ymm1
	vmovdqu	849(%rsp), %ymm3
	vpblendvb	%ymm0, 1572(%r15), %ymm2, %ymm2
	vmovdqu	881(%rsp), %ymm4
	vpblendvb	%ymm0, 1604(%r15), %ymm3, %ymm3
	vpblendvb	%ymm0, 1636(%r15), %ymm4, %ymm0
	vmovdqu	%ymm1, 785(%rsp)
	vmovdqu	%ymm2, 817(%rsp)
	vmovdqu	%ymm3, 849(%rsp)
	vmovdqu	%ymm0, 881(%rsp)
	xorl	%ecx, %ecx
	.p2align	4, 0x90
.LBB2_11:                               # =>This Inner Loop Header: Depth=1
	movzbl	913(%rsp,%rcx), %edx
	movzbl	914(%rsp,%rcx), %ebx
	movzbl	1668(%r15,%rcx), %eax
	xorb	%dl, %al
	andb	%sil, %al
	xorb	%dl, %al
	movb	%al, 913(%rsp,%rcx)
	movzbl	1669(%r15,%rcx), %eax
	xorb	%bl, %al
	andb	%sil, %al
	xorb	%bl, %al
	movb	%al, 914(%rsp,%rcx)
	movzbl	915(%rsp,%rcx), %eax
	movzbl	1670(%r15,%rcx), %edx
	xorb	%al, %dl
	andb	%sil, %dl
	xorb	%al, %dl
	movb	%dl, 915(%rsp,%rcx)
	addq	$3, %rcx
	cmpq	$63, %rcx
	jne	.LBB2_11
# %bb.12:
	movb	$3, 784(%rsp)
	leaq	976(%rsp), %rbx
	leaq	784(%rsp), %rsi
	movl	$192, %edx
	movq	%rbx, %rdi
	vzeroupper
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	976(%rsp), %ymm0
	vmovups	%ymm0, 7185(%rsp)
	leaq	7217(%rsp), %rdi
	movl	$1039, %edx             # imm = 0x40F
	movq	%r14, %rsi
	vzeroupper
	callq	memcpy@PLT
	movb	%bpl, 7184(%rsp)
	leaq	7184(%rsp), %rsi
	movl	$1072, %edx             # imm = 0x430
	movq	%rbx, %rdi
	callq	crypto_hash_sha512_openssl@PLT
	vmovups	976(%rsp), %ymm0
	movq	8(%rsp), %rax           # 8-byte Reload
	vmovups	%ymm0, (%rax)
	xorl	%eax, %eax
	addq	$14856, %rsp            # imm = 0x3A08
	.cfi_def_cfa_offset 56
	popq	%rbx
	.cfi_def_cfa_offset 48
	popq	%r12
	.cfi_def_cfa_offset 40
	popq	%r13
	.cfi_def_cfa_offset 32
	popq	%r14
	.cfi_def_cfa_offset 24
	popq	%r15
	.cfi_def_cfa_offset 16
	popq	%rbp
	.cfi_def_cfa_offset 8
	vzeroupper
	retq
.Lfunc_end2:
	.size	crypto_kem_dec, .Lfunc_end2-crypto_kem_dec
	.cfi_endproc
                                        # -- End function

	.ident	"clang version 7.0.1-8 (tags/RELEASE_701/final)"
	.section	".note.GNU-stack","",@progbits
